/*********************************************************************/

#ifndef _clebsh_gordan_h_
#define _clebsh_gordan_h_

#include <gsl/gsl_sf_coupling.h>

//	< S_old, S_z_old; s, s_z | S_new, S_z_new >
//	spin = 1/2
double clebsch_gordan_spin_1_2(	int S_old, int S_z_old,
				int s_added, int s_z_added,
				int S_new, int S_z_new);

//	< S_old, S_z_old; s, s_z | S_new, S_z_new >
//	spin = 1
double clebsch_gordan_spin_1(	int S_old, int S_z_old,
				int s_added, int s_z_added,
				int S_new, int S_z_new);

//	< S_old, S_z_old; s, s_z | S_new, S_z_new >
//	spin = 0, 1/2, 1
double clebsch_gordan(  int S_old, int S_z_old,
			int s_added, int s_z_added,
			int S_new, int S_z_new);

double clebsch_gordan_charge( int Q_old, int q_add, int Q_new);

#endif// _clebsh_gordan_h_

/*********************************************************************/


