#if!defined (_dmnrg_h_)

#define _dmnrg_h_
#include <assert.h>
#include<fstream>
#include<iostream>
using namespace std;

#include "sector.h"
#include "symmetry.h"
#include "state.h"
#include "in_out.h"
#include "cut_off.h"
#include <iomanip>
#include "spectral_function.h"
#include "transformation.h"




extern char  swap_folder_name[400]; 
extern char  transformation_file_name[400]; 
extern ofstream transformation_file_out; 
extern ifstream transformation_file_in; 

extern char states_file_name[400]; 
extern ofstream states_file_out; 
extern ifstream states_file_in; 


extern char sectors_file_name[400];
extern ofstream sectors_file_out; 
extern ifstream sectors_file_in; 


extern char spectral_operator_file_name[400]; 
extern char static_operator_file_name[400];
extern ofstream spectral_operator_file_out; 
extern ifstream spectral_operator_file_in;

extern ofstream static_operator_file_out;
extern ifstream static_operator_file_in;

extern int double_precision; 
extern const int buffer_size;
extern char buffer[5000];
extern char word[5000];
extern int word_offset;
extern double degeneracy_threshhold;

void write_transformation_sectors(int m_star,
				  long iteration_index, 
				  int state_no,
				  int sector_no, 
				  sector_properties *sectors_properties_array,
				  sector * transformation_sectors
				  ); 


void write_transformation_sectors_binary(int m_star,

					 long iteration_index, 
					 
					 int state_no,
					 int sector_no, 
					 sector_properties *sectors_properties_array,
					 
					 sector * transformation_sectors
					 ); 



void write_states(int m_star,
		  long iteration_index, 
		  int new_block_state_no,
		  state *new_block_states_array,
		  double *new_block_energies_array,
		  int block_state_no, 
		  state *block_states_array, 
		  int *block_original_sectors_array, 
		  int *block_original_sectors_index_array
		  ); 


void write_sectors(int m_star,
		   long iteration_index, 
		   int new_block_state_no,
		   int new_block_sector_no,
		   sector_properties *new_block_sectors_properties_array,
		   int block_sector_no, 
		   sector_properties *block_sectors_properties_array
		   ); 


void write_spectral_operator(int m_star,
			     long iteration_index, 
			     int new_block_state_no,
			     int new_block_sector_no,
			     quantum_operator & spectral_operator
			     );


void write_spectral_operator_binary(int m_star,
				    long iteration_index, 
				    int new_block_state_no,
				    int new_block_sector_no,
				    quantum_operator & spectral_operator
				    );

void write_static_operator(int m_star,
			   long iteration_index, 
			   int new_block_state_no,
			   int new_block_sector_no,
			   quantum_operator & static_operator
			     );


void write_static_operator_binary(int m_star,
				  long iteration_index, 
				  int new_block_state_no,
				  int new_block_sector_no,
				  quantum_operator & static_operator
				    );



void write_m_star(int m_star,
		  char *m_star_file_name); 

void construct_density_matrix(int symmetry_no,
			      symmetry * symmetry_types,

			      int new_block_sector_no,
			      sector_properties * new_block_sectors_properties_array,

			      int new_block_state_no,
			      state * new_block_states_array,

			      double *new_block_energies_array,
			      double *sorted_new_block_energies_array,
			      unsigned long *new_block_energies_index,


			      quantum_operator & new_block_hamiltonian,
			      quantum_operator & new_block_density_matrix,
			      double temperature,
			      double partition_function
			      ); 

void read_m_star(int &m_star,
		 char *m_star_file_name);


void read_states(int m_star,
		 long iteration_index, 

		 int symmetry_no,

		 int & new_block_state_no,
		 state * & new_block_states_array,
		 double * & new_block_energies_array,
		 double * & sorted_new_block_energies_array,
		 unsigned long * & new_block_energies_index,

		 int &block_state_no, 
		 state * & block_states_array
		 ); 

void read_block_states(int m_star,
		       long iteration_index, 
		       
		       int symmetry_no,
		       
		       int &block_state_no, 
		       state * & block_states_array,
		       int * & block_original_sector_array, 
		       int * & block_original_sector_index_array
			 );

void read_new_block_states(int m_star,
			   long iteration_index, 
			   
			   int symmetry_no,
			   
			   int & new_block_state_no,
			   state * & new_block_states_array,
			   double * & new_block_energies_array,
			   double * & sorted_new_block_energies_array,
			   unsigned long * & new_block_energies_index
			   ); 



void read_transformation_sectors(int m_star,
				 long iteration_index, 
				 int new_block_state_no,
				 int new_block_sector_no, 
				 sector_properties *new_block_sectors_properties_array,
				 sector * & transformation_sectors
				 ); 
void read_transformation_sectors_binary(int m_star,
					long iteration_index, 
					int new_block_state_no,
					int new_block_sector_no, 
					sector_properties *new_block_sectors_properties_array,
					sector * & transformation_sectors
					); 


void read_spectral_operator(int m_star, 
			    int iteration_index, 
			    int new_block_state_no, 
			    int new_block_sector_no, 
			    sector_properties * new_block_sectors_properties_array, 
			    quantum_operator & new_block_spectral_operator); 

void read_spectral_operator_binary(int m_star, 
				   int iteration_index, 
				   int new_block_state_no, 
				   int new_block_sector_no, 
				   sector_properties * new_block_sectors_properties_array, 
				   quantum_operator & new_block_spectral_operator);


void read_static_operator(int m_star, 
			  int iteration_index, 
			  int new_block_state_no, 
			  int new_block_sector_no, 
			  sector_properties * new_block_sectors_properties_array, 
			  quantum_operator & new_block_static_operator); 

void read_static_operator_binary(int m_star, 
				 int iteration_index, 
				 int new_block_state_no, 
				 int new_block_sector_no, 
				 sector_properties * new_block_sectors_properties_array, 
				 quantum_operator & new_block_static_operator);


double get_discarded_partition_function(int iteration_index,
					int symmetry_no, 
					symmetry * symmetry_types, 
					
					int new_block_sector_no, 
					sector_properties * new_block_sectors_properties_array, 
					
					int new_block_state_no, 
					state *new_block_states_array, 
					
					double *new_block_energies_array,
					double *sorted_new_block_energies_array,
					unsigned long *new_block_energies_index,
					
					double temperature 
    ); 



void construct_reduced_density_matrix(int symmetry_no,
				      symmetry * symmetry_types,

				      int new_block_sector_no,
				      sector_properties * new_block_sectors_properties_array,
				      int new_block_state_no,				      
				      state * new_block_states_array,
				      

				      int block_sector_no,
				      sector_properties *block_sectors_properties_array,
				      int block_state_no,
				      state * block_states_array,

				      quantum_operator & new_block_density_matrix,
				      quantum_operator & block_density_matrix,

				      double temperature);


double calculate_trace(int sector_no,
		       sector_properties *sectors_properties_array,		       
		       quantum_operator & one_operator); 


void transfer_reduced_density_matrix(int iteration_index,
				     int symmetry_no,
				     symmetry * symmetry_types,

				     int block_sector_no,
				     sector_properties *block_sectors_properties_array,
				     int block_state_no,
				     state *  block_states_array,
				     
				     int * block_original_sector_array, 
				     int * block_original_sector_index_array,

				     
				     int new_block_sector_no,
				     sector_properties * new_block_sectors_properties_array,
				     int new_block_state_no,
				     state * new_block_states_array,

				     				     
				     double *new_block_energies_array,
				     double *sorted_new_block_energies_array,
				     unsigned long *new_block_energies_index,

				     
				     quantum_operator & block_density_matrix,				     
				     quantum_operator & new_block_density_matrix,
				     
				     double temperature,
				     double partition_function); 

#endif 
