#if!defined _real_axis_spectral_function_h_
#define  _real_axis_spectra_function_h_

#include<iostream>
using namespace std;

#include <fstream>
#include <stdlib.h>
#include<math.h>
#include<string.h>
#include <stdio.h>

#include "symmetry.h"
#include "state.h"
#include "clebsch_gordan.h"
#include "quantum_operator.h"
#include "in_out.h"
#include "transformation.h"
#include "hilbert_transform.h"




// calculating the coefficient, coming from the Clebsch-Gordan coefficients, 
//of the given matrixelement which is unifrom throughout one sector 

extern char working_folder_name[400];

extern char  swap_folder_name[400]; 

extern char  delta_peaks_positive_file_name[400]; 
extern ofstream delta_peaks_positive_file_out; 
extern ifstream delta_peaks_positive_file_in; 

extern char  delta_peaks_negative_file_name[400]; 
extern ofstream delta_peaks_negative_file_out; 
extern ifstream delta_peaks_negative_file_in; 


extern char delta_peaks_odd_file_name[400];
extern ofstream delta_peaks_odd_file_out; 
extern ifstream delta_peaks_odd_file_in; 


extern char delta_peaks_even_file_name[400]; 
extern ofstream delta_peaks_even_file_out;
extern ifstream delta_peaks_even_file_in; 

extern char delta_peaks_positive_dmnrg_file_name[400];
extern ofstream delta_peaks_positive_dmnrg_file_out; 
extern ifstream delta_peaks_positive_dmnrg_file_in;

extern char delta_peaks_negative_dmnrg_file_name[400]; 
extern ofstream delta_peaks_negative_dmnrg_file_out; 
extern ifstream delta_peaks_negative_dmnrg_file_in; 


extern char spectral_function_file_name[400]; 
extern ofstream spectral_function_file_out; 


extern int interval_no; 
extern double temperature; 

extern char delta_peaks_dmnrg_file_name[400]; 
extern ofstream delta_peaks_dmnrg_file_out;
extern ifstream delta_peaks_dmnrg_file_in; 

extern char green_function_file_name[400]; 
extern ofstream green_function_file_out;

extern double allowed_error; 

extern double *spectral_function_energies_array; 
extern double *spectral_function_array; 
extern int spectral_function_array_no; 

extern const int buffer_size;
extern char buffer[5000];
extern char word[5000];
extern int word_offset;

extern int broadening_grid_mesh; 
extern double broadening_energy_minim;
extern double broadening_energy_maxim;
extern double *broadening_energy_array; 


double log_gauss_distribution(double omega, 
			      double omega_discrete, 
			      double b, 
			      double temperature); 

double log_gauss_distribution_modified (double omega, 
					double omega_discrete,  
					double quantum_temperature, 
					double b);




void reweight_spectral_function_peaks(quantum_operator & spectral_operator_A,
				      quantum_operator & spectral_operator_B,
				      char * positive_negative_spectrum_switch,
				      char * odd_even_iteration_switch, 
				      char * method
				      );
  



void generate_broadening_mesh();


void generate_spectral_function_real_axis(quantum_operator & spectral_operator_A, 
					  quantum_operator & spectral_operator_B, 
					  double b, 
					  double temperature, 
					  double quantum_temperature, 
					  char * odd_even_iteration_switch,
					  char * broadening_method,
					  char * method);






void generate_spectral_function_real_axis_dmnrg_each_iteration(quantum_operator & spectral_operator_A, 
							       quantum_operator & spectral_operator_B, 
							       double b, 
							       double temperature, 
							       double quantum_temperature, 		    
  							       char * broadening_method
							       );

void generate_static_averages(quantum_operator & spectral_operator_A, 
			      quantum_operator & spectral_operator_B);


void generate_static_averages(quantum_operator & static_operator_A);






#endif // _real_axis_spectral_function_ 
