#if!defined (_symmetry_h_)

#define _symmetry_h_

#include<fstream>
#include<iostream>
using namespace std;
#include <stddef.h>
#include <stdlib.h>
#include "state.h"
#include <string.h>
static const int possible_symmetry_type_no = 6;
static const char * possible_symmetry_type[possible_symmetry_type_no] = {"U(1)","SU(2)","SU(3)","Z(2)","SL(2,C)","charge_SU(2)"};

class symmetry {
 protected:        
    int max_representation_index;
    int min_representation_index;
    char * name;
    int abelian_tag;  //zero for non-abelian symmetries and 1 for abelian ones.

 public:
    //constructors & destructors
    symmetry();
    ~symmetry();
    //member functions. 

    void activate(); 
    void clear(); 
    int get_max_representation_index();  
    int get_min_representation_index();
    void set_max_representation_index (int);
    void set_min_representation_index (int);
    void set_name (char * word);
    char * get_name();
    int trial_state_no();
    int get_abelian_tag();
    void set_abelian_tag(int tag);
    void set_abelian_tag();

    //friend functions.

    friend bool selection_rule(symmetry &, int, int , int );
    friend bool grand_selection_rule(int , symmetry *, llvector & , llvector &, llvector &);
};

/* selection rules: */
#endif
