#if!defined (_transformation_h_)

#define _transformation_h_

#include "sector.h"
#include "quantum_operator.h"
#include <math.h>
#include <assert.h>

extern double allowed_error; 

extern "C" void indexx(unsigned long, double *, unsigned long *); 
extern "C" void hpsort(unsigned long , double *); 

extern "C" void  dgemm_(char *transa, char *transb,
			int *m, int *n, int *k, double *alpha, double *a, int 
			*lda, double *b, int *ldb,
			double *beta, double *c, int *ldc );


void operator_transformation(int sector_no, 
			     quantum_operator & one_operator, 
			     sector * transformation_sectors); 


void generate_energy_index_table(int new_state_no, 
				 double* new_energies_array, 
				 unsigned long* new_energies_index); 

void generate_energy_index_table_mod(int new_state_no, 
				 double* new_energies_array, 
				 unsigned long* new_energies_index);
 
void sort_energies(int new_state_no, 
		   double * new_energies_array, 
		   double * sorted_new_energies_array); 

void check_orthogonality(int sector_no, sector * transformation_sectors); 

void substract_ground_state_energy(int sector_no, 
				   sector_properties *sectors_properties_array, 
				   quantum_operator & block_hamiltonian, 
				   double * energies_array,
				   double * sorted_energies_array);
  


#endif // _transformation_h_ 
