#if!defined (_variables_h_)

#define _variables_h_


#include "dmatrix.h"
#include "llvector.h"
#include "sector.h"
#include "state.h"
#include "state_list.h"
#include "symmetry.h"
#include "quantum_operator.h"


typedef char name[256];

name *couplings_name = NULL;

/***********************************************************************************************/
//                                   Overall variables
//
/***********************************************************************************************/
char model[256];//model name used
double lambda ; // the value of lambda, will be readed as an input parameter.
double sqrt_lambda; // the value of the square root of lambda 
int max_state_no;
int iteration_no;
int max_iteration_no;
int symmetry_no;
int block_state_no;
int coupling_no;
int local_coupling_no;
int operator_no;
int local_state_no;
int hopping_operator_no;
int spectral_operator_no; 
int static_operator_no;
int spectral_function_no; //this is the number of spectral functions that you want to compute
int self_energy_no; //number of how manu self-energy terms are computed. 
int *spectral_function_index[2]; //keep track of the spectral functions that has to be comuted.
int *self_energy_index[4]; 
int interval_no;
double degeneracy_threshhold;
double temperature; 
double bare_temperature; 
double * couplings = NULL;
double * couplings_rescaled = NULL;
double * local_couplings = NULL; 

symmetry * symmetry_types =NULL; // used for storing the symmetry types found in the parameter file 
int trial_state_no = 1; // After that the symmetries have been read from the parameter file 
                       // the number of trial_states (permitted by the parameters) are calculated
                       // The result is needed for the construction of the new_block_states. It is the first\
                       //  cut-off in the code. 

quantum_operator new_block_hamiltonian; 
quantum_operator  block_hamiltonian; 
quantum_operator *block_hamiltonian_terms=NULL; 

quantum_operator  local_hamiltonian; 
quantum_operator *local_hamiltonian_terms=NULL; 
quantum_operator *local_hopping_hamiltonians= NULL;

quantum_operator* new_block_spectral_operators = NULL;
quantum_operator* new_block_static_operators = NULL;
quantum_operator* new_block_hopping_operators = NULL;
quantum_operator* block_hopping_operators = NULL;
quantum_operator* block_spectral_operators = NULL; 
quantum_operator* block_static_operators = NULL;
quantum_operator* local_hopping_operators= NULL; 


state * new_block_states_array = NULL;
int new_block_state_no; 
int new_block_sector_no; 
sector_properties *new_block_sectors_properties_array = NULL; 

int local_sector_no;
state * local_states_array = NULL;
state * local_states_array_copy=NULL;
sector_properties *local_sectors_properties_array = NULL; 


int block_sector_no;


state * block_states_array = NULL; // at first it is used for storing the initial states 
state * block_states_array_copy = NULL; 
sector_properties *block_sectors_properties_array = NULL;

double * new_block_energies_array = NULL; // to store the eigenvalues of the Hamiltonian 
double *sorted_new_block_energies_array=NULL; //to store the sorted eigenvalues of the Hamiltonian. 
double *block_energies_array = NULL; 
double *sorted_block_energies_array = NULL; 


unsigned long * new_block_energies_index = NULL;
unsigned long * block_energies_index = NULL; 
sector * transformation_sectors = NULL;
                        //  and the largest possible distance between degenerate states 
ifstream read_file;
ofstream log_file; 


const int buffer_size= 5000;
char buffer[buffer_size];
char word[buffer_size];
int word_offset;

char working_folder_name[400]; 
char folder_name[400]; 
char swap_folder_name[400]; 
char delta_peaks_folder_name[400];
char spectral_functions_folder_name[400];
char transformations_folder_name[400];
char spectral_operators_folder_name[400];
char states_folder_name[400];
char sectors_folder_name[400]; 
char static_operators_folder_name[400]; 

// Density matrix variables

int local_degeneracy; 
int m_star (-1); //the first iteration at which the states are discarded. 

ofstream m_star_file_out;
ifstream m_star_file_in;
char m_star_file_name[400]; 

char transformation_file_name[400]; 
ofstream transformation_file_out; 
ifstream transformation_file_in; 


char states_file_name[400]; 
ofstream states_file_out; 
ifstream states_file_in; 

char sectors_file_name[400]; 
ofstream sectors_file_out; 
ifstream sectors_file_in; 

char spectral_operator_file_name[400];
char static_operator_file_name[400];
ofstream spectral_operator_file_out; 
ifstream spectral_operator_file_in; 

ofstream static_operator_file_out; 
ifstream static_operator_file_in; 


quantum_operator new_block_density_matrix; 
quantum_operator block_density_matrix; 


char delta_peaks_positive_file_name[400]; 
ofstream delta_peaks_positive_file_out;
ifstream delta_peaks_positive_file_in; 


char delta_peaks_negative_file_name[400];
ofstream delta_peaks_negative_file_out;
ifstream delta_peaks_negative_file_in; 


char delta_peaks_odd_file_name[400]; 
ofstream delta_peaks_odd_file_out; 
ifstream delta_peaks_odd_file_in; 


char delta_peaks_even_file_name[400]; 
ofstream delta_peaks_even_file_out; 
ifstream delta_peaks_even_file_in; 

char spectral_function_file_name[400]; 
ofstream spectral_function_file_out; 


char delta_peaks_positive_dmnrg_file_name[400]; 
ofstream delta_peaks_positive_dmnrg_file_out; 
ifstream delta_peaks_positive_dmnrg_file_in; 

char delta_peaks_negative_dmnrg_file_name[400]; 
ofstream delta_peaks_negative_dmnrg_file_out; 
ifstream delta_peaks_negative_dmnrg_file_in; 

char delta_peaks_dmnrg_file_name[400]; 
ofstream delta_peaks_dmnrg_file_out; 
ifstream delta_peaks_dmnrg_file_in; 



double partition_function; 
double rescaled_temperature;

double allowed_error = 1e-10; 
int double_precision = 20; 


char broadening_method[100]; 
double broadening_parameter; 
double broadening_energy_minim; 
double broadening_energy_maxim; 
int broadening_grid_mesh;
double quantum_temperature;
double *broadening_energy_array;  //array to keep all the energies where the broadening is done.



int  spectral_function_nrg_even;
int spectral_function_nrg_odd;
int spectral_function_dmnrg; 
int static_average_dmnrg; 
int green_function_dmnrg;
int green_function_nrg_even; 
int green_function_nrg_odd;
long green_function_grid_mesh; 



char log_file_name[400]; 


//variables used when an energy dependent density of states is considered.

char mapping_folder_name[400]; 
char dos_mapping_folder_name[400]; 
char density_of_states_file_name[400]; 

int dos_points_no_per_interval=10000; 
char gamma_file_name[400]; 
char zeta_file_name[400]; 

char on_site_energies_file_name[400]; 
char hopping_couplings_file_name[400]; 

char green_function_file_name[400]; 
ofstream green_function_file_out; 



double *spectral_function_energies_array; 
double *spectral_function_array; 
int spectral_function_array_no; 



int dmnrg_flag;
int text_swap_files_flag; 
int binary_swap_files_flag; 
int hoppings_on_site_energies_flag; 


double **hopping_couplings_array=NULL;
double **on_site_energies_array=NULL;
int self_consistancy_index = 0; 
double hybridization_potential;
//double **static_average_spectral_operators_array=NULL; 
double beta_tilde; //variable that is the beta exponent in the evaluation of the static averages in the NRG forward run only. 

void clear_all();

double *dos_energy_array; 
double **dos_hopping_operator_array; 
long dos_energy_no; 


int *block_original_sector_array; 
int *block_original_sector_index_array;


#endif





