//Last updata 2007/10/30

#include "../include/density_of_states.h"


double density_of_states_function(int hopping_operator_no,
				  int hopping_operator_index,
				  double energy){
  /**************************************************************************************
This routine generates the normalized density of states in terms of the band width D 
It is supposed that the band is between [-D  D] and D is set to 1. 
A density of states is generated for each hopping operator. 
 ***************************************************************************************/
  
    //here comes the code input from the user:
    //for each hopping operator a if loop is needed in order to generate density of states for all 
    //the operators. 

  double dos_value; 
  long index_minim;
  long index_maxim;
  long index_half; 

  assert(hopping_operator_index<hopping_operator_no); 
  assert(hopping_operator_index>=0); 

  /*
  if(hopping_operator_index==0){

      if (fabs(energy)<=1.0){
        return 0.5;//exp(-5.0*energy*energy);
      }
      else{
        return 0.0;
      }
    }//if

    if (hopping_operator_index==1){

      if (fabs(energy)<=1.0){
        return 0.5;// /(energy*energy);
      }
      else{
        return 0.0;
      }

    }//if

    return 0.0;
  */

  
  index_minim = 0; 
  index_maxim = dos_energy_no-1; 

  do{

    index_half = (long)((index_minim+ index_maxim)/2);


    if (energy == dos_energy_array[index_minim]){
      dos_value = dos_hopping_operator_array[hopping_operator_index][index_minim];
      break;
    }

    if(energy == dos_energy_array[index_maxim]){
      dos_value = dos_hopping_operator_array[hopping_operator_index][index_maxim]; 
    }//if


    if ((energy-dos_energy_array[index_minim])*(energy-dos_energy_array[index_maxim]) >0){
      error_message("error in routine density_of_states(), energy out of range");      
    }//if
    
    if ((energy-dos_energy_array[index_minim])*(energy-dos_energy_array[index_half]) <0){
      index_maxim = index_half;      
    }//if

    if ((energy-dos_energy_array[index_maxim])*(energy-dos_energy_array[index_half])<0){
      index_minim = index_half;
    }//if
    
    assert(index_minim<index_maxim); 

  }while(index_maxim - index_minim == 1);

  
  dos_value = dos_hopping_operator_array[hopping_operator_index][index_minim] +
    (energy - dos_energy_array[index_minim])/(dos_energy_array[index_maxim]-dos_energy_array[index_minim])*
    (dos_hopping_operator_array[hopping_operator_index][index_maxim]-dos_hopping_operator_array[hopping_operator_index][index_minim]);
  

  return dos_value; 

}//density_of_states

