/*************************************************************************
Last Update 2007/12/12 by Pascu Moca

Documentation update necessary. 

*************************************************************************/

#include "../include/green_function.h"


void generate_green_function_dmnrg_quadrature (double b,
					       quantum_operator & spectral_operator_A, 
					       quantum_operator & spectral_operator_B
					       ){

/*******************************************************************************
input variables:  3
    b                   -  broadening parameter used for the conversion of the delta peaks into log-gaussian/log_gaussian_modified  distributions.
    spectral_operator_A - the first spectral operator for which the spectral function is computed.
    spectral_operator_B - the second spectral operator for which the spectral function is computed. 


output variables: none

return: void

What it does:
     This 

How to call:
*******************************************************************************/

  int line_no ; 
  int energy_no; 
  int green_function_data_points_no; 
  int average_range; 

  double * energies_array; 
  double * spectral_function_array; 
  double * spectral_function_second_derivative_array; 

  double *green_function_re_array; 
  double *green_function_im_array; 


  ifstream spectral_function_file_in;
  ofstream green_function_file_out; 

  
  //first we read in the spectral_function data from the file. 

  spectral_function_dmnrg_swap_file_name(working_folder_name,
					b,
					spectral_function_file_name,
					spectral_operator_A, 
					spectral_operator_B
					);


  spectral_function_file_in.open(spectral_function_file_name, ios::in); 
  if (!spectral_function_file_in.good()){
    error_message("cannot open spectral_function_file_in"); 
  }//if


  line_no =0; 
  //first we get the number of lines in the file.
  while(!(spectral_function_file_in.eof())){
      spectral_function_file_in.getline(buffer, buffer_size, '\n');
      line_no++; 
  }//while
  line_no--;   

  energy_no = line_no; 
  spectral_function_file_in.close();
  spectral_function_file_in.clear();
  energies_array = new double [energy_no]; 
  spectral_function_array = new double [energy_no]; 
  spectral_function_second_derivative_array = new double [energy_no]; 

  
  green_function_re_array = new double [energy_no]; 
  green_function_im_array = new double [energy_no]; 


  spectral_function_file_in.open(spectral_function_file_name, ios::in); 
  
  if (!spectral_function_file_in.good()){
    error_message("cannot open spectral_function_file_in");
  }//if



  for (int energy_index =0; energy_index<energy_no; energy_index++){
    
    spectral_function_file_in.getline(buffer, buffer_size, '\n');
    word_offset = 0; 
      
    if(!(get_word(buffer, word, word_offset)))
      error_message("reading energies in the spectral_function_file_in");
      energies_array[energy_index]= atof(word);     

      if(!(get_word(buffer, word, word_offset)))
        error_message("reading spectral_functions in the spectral_function_file_in");
      spectral_function_array[energy_index] = atof(word);
      
  }//for energy_index


  spectral_function_file_in.close();
  spectral_function_file_in.clear();

  

  spline(energies_array-1,spectral_function_array-1,energy_no, 0.0, 0.0, spectral_function_second_derivative_array-1 ); 
  


  green_function_dmnrg_swap_file_name(working_folder_name,
				      b,
				      green_function_file_name,
				      spectral_operator_A, 
				      spectral_operator_B
				      );


  green_function_file_out.open(green_function_file_name, ios::out); 
  if (!green_function_file_out.good()){
    error_message("cannot open green_function_file_out"); 
  }//if


  green_function_file_out.precision(double_precision); 


  double *mu; 
  double *nu; 


  //we make the green_function_grid_mesh an even number first.
  if (ldiv(green_function_grid_mesh, 2).rem ==1) green_function_grid_mesh+=1; 

  mu = new double [green_function_grid_mesh+1]; 
  nu = new double [green_function_grid_mesh]; 

  /*
  for(int i=0; i<green_function_grid_mesh/2; i++){
    mu[i] = 0.5 - pow(0.5, i+1); 
  }
  for (int i =green_function_grid_mesh/2+1; i<=green_function_grid_mesh; i++){
    mu[i] = 0.5+ pow(0.5, green_function_grid_mesh-i+1); 
  }
  */

  
  for(int i=0; i<=green_function_grid_mesh; i++){
    mu[i] =((double)(i))/(green_function_grid_mesh); 
  }

  for(int i=0; i<green_function_grid_mesh; i++){
    nu[i]= 0.5*(mu[i]+mu[i+1]); 
  }




  for (int energy_index=1; energy_index<energy_no-1; energy_index++){

    double t, y; 
    double a, b; 
    double formal_derivative; 
    
    double alpha, beta; 
    double f_alpha, f_beta;
    double sum = 0; 

    green_function_re_array[energy_index] = 0.0;
    green_function_im_array[energy_index] = 0.0; 

    a = energies_array[0];
    t = energies_array[energy_index]; 
    b = energies_array[energy_no-1]; 
    

    splint(energies_array-1, spectral_function_array-1, spectral_function_second_derivative_array-1,energy_no, t, &y);  
    
    
    //first term in the sum; 
    green_function_re_array[energy_index] += 1.0/M_PI* y*log((b-t)/(t-a)); 

    
    for(int i =1; i<=green_function_grid_mesh - 1; i++){
      
      alpha = (1-nu[i])*t + nu[i]*b;
      beta = (1-nu[i])*t +nu[i]*a;

      splint(energies_array-1, spectral_function_array-1, spectral_function_second_derivative_array-1,energy_no, alpha, &f_alpha);  
      splint(energies_array-1, spectral_function_array-1, spectral_function_second_derivative_array-1,energy_no, beta, &f_beta);  
      
      formal_derivative = (f_alpha-f_beta)/(alpha-beta); 

      sum+= (mu[i+1]-mu[i])*formal_derivative;
      
    }//int i 
    sum*=(b-a); 

    green_function_re_array[energy_index] += 1.0/M_PI*sum; 
    

    green_function_file_out<<energies_array[energy_index]<<"\t";
    green_function_file_out<<-M_PI*green_function_re_array[energy_index]<<"\t";
    green_function_file_out<<-M_PI*spectral_function_array[energy_index]<<"\n";
    
    }//for energy_index
    
  

  green_function_file_out.close();
  green_function_file_out.clear();

  
  delete [] energies_array; 
  delete [] spectral_function_array; 
  delete [] spectral_function_second_derivative_array; 
  
  delete [] green_function_re_array;
  delete [] green_function_im_array; 

  delete [] mu; 
  delete [] nu; 
  

  return; 

}//generate_green_function_dmnrg_quadrature




void generate_green_function_nrg_even_quadrature (double b,
						  quantum_operator & spectral_operator_A, 
						  quantum_operator & spectral_operator_B
						  ){

/*******************************************************************************
input variables:  3
    b                   -  broadening parameter used for the conversion of the delta peaks into log-gaussian/log_gaussian_modified  distributions.
    spectral_operator_A - the first spectral operator for which the spectral function is computed.
    spectral_operator_B - the second spectral operator for which the spectral function is computed. 


output variables: none

return: void

What it does:
     This 

How to call:
*******************************************************************************/

  int line_no ; 
  int energy_no; 
  int green_function_data_points_no; 
  int average_range; 

  double * energies_array; 
  double * spectral_function_array; 
  double * spectral_function_second_derivative_array; 

  double *green_function_re_array; 
  double *green_function_im_array; 


  ifstream spectral_function_file_in;
  ofstream green_function_file_out; 

  
  //first we read in the spectral_function data from the file. 

  spectral_function_even_swap_file_name(working_folder_name,
					b,
					spectral_function_file_name,
					spectral_operator_A, 
					spectral_operator_B
					);


  spectral_function_file_in.open(spectral_function_file_name, ios::in); 
  if (!spectral_function_file_in.good()){
    error_message("cannot open spectral_function_file_in"); 
  }//if


  line_no =0; 
  //first we get the number of lines in the file.
  while(!(spectral_function_file_in.eof())){
      spectral_function_file_in.getline(buffer, buffer_size, '\n');
      line_no++; 
  }//while
  line_no--;   

  energy_no = line_no; 
  spectral_function_file_in.close();
  spectral_function_file_in.clear();
  energies_array = new double [energy_no]; 
  spectral_function_array = new double [energy_no]; 
  spectral_function_second_derivative_array = new double [energy_no]; 

  
  green_function_re_array = new double [energy_no]; 
  green_function_im_array = new double [energy_no]; 


  spectral_function_file_in.open(spectral_function_file_name, ios::in); 
  
  if (!spectral_function_file_in.good()){
    error_message("cannot open spectral_function_file_in");
  }//if



  for (int energy_index =0; energy_index<energy_no; energy_index++){
    
    spectral_function_file_in.getline(buffer, buffer_size, '\n');
    word_offset = 0; 
      
    if(!(get_word(buffer, word, word_offset)))
      error_message("reading energies in the spectral_function_file_in");
      energies_array[energy_index]= atof(word);     

      if(!(get_word(buffer, word, word_offset)))
        error_message("reading spectral_functions in the spectral_function_file_in");
      spectral_function_array[energy_index] = atof(word);
      
  }//for energy_index


  spectral_function_file_in.close();
  spectral_function_file_in.clear();

  

  spline(energies_array-1,spectral_function_array-1,energy_no, 0.0, 0.0, spectral_function_second_derivative_array-1 ); 
  


  green_function_even_swap_file_name(working_folder_name,
				      b,
				      green_function_file_name,
				      spectral_operator_A, 
				      spectral_operator_B
				      );


  green_function_file_out.open(green_function_file_name, ios::out); 
  if (!green_function_file_out.good()){
    error_message("cannot open green_function_file_out"); 
  }//if


  green_function_file_out.precision(double_precision); 


  double *mu; 
  double *nu; 


  //we make the green_function_grid_mesh an even number first.
  if (ldiv(green_function_grid_mesh, 2).rem ==1) green_function_grid_mesh+=1; 

  mu = new double [green_function_grid_mesh+1]; 
  nu = new double [green_function_grid_mesh]; 

  /*
  for(int i=0; i<green_function_grid_mesh/2; i++){
    mu[i] = 0.5 - pow(0.5, i+1); 
  }
  for (int i =green_function_grid_mesh/2+1; i<=green_function_grid_mesh; i++){
    mu[i] = 0.5+ pow(0.5, green_function_grid_mesh-i+1); 
  }
  */

  
  for(int i=0; i<=green_function_grid_mesh; i++){
    mu[i] =((double)(i))/(green_function_grid_mesh); 
  }

  for(int i=0; i<green_function_grid_mesh; i++){
    nu[i]= 0.5*(mu[i]+mu[i+1]); 
  }




  for (int energy_index=1; energy_index<energy_no-1; energy_index++){

    double t, y; 
    double a, b; 
    double formal_derivative; 
    
    double alpha, beta; 
    double f_alpha, f_beta;
    double sum = 0; 

    green_function_re_array[energy_index] = 0.0;
    green_function_im_array[energy_index] = 0.0; 

    a = energies_array[0];
    t = energies_array[energy_index]; 
    b = energies_array[energy_no-1]; 
    

    splint(energies_array-1, spectral_function_array-1, spectral_function_second_derivative_array-1,energy_no, t, &y);  
    
    
    //first term in the sum; 
    green_function_re_array[energy_index] += 1.0/M_PI* y*log((b-t)/(t-a)); 

    
    for(int i =1; i<=green_function_grid_mesh - 1; i++){
      
      alpha = (1-nu[i])*t + nu[i]*b;
      beta = (1-nu[i])*t +nu[i]*a;

      splint(energies_array-1, spectral_function_array-1, spectral_function_second_derivative_array-1,energy_no, alpha, &f_alpha);  
      splint(energies_array-1, spectral_function_array-1, spectral_function_second_derivative_array-1,energy_no, beta, &f_beta);  
      
      formal_derivative = (f_alpha-f_beta)/(alpha-beta); 

      sum+= (mu[i+1]-mu[i])*formal_derivative;
      
    }//int i 
    sum*=(b-a); 

    green_function_re_array[energy_index] += 1.0/M_PI*sum; 
    

    green_function_file_out<<energies_array[energy_index]<<"\t";
    green_function_file_out<<-M_PI*green_function_re_array[energy_index]<<"\t";
    green_function_file_out<<-M_PI*spectral_function_array[energy_index]<<"\n";
    
    }//for energy_index
    
  

  green_function_file_out.close();
  green_function_file_out.clear();

  
  delete [] energies_array; 
  delete [] spectral_function_array; 
  delete [] spectral_function_second_derivative_array; 
  
  delete [] green_function_re_array;
  delete [] green_function_im_array; 

  delete [] mu; 
  delete [] nu; 
  

  return; 

}//generate_green_function_nrg_even_quadrature











void generate_green_function_nrg_odd_quadrature (double b,
						  quantum_operator & spectral_operator_A, 
						  quantum_operator & spectral_operator_B
						  ){

/*******************************************************************************
input variables:  3
    b                   -  broadening parameter used for the conversion of the delta peaks into log-gaussian/log_gaussian_modified  distributions.
    spectral_operator_A - the first spectral operator for which the spectral function is computed.
    spectral_operator_B - the second spectral operator for which the spectral function is computed. 


output variables: none

return: void

What it does:
     This 

How to call:
*******************************************************************************/

  int line_no ; 
  int energy_no; 
  int green_function_data_points_no; 
  int average_range; 

  double * energies_array; 
  double * spectral_function_array; 
  double * spectral_function_second_derivative_array; 

  double *green_function_re_array; 
  double *green_function_im_array; 


  ifstream spectral_function_file_in;
  ofstream green_function_file_out; 

  
  //first we read in the spectral_function data from the file. 

  spectral_function_odd_swap_file_name(working_folder_name,
					b,
					spectral_function_file_name,
					spectral_operator_A, 
					spectral_operator_B
					);


  spectral_function_file_in.open(spectral_function_file_name, ios::in); 
  if (!spectral_function_file_in.good()){
    error_message("cannot open spectral_function_file_in"); 
  }//if


  line_no =0; 
  //first we get the number of lines in the file.
  while(!(spectral_function_file_in.eof())){
      spectral_function_file_in.getline(buffer, buffer_size, '\n');
      line_no++; 
  }//while
  line_no--;   

  energy_no = line_no; 
  spectral_function_file_in.close();
  spectral_function_file_in.clear();
  energies_array = new double [energy_no]; 
  spectral_function_array = new double [energy_no]; 
  spectral_function_second_derivative_array = new double [energy_no]; 

  
  green_function_re_array = new double [energy_no]; 
  green_function_im_array = new double [energy_no]; 


  spectral_function_file_in.open(spectral_function_file_name, ios::in); 
  
  if (!spectral_function_file_in.good()){
    error_message("cannot open spectral_function_file_in");
  }//if



  for (int energy_index =0; energy_index<energy_no; energy_index++){
    
    spectral_function_file_in.getline(buffer, buffer_size, '\n');
    word_offset = 0; 
      
    if(!(get_word(buffer, word, word_offset)))
      error_message("reading energies in the spectral_function_file_in");
      energies_array[energy_index]= atof(word);     

      if(!(get_word(buffer, word, word_offset)))
        error_message("reading spectral_functions in the spectral_function_file_in");
      spectral_function_array[energy_index] = atof(word);
      
  }//for energy_index


  spectral_function_file_in.close();
  spectral_function_file_in.clear();

  

  spline(energies_array-1,spectral_function_array-1,energy_no, 0.0, 0.0, spectral_function_second_derivative_array-1 ); 
  


  green_function_odd_swap_file_name(working_folder_name,
				      b,
				      green_function_file_name,
				      spectral_operator_A, 
				      spectral_operator_B
				      );


  green_function_file_out.open(green_function_file_name, ios::out); 
  if (!green_function_file_out.good()){
    error_message("cannot open green_function_file_out"); 
  }//if


  green_function_file_out.precision(double_precision); 


  double *mu; 
  double *nu; 


  //we make the green_function_grid_mesh an odd number first.
  if (ldiv(green_function_grid_mesh, 2).rem ==1) green_function_grid_mesh+=1; 

  mu = new double [green_function_grid_mesh+1]; 
  nu = new double [green_function_grid_mesh]; 

  /*
  for(int i=0; i<green_function_grid_mesh/2; i++){
    mu[i] = 0.5 - pow(0.5, i+1); 
  }
  for (int i =green_function_grid_mesh/2+1; i<=green_function_grid_mesh; i++){
    mu[i] = 0.5+ pow(0.5, green_function_grid_mesh-i+1); 
  }
  */

  
  for(int i=0; i<=green_function_grid_mesh; i++){
    mu[i] =((double)(i))/(green_function_grid_mesh); 
  }

  for(int i=0; i<green_function_grid_mesh; i++){
    nu[i]= 0.5*(mu[i]+mu[i+1]); 
  }




  for (int energy_index=1; energy_index<energy_no-1; energy_index++){

    double t, y; 
    double a, b; 
    double formal_derivative; 
    
    double alpha, beta; 
    double f_alpha, f_beta;
    double sum = 0; 

    green_function_re_array[energy_index] = 0.0;
    green_function_im_array[energy_index] = 0.0; 

    a = energies_array[0];
    t = energies_array[energy_index]; 
    b = energies_array[energy_no-1]; 
    

    splint(energies_array-1, spectral_function_array-1, spectral_function_second_derivative_array-1,energy_no, t, &y);  
    
    
    //first term in the sum; 
    green_function_re_array[energy_index] += 1.0/M_PI* y*log((b-t)/(t-a)); 

    
    for(int i =1; i<=green_function_grid_mesh - 1; i++){
      
      alpha = (1-nu[i])*t + nu[i]*b;
      beta = (1-nu[i])*t +nu[i]*a;

      splint(energies_array-1, spectral_function_array-1, spectral_function_second_derivative_array-1,energy_no, alpha, &f_alpha);  
      splint(energies_array-1, spectral_function_array-1, spectral_function_second_derivative_array-1,energy_no, beta, &f_beta);  
      
      formal_derivative = (f_alpha-f_beta)/(alpha-beta); 

      sum+= (mu[i+1]-mu[i])*formal_derivative;
      
    }//int i 
    sum*=(b-a); 

    green_function_re_array[energy_index] += 1.0/M_PI*sum; 
    

    green_function_file_out<<energies_array[energy_index]<<"\t";
    green_function_file_out<<-M_PI*green_function_re_array[energy_index]<<"\t";
    green_function_file_out<<-M_PI*spectral_function_array[energy_index]<<"\n";
    
    }//for energy_index
    
  

  green_function_file_out.close();
  green_function_file_out.clear();

  
  delete [] energies_array; 
  delete [] spectral_function_array; 
  delete [] spectral_function_second_derivative_array; 
  
  delete [] green_function_re_array;
  delete [] green_function_im_array; 

  delete [] mu; 
  delete [] nu; 
  

  return; 

}//generate_green_function_nrg_odd_quadrature

