/*******************************************************************************
Modified:

2007/11/21 Pascu Moca
2008/02/07 Pascu Moca 
2008/05/21 Pascu Moca

Documentation has to be updated.

*******************************************************************************/

#include "../include/in_out.h"

/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/


void copy_file( char *file_name_in, 
		char *file_name_out){


  ifstream file_in(file_name_in, ios::in); 
  ofstream file_out(file_name_out, ios::out);


  if(!file_in.good()){
    error_message("while trying to open file for reading");
  }//if
  if (!file_out.good()){
    error_message("while trying to open file for writing"); 
  }//

  char c; 

  while (!file_in.eof()){
    c= file_in.get();
    file_out.put(c);
  }//while

  file_in.close();
  file_in.clear();
  file_out.close();
  file_out.clear();

  return; 
}


void remove_density_of_states_files(){

  char file_name[400];
 
  for(int iteration_index=0; iteration_index<=iteration_no; iteration_index++){
    //first we remove the transformation files. 

    density_of_states_negative_mapping_file_name(dos_mapping_folder_name,
						 iteration_index,
						 0, 
						 file_name
						 ); 
  
    
    
    remove(file_name); 
  }//for iteration_index


  for(int iteration_index=0; iteration_index<=iteration_no; iteration_index++){
    //first we remove the transformation files. 

    density_of_states_positive_mapping_file_name(dos_mapping_folder_name,
						 iteration_index,
						 0, 
						 file_name
						 ); 
  
    
    
    remove(file_name); 
  }//for iteration_index


  gamma_negative_mapping_file_name(dos_mapping_folder_name,
				     self_consistancy_index, 
				     file_name
				     );

  remove(file_name); 

  zeta_negative_mapping_file_name(dos_mapping_folder_name,
				     self_consistancy_index, 
				     file_name
				     );

  remove(file_name);

  gamma_positive_mapping_file_name(dos_mapping_folder_name,
				   self_consistancy_index, 
				   file_name
				   );
  
  remove(file_name); 

  zeta_positive_mapping_file_name(dos_mapping_folder_name,
				  self_consistancy_index, 
				  file_name
				  );

  remove(file_name);




}//remove_density_of_states_files

void remove_binary_files(){

  char file_name[400];
 
  for(int iteration_index=0; iteration_index<=iteration_no; iteration_index++){
    //first we remove the transformation files. 
    
    transformation_binary_swap_file_name( transformations_folder_name, 
					  iteration_index,
					  file_name
					  );   
    
    remove(file_name); 
  }//for iteration_index


  for (int spectral_index = 0; spectral_index<spectral_operator_no; spectral_index++){
    for(int iteration_index=0; iteration_index<=iteration_no; iteration_index++){
      // we remove the binary spectral functions files. 
      

      spectral_operator_binary_swap_file_name(spectral_operators_folder_name,
					      iteration_index, 
					      file_name,
					      block_spectral_operators[spectral_index]
					      );   
      
      remove(file_name); 
    }//for iteration_index

  }//for spectral_index


  for (int static_index = 0; static_index<static_operator_no; static_index++){
    for(int iteration_index=0; iteration_index<=iteration_no; iteration_index++){
      // we remove the binary spectral functions files. 
      

      static_operator_binary_swap_file_name(static_operators_folder_name,
					    iteration_index, 
					    file_name,
					    block_static_operators[static_index]
					    );   
      
      remove(file_name); 
    }//for iteration_index

  }//for spectral_index




  return; 
}


void create_working_folder(char * model,
			   double lambda, 
			   int max_state_no,
			   int iteration_no,
			   double temperature,		   
			   int symmetry_no,
			   symmetry *symmetry_types,
			   int coupling_no, 
			   double *couplings,
			   char* name
			   ){

/*******************************************************************************
input variables:  nine
    model          - name of the model simulated
    lambda         - parameter used for the NRG iteration.  (readed from the 
                     input.dat file)
    max_state_no   - the number of maximul states used in the run.  (readed from 
                     the input.dat file)
    iteration_no   - the number of iterations for the NRG run  (readed from the 
                     input.dat file)
    temperature    - the temperature  (readed from the input.dat file)
    symmetry_no    - the number of symmetries in the input file.  (readed from 
                     the input.dat file)
    symmetry_types - array with the symmetries. 
    coupling_no    - the number of how many terms are in the Block_Hamiltonian.  
                     (readed from the input.dat file)


output variables: one
    name           - string with the name of the working folder

return: void

What it does:
    This routine creates the working folder for the present run. 
    The name of the folder contains the informations related to the 
    parameters of the present run. 

How to call:
    ???
*******************************************************************************/

  char string_one[254];
  char string_two[254];
  

  sprintf(string_one, "results//%s_lambda_%lf_max_states_%d_iter_%d_T_%lf_", model, lambda, max_state_no, iteration_no, bare_temperature); 
  
  sprintf(string_two, "symmetries_" );

  for (int i=0; i<symmetry_no; i++){
    strcat(string_two, symmetry_types[i].get_name()); 
  }//i
  
  strcat(string_one, string_two); 

 
   
  for(int i=0; i<coupling_no; i++){
    sprintf(string_two, "_%s_%lf",couplings_name[i], couplings[i]);
    strcat(string_one, string_two);
  }//i
  
  strcpy(name,string_one); 
  
  mkdir(name, 0777);   

  return; 
}//create_working_folder



/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/


void create_swap_folder(char *working_folder_name, 
			char * swap_folder_name){

/*******************************************************************************
input variables:  one
     working_folder_name - string that is the working folder name created before 
                           calling the create_working_folder_function. 

output variables: one
     swap_folder_name - the name of the swap folder. This is a folder 
                        called data inside the working folder. 

return: void

What it does:
     This routine creates a swap folder inside the working folder where the 
     temporary files are kept, such as the spectral functions, transformations, 
     states, sectors and delta peaks file during the NRG iteration. 

How to call:
     ???
*******************************************************************************/

  strcpy( swap_folder_name, working_folder_name); 
  strcat(swap_folder_name, "//data"); 
  mkdir(swap_folder_name, 0777); 
  
  return; 
}//create_swap_folder



/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/


void create_delta_peaks_folder(char *swap_folder_name, 
			       char * delta_peaks_folder_name){

/*******************************************************************************
input variables:  one
     swap_folder_name - string that is the working folder name created before 
                           calling the create_working_folder_function. 

output variables: one
     delta_peaks_folder_name - the name of the delta peaks folder. This is a folder 
                        called data inside the working folder. 

return: void

What it does:
     This routine creates a swap folder inside the working folder where the 
     temporary files are kept, such as the spectral functions, transformations, 
     states, sectors and delta peaks file during the NRG iteration. 

How to call:
     ???
*******************************************************************************/

  strcpy( delta_peaks_folder_name, swap_folder_name); 
  strcat(delta_peaks_folder_name, "//delta_peaks"); 
  mkdir(delta_peaks_folder_name, 0777); 
  
  return; 
}//create_delta_peaks_folder



/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/


void create_spectral_functions_folder(char *swap_folder_name, 
				      char * spectral_functions_folder_name){
  
/*******************************************************************************
input variables:  one
     swap_folder_name - string that is the working folder name created before 
                           calling the create_working_folder_function. 

output variables: one
     spectral_functions_folder_name - the name of the delta peaks folder. This is a folder 
                        called data inside the working folder. 

return: void

What it does:
     This routine creates a swap folder inside the working folder where the 
     temporary files are kept, such as the spectral functions, transformations, 
     states, sectors and delta peaks file during the NRG iteration. 

How to call:
     ???
*******************************************************************************/

  strcpy( spectral_functions_folder_name, swap_folder_name); 
  strcat(spectral_functions_folder_name, "//spectral_functions");  
  mkdir(spectral_functions_folder_name, 0777); 
  
  return; 
}//create_spectral_functions_folder


/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/


void create_transformations_folder(char *swap_folder_name, 
			       char * transformations_folder_name){

/*******************************************************************************
input variables:  one
     swap_folder_name - string that is the working folder name created before 
                           calling the create_working_folder_function. 

output variables: one
     transformations_folder_name - the name of the delta peaks folder. This is a folder 
                        called data inside the working folder. 

return: void

What it does:
     This routine creates a swap folder inside the working folder where the 
     temporary files are kept, such as the spectral functions, transformations, 
     states, sectors and delta peaks file during the NRG iteration. 

How to call:
     ???
*******************************************************************************/

  strcpy( transformations_folder_name, swap_folder_name); 
  strcat(transformations_folder_name, "//transformations"); 
  mkdir(transformations_folder_name, 0777); 
  
  return; 
}//create_transformations_folder



/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/





void create_states_folder(char *swap_folder_name, 
			       char * states_folder_name){

/*******************************************************************************
input variables:  one
     swap_folder_name - string that is the working folder name created before 
                           calling the create_working_folder_function. 

output variables: one
     states_folder_name - the name of the delta peaks folder. This is a folder 
                        called data inside the working folder. 

return: void

What it does:
     This routine creates a swap folder inside the working folder where the 
     temporary files are kept, such as the spectral functions, transformations, 
     states, sectors and delta peaks file during the NRG iteration. 

How to call:
     ???
*******************************************************************************/

  strcpy( states_folder_name, swap_folder_name); 
  strcat(states_folder_name, "//states"); 
  mkdir(states_folder_name, 0777); 
  
  return; 
}//create_states_folder



/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/


void create_spectral_operators_folder(char *swap_folder_name, 
			       char * spectral_operators_folder_name){

/*******************************************************************************
input variables:  one
     swap_folder_name - string that is the working folder name created before 
                           calling the create_working_folder_function. 

output variables: one
     spectral_operators_folder_name - the name of the delta peaks folder. This is a folder 
                        called data inside the working folder. 

return: void

What it does:
     This routine creates a swap folder inside the working folder where the 
     temporary files are kept, such as the spectral functions, transformations, 
     states, sectors and delta peaks file during the NRG iteration. 

How to call:
     ???
*******************************************************************************/

  strcpy( spectral_operators_folder_name, swap_folder_name); 
  strcat(spectral_operators_folder_name, "//spectral_operators"); 
  mkdir(spectral_operators_folder_name, 0777); 
  
  return; 
}//create_spectral_operators_folder


/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/



void create_static_operators_folder(char *swap_folder_name, 
				    char * static_operators_folder_name){

/*******************************************************************************
input variables:  one
     swap_folder_name - string that is the working folder name created before 
                           calling the create_working_folder_function. 

output variables: one
     static_operators_folder_name - the name of the delta peaks folder. This is a folder 
                        called data inside the working folder. 

return: void

What it does:
     This routine creates a swap folder inside the working folder where the 
     temporary files are kept, such as the spectral functions, transformations, 
     states, sectors and delta peaks file during the NRG iteration. 

How to call:
     ???
*******************************************************************************/

  strcpy( static_operators_folder_name, swap_folder_name); 
  strcat(static_operators_folder_name, "//static_operators"); 
  mkdir(static_operators_folder_name, 0777); 
  
  return; 
}//create_static_operators_folder

/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/

void create_sectors_folder(char *swap_folder_name, 
			       char * sectors_folder_name){

/*******************************************************************************
input variables:  one
     swap_folder_name - string that is the working folder name created before 
                           calling the create_working_folder_function. 

output variables: one
     sectors_folder_name - the name of the delta peaks folder. This is a folder 
                        called data inside the working folder. 

return: void

What it does:
     This routine creates a swap folder inside the working folder where the 
     temporary files are kept, such as the spectral functions, transformations, 
     states, sectors and delta peaks file during the NRG iteration. 

How to call:
     ???
*******************************************************************************/

  strcpy( sectors_folder_name, swap_folder_name); 
  strcat(sectors_folder_name, "//sectors"); 
  mkdir(sectors_folder_name, 0777); 
  
  return; 
}//create_sectors_folder




/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/




void create_mapping_folder(char *mapping_folder_name){

/*******************************************************************************
input variables:  one
     working_folder_name - string that is the working folder name created before 
                           calling the create_working_folder_function. 

output variables: one
     mapping_folder_name - the name of the mapping folder. This is a folder 
                           called data inside the working folder. 

return: void

What it does:
     This routine creates a mapping folder inside the working folder where the 
     temporary files such as the density of states and the hoppings 
     and the on-site energies are kept  during the NRG iteration. 

How to call:
     ??? 
*******************************************************************************/


  strcpy( mapping_folder_name, swap_folder_name); 
  strcat(mapping_folder_name, "//mapping"); 
  mkdir(mapping_folder_name, 0777); 
  

}//create_mapping_folder


void create_dos_mapping_folder(char *dos_mapping_folder_name){

/*******************************************************************************
input variables:  one
     working_folder_name - string that is the working folder name created before 
                           calling the create_working_folder_function. 

output variables: one
     mapping_folder_name - the name of the mapping folder. This is a folder 
                           called data inside the working folder. 

return: void

What it does:
     This routine creates a mapping folder inside the working folder where the 
     temporary files such as the density of states and the hoppings 
     and the on-site energies are kept  during the NRG iteration. 

How to call:
     ??? 
*******************************************************************************/


  strcpy( dos_mapping_folder_name, "dos_mapping"); 
 
}//create_mapping_folder


/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/

void delta_peaks_positive_swap_file_name(char *delta_peaks_folder_name,
					 int iteration_index,
					 char *delta_peaks_positive_file_name,
					 quantum_operator & spectral_operator_A,
					 quantum_operator & spectral_operator_B){

/*******************************************************************************
input variables:  four
     swap_folder_name    - the swap folder name where the data is saved. 
     iteration_index     - the current iteration number.
     spectral_operator_A - the first operator in the combination of the
                           two operator for which the spectral function is 
                           computed. 
     spectral_operator_B - the second operator in the combination of the
                           two operator for which the spectral function is 
                           computed. 

output variables: one
     delta_peaks_positive_file_name - the name of the file. 

return: bool

What it does:
     This routine generate a filename for the delta peaks for the positive 
     spectrum of the energy. 

How to call:
     ??? 
*******************************************************************************/
  
  char swap_string[254]; 

  strcpy(delta_peaks_positive_file_name, delta_peaks_folder_name); 
  sprintf(swap_string, "//delta_peaks_positive_"); 
  strcat(swap_string, spectral_operator_A.get_name()); 
  strcat(swap_string, "_"); 
  strcat(swap_string, spectral_operator_B.get_name());
  strcat(delta_peaks_positive_file_name, swap_string); 

  sprintf(swap_string, "_%d.dat", iteration_index);
  strcat(delta_peaks_positive_file_name, swap_string); 

  return; 
}//delta_peaks_positive_swap_file_name; 


/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/


void delta_peaks_negative_swap_file_name(char *delta_peaks_folder_name,
					 int iteration_index,
					 char *delta_peaks_negative_file_name,
					 quantum_operator & spectral_operator_A,
					 quantum_operator & spectral_operator_B){

/*******************************************************************************
input variables:  four
     swap_folder_name    - the swap folder name where the data is saved. 
     iteration_index     - the current iteration number.
     spectral_operator_A - the first operator in the combination of the
                           two operator for which the spectral function is 
                           computed. 
     spectral_operator_B - the second operator in the combination of the
                           two operator for which the spectral function is 
                           computed. 

output variables: one
     delta_peaks_positive_file_name - the name of the file. 

return: void

What it does:
     This routine generate a filename for the delta peaks for the negative 
     spectrum of the energy. 

How to call:
     ???
*******************************************************************************/
  
  char swap_string[254]; 

  strcpy(delta_peaks_negative_file_name, delta_peaks_folder_name); 
  sprintf(swap_string, "//delta_peaks_negative_"); 
  strcat(swap_string, spectral_operator_A.get_name()); 
  strcat(swap_string, "_"); 
  strcat(swap_string, spectral_operator_B.get_name());
  strcat(delta_peaks_negative_file_name, swap_string); 

  sprintf(swap_string, "_%d.dat", iteration_index);
  strcat(delta_peaks_negative_file_name, swap_string); 

  return; 
}//delta_peaks_negative_swap_file_name



/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/


void delta_peaks_odd_swap_file_name(char *delta_peaks_folder_name,
				    char *delta_peaks_odd_file_name,
				    quantum_operator & spectral_operator_A,
				    quantum_operator & spectral_operator_B){

/*******************************************************************************
input variables:  three
     swap_folder_name    - the swap folder name where the data is saved. 
     spectral_operator_A - the first operator in the combination of the
                           two operator for which the spectral function is 
                           computed. 
     spectral_operator_B - the second operator in the combination of the
                           two operator for which the spectral function is 
                           computed. 

output variables: one
     delta_peaks_odd_file_name - the name of the file. 

return: void

What it does:
     This routine generate a filename for the reweighted spectrum when the spectral 
     function is computed using the odd part for the energy spectrum. The odd means 
     that the iteration indices used for computed the spectral functions are 1,3,5....

How to call:
     ???
*******************************************************************************/
  
  char swap_string[254]; 

  strcpy(delta_peaks_odd_file_name, delta_peaks_folder_name); 
  sprintf(swap_string, "//delta_peaks_odd_"); 
  strcat(swap_string, spectral_operator_A.get_name()); 
  strcat(swap_string, "_"); 
  strcat(swap_string, spectral_operator_B.get_name());
  strcat(delta_peaks_odd_file_name, swap_string); 

  sprintf(swap_string, ".dat");
  strcat(delta_peaks_odd_file_name, swap_string); 

  return; 
}//delta_peaks_odd_swap_file_name


/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/


void delta_peaks_even_swap_file_name(char *delta_peaks_folder_name,
				    char *delta_peaks_even_file_name,
				    quantum_operator & spectral_operator_A,
				    quantum_operator & spectral_operator_B){

/*******************************************************************************
input variables:  three
     swap_folder_name    - the swap folder name where the data is saved. 
     spectral_operator_A - the first operator in the combination of the
                           two operator for which the spectral function is 
                           computed. 
     spectral_operator_B - the second operator in the combination of the
                           two operator for which the spectral function is 
                           computed. 

output variables: one
     delta_peaks_even_file_name - the name of the file. 

return: void

What it does:
     This routine generate a filename for the reweighted spectrum when the spectral 
     function is computed using the even part for the energy spectrum. The even part means 
     that the iteration indices used for computed the spectral functions are 0,2,4....

How to call:
     ???
*******************************************************************************/
  
  char swap_string[254]; 

  strcpy(delta_peaks_even_file_name, delta_peaks_folder_name); 
  sprintf(swap_string, "//delta_peaks_even_"); 
  strcat(swap_string, spectral_operator_A.get_name()); 
  strcat(swap_string, "_"); 
  strcat(swap_string, spectral_operator_B.get_name());
  strcat(delta_peaks_even_file_name, swap_string); 

  sprintf(swap_string, ".dat");
  strcat(delta_peaks_even_file_name, swap_string); 

  return; 
}//delta_peaks_even_swap_file_name


/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/


void delta_peaks_dmnrg_swap_file_name(char *delta_peaks_folder_name,
				    char *delta_peaks_dmnrg_file_name,
				    quantum_operator & spectral_operator_A,
				    quantum_operator & spectral_operator_B){

/*******************************************************************************
input variables:  three
     swap_folder_name    - the swap folder name where the data is saved. 
     spectral_operator_A - the first operator in the combination of the
                           two operator for which the spectral function is 
                           computed. 
     spectral_operator_B - the second operator in the combination of the
                           two operator for which the spectral function is 
                           computed. 


output variables: one
     delta_peaks_dmnrg_file_name - the name of the file. 

return: void

What it does:
     This routine generate a filename for the reweighted spectrum when the spectral 
     function is computed using the DMNRG calculation

How to call:
     ???
*******************************************************************************/
  
  char swap_string[254]; 

  strcpy(delta_peaks_dmnrg_file_name, delta_peaks_folder_name); 
  sprintf(swap_string, "//delta_peaks_dmnrg_"); 
  strcat(swap_string, spectral_operator_A.get_name()); 
  strcat(swap_string, "_"); 
  strcat(swap_string, spectral_operator_B.get_name());
  strcat(delta_peaks_dmnrg_file_name, swap_string); 

  sprintf(swap_string, ".dat");
  strcat(delta_peaks_dmnrg_file_name, swap_string); 

  return; 
}//delta_peaks_dmnrg_swap_file_name





/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/


void delta_peaks_dmnrg_swap_file_name(char *delta_peaks_folder_name,
				      int iteration_index,
				      char *delta_peaks_dmnrg_file_name,
				      quantum_operator & spectral_operator_A,
				      quantum_operator & spectral_operator_B){

/***************************************************************************
input variables:  four
     swap_folder_name    - the swap folder name where the data is saved. 
     iteration_index     - the current iteration number.
     spectral_operator_A - the first operator in the combination of the
                           two operator for which the spectral function is 
                           computed. 
     spectral_operator_B - the second operator in the combination of the
                           two operator for which the spectral function is 
                           computed. 

output variables: one
     delta_peaks_positive_dmnrg_file_name - the name of the file.

return: void

What it does:
     This routine generate a filename for the delta peaks for the positive spectrum of the energy
     in the DMNRG backward iteration. 

How to call:
     ???
*******************************************************************************/
  
  char swap_string[254]; 

  strcpy(delta_peaks_dmnrg_file_name, delta_peaks_folder_name); 
  sprintf(swap_string, "//delta_peaks_dmnrg_"); 
  strcat(swap_string, spectral_operator_A.get_name()); 
  strcat(swap_string, "_"); 
  strcat(swap_string, spectral_operator_B.get_name());
  strcat(delta_peaks_dmnrg_file_name, swap_string); 

  sprintf(swap_string, "_%d.dat", iteration_index);
  strcat(delta_peaks_dmnrg_file_name, swap_string); 


  return; 
}//delta_peaks_dmnrg_swap_file_name




/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/


void spectral_function_dmnrg_swap_file_name(char *spectral_functions_folder_name,
					    int iteration_index,
					    double broadening_parameter,
					    char *spectral_function_dmnrg_file_name,
					    quantum_operator & spectral_operator_A,
					    quantum_operator & spectral_operator_B){

/***************************************************************************
input variables:  four
     swap_folder_name    - the swap folder name where the data is saved. 
     iteration_index     - the current iteration number.
     spectral_operator_A - the first operator in the combination of the
                           two operator for which the spectral function is 
                           computed. 
     spectral_operator_B - the second operator in the combination of the
                           two operator for which the spectral function is 
                           computed. 

output variables: one
     delta_peaks_positive_dmnrg_file_name - the name of the file.

return: void

What it does:
     This routine generate a filename for the delta peaks for the positive spectrum of the energy
     in the DMNRG backward iteration. 

How to call:
     ???
*******************************************************************************/
  
  char swap_string[254]; 

  strcpy(spectral_function_dmnrg_file_name, spectral_functions_folder_name); 
  sprintf(swap_string, "//spectral_function_dmnrg_"); 
  strcat(swap_string, spectral_operator_A.get_name()); 
  strcat(swap_string, "_"); 
  strcat(swap_string, spectral_operator_B.get_name());
  strcat(spectral_function_dmnrg_file_name, swap_string); 
  sprintf(swap_string, "_b_%lf_%d.dat", broadening_parameter, iteration_index);
  strcat(spectral_function_dmnrg_file_name, swap_string); 


  return; 
}//spectral_function_dmnrg_swap_file_name




/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/


void delta_peaks_positive_dmnrg_swap_file_name(char *delta_peaks_folder_name,
					       int iteration_index,
					       char *delta_peaks_positive_dmnrg_file_name,
					       quantum_operator & spectral_operator_A,
					       quantum_operator & spectral_operator_B){

/***************************************************************************
input variables:  four
     swap_folder_name    - the swap folder name where the data is saved. 
     iteration_index     - the current iteration number.
     spectral_operator_A - the first operator in the combination of the
                           two operator for which the spectral function is 
                           computed. 
     spectral_operator_B - the second operator in the combination of the
                           two operator for which the spectral function is 
                           computed. 

output variables: one
     delta_peaks_positive_dmnrg_file_name - the name of the file.

return: void

What it does:
     This routine generate a filename for the delta peaks for the positive spectrum of the energy
     in the DMNRG backward iteration. 

How to call:
     ???
*******************************************************************************/
  
  char swap_string[254]; 

  strcpy(delta_peaks_positive_dmnrg_file_name, delta_peaks_folder_name); 
  sprintf(swap_string, "//delta_peaks_positive_dmnrg_"); 
  strcat(swap_string, spectral_operator_A.get_name()); 
  strcat(swap_string, "_"); 
  strcat(swap_string, spectral_operator_B.get_name());
  strcat(delta_peaks_positive_dmnrg_file_name, swap_string); 

  sprintf(swap_string, "_%d.dat", iteration_index);
  strcat(delta_peaks_positive_dmnrg_file_name, swap_string); 


  return; 
}//delta_peaks_positive_dmnrg_swap_file_name


/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/


void delta_peaks_negative_dmnrg_swap_file_name(char *delta_peaks_folder_name,
					       int iteration_index,
					       char *delta_peaks_negative_dmnrg_file_name,
					       quantum_operator & spectral_operator_A,
					       quantum_operator & spectral_operator_B){

/*******************************************************************************
input variables:  two
     swap_folder_name    - the swap folder name where the data is saved. 
     iteration_index     - the current iteration number.
     spectral_operator_A - the first operator in the combination of the
                           two operator for which the spectral function is computed. 
     spectral_operator_B - the second operator in the combination of the
                           two operator for which the spectral function is computed. 

output variables: one
     delta_peaks_negative_dmnrg_file_name - the name of the file. 

return: void

What it does:
      This routine generate a filename for the delta peaks for the negative spectrum  
      of the energy in the DMNRG backward iteration. 

How to call:
      ???
*******************************************************************************/
  
  char swap_string[254]; 

  strcpy(delta_peaks_negative_dmnrg_file_name, delta_peaks_folder_name); 
  sprintf(swap_string, "//delta_peaks_negative_dmnrg_"); 
  strcat(swap_string, spectral_operator_A.get_name()); 
  strcat(swap_string, "_"); 
  strcat(swap_string, spectral_operator_B.get_name());
  strcat(delta_peaks_negative_dmnrg_file_name, swap_string); 

  sprintf(swap_string, "_%d.dat", iteration_index);
  strcat(delta_peaks_negative_dmnrg_file_name, swap_string); 

  return; 
}//delta_peaks_negative_dmnrg_swap_file_name


/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/


void transformation_swap_file_name(char *transformations_folder_name, 
				   int iteration_index,
				   char *transformation_file_name
				   ){

/*******************************************************************************
input variables:  two
      swap_folder_name - the swap folder name where the data is saved. 
      iteration_index  - the current iteration number.

output variables: one
      transformation_file_name - the name of the file. 

return: void

What it does:
      This routine generate a filename for the transformation sectors in the course of 
      NRG iteration. 

How to call:
      ???
*******************************************************************************/

    char swap_string[254];
    
    strcpy(transformation_file_name, transformations_folder_name); 

    sprintf(swap_string, "//transformation_%d.dat", iteration_index); 
    strcat(transformation_file_name, swap_string); 

  return; 
}//transformation_swap_file_name;



/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/


void transformation_binary_swap_file_name(char *transformations_folder_name, 
					  int iteration_index,
					  char *transformation_file_name
					  ){

  /*******************************************************************************
input variables:  two
      swap_folder_name - the swap folder name where the data is saved. 
      iteration_index  - the current iteration number.

output variables: one
      transformation_file_name - the name of the file. 

return: void

What it does:
      This routine generate a filename for the transformation sectors in the course of 
      NRG iteration. 

How to call:
      ???
*******************************************************************************/

    char swap_string[254];
    
    strcpy(transformation_file_name, transformations_folder_name); 

    sprintf(swap_string, "//transformation_binary_%d.dat", iteration_index); 
    strcat(transformation_file_name, swap_string); 

  return; 
}//transformation_binary_swap_file_name;



/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/


void states_swap_file_name(char *states_folder_name, 
			   int iteration_index,
			   char *states_file_name
			   ){

/*******************************************************************************
input variables:  two
     swap_folder_name - the swap folder name where the data is saved. 
     iteration_index  - the current iteration number.

output variables: one
     states_file_name - the name of the file

return: void

What it does:
     This routine generate a filename for the states in the course of 
     NRG iteration. For each iteration a separate filename has to be generated. 

How to call:
     ???
*******************************************************************************/

  char swap_string[254];
    
  strcpy(states_file_name, states_folder_name); 

  sprintf(swap_string, "//states_%d.dat", iteration_index); 
  strcat(states_file_name, swap_string); 

  return; 
}//states_swap_file_name;



/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/


void sectors_swap_file_name(char *sectors_folder_name, 
			   int iteration_index,
			   char *sectors_file_name
			   ){

/*******************************************************************************
input variables:  two
     swap_folder_name - the swap folder name where the data is saved. 
     iteration_index  - the current iteration number.

output variables: one
     sectors_file_name - the name of the file

return: void

What it does:
    This routine generate a filename for the sectors in the course of 
    NRG iteration. For each iteration a separate filename has to be generated. 

How to call:
    ???
*******************************************************************************/

  char swap_string[254];
    
  strcpy(sectors_file_name, sectors_folder_name); 

  sprintf(swap_string, "//sectors_%d.dat", iteration_index); 
  strcat(sectors_file_name, swap_string); 

  return; 
}//sectors_swap_file_name;


/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/


void spectral_operator_swap_file_name(char *spectral_operators_folder_name,
				      int iteration_index, 
				      char *spectral_operator_file_name,
				      quantum_operator & spectral_operator){

/*******************************************************************************
input variables:  three
     swap_folder_name  - the swap folder name where the data is saved. 
     iteration_index   - the current iteration number.
     spectral_operator - the spectral operator for which the file is created

output variables: one
     spectral_operator_file_name - the name of the file

return: void

What it does:
     This routine generate a filename for the spectral function operators in the course of 
     NRG iteration. For each iteration a separate filename has to be generated. The name of the 
     file contains the name of the spectral function, so it has to be called separately for
     each spectral operator.

How to call:
*******************************************************************************/

  char swap_string[254]; 
  char swap_string_1[254];

  strcpy(spectral_operator_file_name, spectral_operators_folder_name); 
  sprintf(swap_string, "//spectral_operator_"); 
  strcat(swap_string, spectral_operator.get_name()); 
  sprintf(swap_string_1, "_%d.dat", iteration_index); 
  strcat(swap_string, swap_string_1); 
  strcat(spectral_operator_file_name, swap_string); 

  return; 
}//spectral_operator_swap_file_name

/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/



/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/


void static_operator_swap_file_name(char *static_operators_folder_name,
				      int iteration_index, 
				      char *static_operator_file_name,
				      quantum_operator & static_operator){

/*******************************************************************************
input variables:  three
     swap_folder_name  - the swap folder name where the data is saved. 
     iteration_index   - the current iteration number.
     static_operator - the static operator for which the file is created

output variables: one
     static_operator_file_name - the name of the file

return: void

What it does:
     This routine generate a filename for the static function operators in the course of 
     NRG iteration. For each iteration a separate filename has to be generated. The name of the 
     file contains the name of the static function, so it has to be called separately for
     each static operator.

How to call:
*******************************************************************************/

  char swap_string[254]; 
  char swap_string_1[254];

  strcpy(static_operator_file_name, static_operators_folder_name); 
  sprintf(swap_string, "//static_operator_"); 
  strcat(swap_string, static_operator.get_name()); 
  sprintf(swap_string_1, "_%d.dat", iteration_index); 
  strcat(swap_string, swap_string_1); 
  strcat(static_operator_file_name, swap_string); 

  return; 
}//static_operator_swap_file_name

/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/



/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/


void spectral_operator_binary_swap_file_name(char *spectral_operators_folder_name,
					     int iteration_index, 
					     char *spectral_operator_file_name,
					     quantum_operator & spectral_operator){
  
/*******************************************************************************
input variables:  three
     swap_folder_name  - the swap folder name where the data is saved. 
     iteration_index   - the current iteration number.
     spectral_operator - the spectral operator for which the file is created

output variables: one
     spectral_operator_file_name - the name of the file

return: void

What it does:
     This routine generate a filename for the spectral function operators in the course of 
     NRG iteration. For each iteration a separate filename has to be generated. The name of the 
     file contains the name of the spectral function, so it has to be called separately for
     each spectral operator.

How to call:
*******************************************************************************/

  char swap_string[254]; 
  char swap_string_1[254];

  strcpy(spectral_operator_file_name, spectral_operators_folder_name); 
  sprintf(swap_string, "//spectral_operator_binary_"); 
  strcat(swap_string, spectral_operator.get_name()); 
  sprintf(swap_string_1, "_%d.dat", iteration_index); 
  strcat(swap_string, swap_string_1); 
  strcat(spectral_operator_file_name, swap_string); 

  return; 
}//spectral_operator_binary_swap_file_name

/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/


/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/


void static_operator_binary_swap_file_name(char *static_operators_folder_name,
					     int iteration_index, 
					     char *static_operator_file_name,
					     quantum_operator & static_operator){
  
/*******************************************************************************
input variables:  three
     swap_folder_name  - the swap folder name where the data is saved. 
     iteration_index   - the current iteration number.
     static_operator - the static operator for which the file is created

output variables: one
     static_operator_file_name - the name of the file

return: void

What it does:
     This routine generate a filename for the static function operators in the course of 
     NRG iteration. For each iteration a separate filename has to be generated. The name of the 
     file contains the name of the static function, so it has to be called separately for
     each static operator.

How to call:
*******************************************************************************/

  char swap_string[254]; 
  char swap_string_1[254];

  strcpy(static_operator_file_name, static_operators_folder_name); 
  sprintf(swap_string, "//static_operator_binary_"); 
  strcat(swap_string, static_operator.get_name()); 
  sprintf(swap_string_1, "_%d.dat", iteration_index); 
  strcat(swap_string, swap_string_1); 
  strcat(static_operator_file_name, swap_string); 

  return; 
}//static_operator_binary_swap_file_name

/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/



void m_star_swap_file_name(char *swap_folder_name,
			   char *m_star_file_name){
/*******************************************************************************
input variables: ???

output variables:

return:

What it does:

How to call:
*******************************************************************************/

  char swap_string[254]; 

  strcpy(m_star_file_name, swap_folder_name); 
  sprintf(swap_string, "//m_star.dat"); 
  strcat(m_star_file_name, swap_string); 
  return; 
}//spectral_operator_swap_file_name


/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/

void log_swap_file_name(char *working_folder_name,
			char *log_file_name){

/*******************************************************************************
input variables: ???

output variables:

return:

What it does:

How to call:
*******************************************************************************/

  char swap_string[254]; 

  strcpy(log_file_name, working_folder_name); 
  sprintf(swap_string, "//log_file.dat"); 
  strcat(log_file_name, swap_string); 
  return; 
}//spectral_operator_swap_file_name




/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/

void input_swap_file_name(char *working_folder_name,
			char *input_file_name){

/*******************************************************************************
input variables: ???

output variables:

return:

What it does:

How to call:
*******************************************************************************/

  char swap_string[254]; 

  strcpy(input_file_name, working_folder_name); 
  sprintf(swap_string, "//input.dat"); 
  strcat(input_file_name, swap_string); 
  return; 
}//input_swap_file_name


/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/


void spectral_function_even_swap_file_name(char *working_folder_name,
					   double b,
					   char *spectral_function_file_name,
					   quantum_operator & spectral_operator_A, 
					   quantum_operator & spectral_operator_B
					   ){

/*******************************************************************************
input variables: ???

output variables:

return:

What it does:

How to call:
*******************************************************************************/


  char swap_string[254]; 

  strcpy(spectral_function_file_name, working_folder_name); 
  
  sprintf(swap_string, "//spectral_function_even_"); 
  strcat(swap_string, spectral_operator_A.get_name()); 
  strcat(swap_string, "_"); 
  strcat(swap_string, spectral_operator_B.get_name());
  strcat(swap_string, "_"); 
  strcat(spectral_function_file_name, swap_string); 
  
  sprintf(swap_string, "b_%lf.dat", b); 
  strcat(spectral_function_file_name, swap_string); 

  return; 
}//spectral_function_even_swap_file_name


/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/


void spectral_function_odd_swap_file_name(char *working_folder_name,
					  double b,
					  char *spectral_function_file_name,
					  quantum_operator & spectral_operator_A, 
					  quantum_operator & spectral_operator_B
					  ){

/*******************************************************************************
input variables: ???

output variables:

return:

What it does:

How to call:
*******************************************************************************/

  char swap_string[254]; 

  strcpy(spectral_function_file_name, working_folder_name); 
  
  sprintf(swap_string, "//spectral_function_odd_"); 
  strcat(swap_string, spectral_operator_A.get_name()); 
  strcat(swap_string, "_"); 
  strcat(swap_string, spectral_operator_B.get_name());
  strcat(swap_string, "_"); 
  strcat(spectral_function_file_name, swap_string); 
  
  sprintf(swap_string, "b_%lf.dat", b); 
  strcat(spectral_function_file_name, swap_string); 
  return; 
}//spectral_function_odd_swap_file_name


/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/


void static_average_spectral_operators_swap_file_name(char *static_operators_folder_name,
						      char *static_average_spectral_operators_file_name,
						      quantum_operator & spectral_operator_A, 
						      quantum_operator & spectral_operator_B
						      ){

/*******************************************************************************
input variables: ???

output variables:

return:

What it does:

How to call:
*******************************************************************************/

  char swap_string[254]; 

  strcpy(static_average_spectral_operators_file_name, static_operators_folder_name); 
  
  sprintf(swap_string, "//static_average_dmnrg_"); 
  strcat(swap_string, spectral_operator_A.get_name()); 
  strcat(swap_string, "_"); 
  strcat(swap_string, spectral_operator_B.get_name());
  strcat(swap_string, ".dat"); 
  strcat(static_average_spectral_operators_file_name, swap_string); 
  
  return; 
}//static_average_spectral_operators_file_name;



/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/


void static_average_static_operator_swap_file_name(char *static_operators_folder_name,
						   char *static_average_static_operators_file_name,
						   quantum_operator & spectral_operator_A
						   ){

/*******************************************************************************
input variables: ???

output variables:

return:

What it does:

How to call:
*******************************************************************************/

  char swap_string[254]; 

  strcpy(static_average_static_operators_file_name, static_operators_folder_name); 
  
  sprintf(swap_string, "//static_average_dmnrg_"); 
  strcat(swap_string, spectral_operator_A.get_name()); 
  strcat(swap_string, ".dat"); 
  strcat(static_average_static_operators_file_name, swap_string);  
  return; 
}//static_average_spectral_operators_file_name;


/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/


void static_average_spectral_operators_nrg_file_name(char *working_folder_name,
						     char *static_average_spectral_operators_file_name,
						     quantum_operator & spectral_operator_A, 
						     quantum_operator & spectral_operator_B
						      ){

/*******************************************************************************
input variables: ???

output variables:

return:

What it does:

How to call:
*******************************************************************************/

  char swap_string[254]; 

  strcpy(static_average_spectral_operators_file_name, working_folder_name); 
  
  sprintf(swap_string, "//static_average_nrg_"); 
  strcat(swap_string, spectral_operator_A.get_name()); 
  strcat(swap_string, "_"); 
  strcat(swap_string, spectral_operator_B.get_name());
  strcat(swap_string, ".dat"); 
  strcat(static_average_spectral_operators_file_name, swap_string); 
  
  return; 
}//static_average_spectral_operators_nrg_file_name;






/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/


void spectral_function_dmnrg_swap_file_name(char *working_folder_name,
					    double b,
					    char *spectral_function_file_name,
					    quantum_operator & spectral_operator_A, 
					    quantum_operator & spectral_operator_B
					   ){

/*******************************************************************************
input variables:  four

output variables: one

return: void

What it does:
    ???
How to call:
    ???
*******************************************************************************/



  char swap_string[254]; 

  strcpy(spectral_function_file_name, working_folder_name); 
  
  sprintf(swap_string, "//spectral_function_dmnrg_"); 
  strcat(swap_string, spectral_operator_A.get_name()); 
  strcat(swap_string, "_"); 
  strcat(swap_string, spectral_operator_B.get_name());
  strcat(swap_string, "_"); 
  strcat(spectral_function_file_name, swap_string); 
  
  sprintf(swap_string, "b_%lf.dat", b); 
  strcat(spectral_function_file_name, swap_string); 

  return; 
}//spectral_function_dmnrg_swap_file_name


/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/


void density_of_states_negative_mapping_file_name(char *dos_mapping_folder_name,
						  int iteration_index,
						  int self_consistancy_index, 
						  char *density_of_states_file_name
						  ){

/*******************************************************************************
input variables:  four
     dos_mapping_folder_name       - the dos_mapping folder name where the data is saved. 
     iteration_index           - index for the iteration 
     self_consistency_index    - the current iteration number.
     hopping_operator_operator - the spectral operator for which the file is 
                                 created.

output variables: one
     file_name - ???

return: void

What it does:
    This routine generate a filename for the density of states used to calculate  
    the on-site energies and hoppings for a given operator. 

How to call:
    ???
*******************************************************************************/

  char swap_string[254]; 
  char swap_string_1[254];

  strcpy(density_of_states_file_name, dos_mapping_folder_name); 
  sprintf(swap_string, "//density_of_states_negative_energies_"); 
  sprintf(swap_string_1, "iteration_%d_", iteration_index); 
  strcat(swap_string, swap_string_1); 
  sprintf(swap_string_1, "self_consistency_%d.dat", self_consistancy_index); 
  strcat(swap_string, swap_string_1); 
  strcat(density_of_states_file_name, swap_string); 

  return; 
}//density_of_states_positive_mapping_file_name


/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/


void density_of_states_positive_mapping_file_name(char *dos_mapping_folder_name,
						  int iteration_index,
						  int self_consistancy_index, 
						  char *density_of_states_file_name
						  ){

/*******************************************************************************
input variables:  four
     dos_mapping_folder_name       - the dos_mapping folder name where the data is saved. 
     iteration_index           - index for the iteration 
     self_consistency_index    - the current iteration number.
     hopping_operator_operator - the spectral operator for which the file is created

output variables: one
     file_name

return: void

What it does:
     This routine generate a filename for the density of states used to calculate the 
     on-site energies and hoppings for a given operator. 

How to call:
     ???
*******************************************************************************/

  char swap_string[254]; 
  char swap_string_1[254];

  strcpy(density_of_states_file_name, dos_mapping_folder_name); 
  sprintf(swap_string, "//density_of_states_positive_energies_"); 
  sprintf(swap_string_1, "iteration_%d_", iteration_index); 
  strcat(swap_string, swap_string_1); 
  sprintf(swap_string_1, "self_consistency_%d.dat", self_consistancy_index); 
  strcat(swap_string, swap_string_1); 
  strcat(density_of_states_file_name, swap_string); 

  return; 
}//density_of_states_positive_mapping_file_name


/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/


void gamma_positive_mapping_file_name(char *dos_mapping_folder_name,
				      int self_consistancy_index, 
				      char *gamma_file_name
				      ){

/*******************************************************************************
input variables:  three
     dos_mapping_folder_name       - the dos_mapping folder name where the data is saved. 
     self_consistency_index    - the current iteration number.
     hopping_operator_operator - the spectral operator for which the file is created

output variables: one
     file_name

return: void

What it does:
     This routine generate a filename for the gamma's as conputed from 
     the density of states. 

How to call:
     ???
*******************************************************************************/

  char swap_string[254]; 
  char swap_string_1[254];

  strcpy(gamma_file_name, dos_mapping_folder_name); 
  sprintf(swap_string, "//gamma_positive_energies_"); 
  sprintf(swap_string_1, "self_consistency_%d.dat", self_consistancy_index); 
  strcat(swap_string, swap_string_1); 
  strcat(gamma_file_name, swap_string); 

  return; 
}//gamma_positive_mapping_file_name


/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/


void gamma_negative_mapping_file_name(char *dos_mapping_folder_name,
				      int self_consistancy_index, 
				      char *gamma_file_name
				      ){

/*******************************************************************************
input variables:  three
     dos_mapping_folder_name       - the dos_mapping folder name where the data is saved. 
     self_consistency_index    - the current iteration number.
     hopping_operator_operator - the spectral operator for which the file is created

output variables: one
     file_name

return: bool

What it does:

How to call:
     This routine generate a filename for the gammas as conputed from 
     the density of states. 
*******************************************************************************/


  char swap_string[254]; 
  char swap_string_1[254];

  strcpy(gamma_file_name, dos_mapping_folder_name); 
  sprintf(swap_string, "//gamma_negative_energies_"); 
  sprintf(swap_string_1, "self_consistency_%d.dat", self_consistancy_index); 
  strcat(swap_string, swap_string_1); 
  strcat(gamma_file_name, swap_string); 

  return; 
}//gamma_negative_mapping_file_name


/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/


void zeta_negative_mapping_file_name(char *dos_mapping_folder_name,
				      int self_consistancy_index, 
				      char *zeta_file_name
				      ){

/*******************************************************************************
input variables:  three
     dos_mapping_folder_name       - the dos_mapping folder name where the data is saved. 
     self_consistency_index    - the current iteration number.
     hopping_operator_operator - the spectral operator for which the file is 
                                 created.

output variables: one
     file_name

return: void

What it does:
     This routine generate a filename for the zetas as conputed from 
     the density of states. 

How to call:
     ???
*******************************************************************************/

  char swap_string[254]; 
  char swap_string_1[254];

  strcpy(zeta_file_name, dos_mapping_folder_name); 
  sprintf(swap_string, "//zeta_negative_energies_"); 
  sprintf(swap_string_1, "self_consistency_%d.dat", self_consistancy_index); 
  strcat(swap_string, swap_string_1); 
  strcat(zeta_file_name, swap_string); 

  return; 
}//zeta_negative_mapping_file_name


/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/


void zeta_positive_mapping_file_name(char *dos_mapping_folder_name,
				      int self_consistancy_index, 
				      char *zeta_file_name
				      ){

/*******************************************************************************
input variables:  three
     dos_mapping_folder_name       - the dos_mapping folder name where the data is saved. 
     self_consistency_index    - the current iteration number.
     hopping_operator_operator - the spectral operator for which the file is 
                                 created.

output variables: one
     file_name - file name for the zetas.

return: void

What it does:
     This routine generate a filename for the zetas as conputed from 
     the density of states. 

How to call:
     ???
*******************************************************************************/

  char swap_string[254]; 
  char swap_string_1[254];

  strcpy(zeta_file_name, dos_mapping_folder_name); 
  sprintf(swap_string, "//zeta_positive_energies_"); 
  sprintf(swap_string_1, "self_consistency_%d.dat", self_consistancy_index); 
  strcat(swap_string, swap_string_1); 
  strcat(zeta_file_name, swap_string); 

  return; 
}//zeta_negative_mapping_file_name


/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/


void on_site_energies_mapping_file_name(char *dos_mapping_folder_name,
					int self_consistancy_index, 
					char *on_site_energies_file_name
				      ){

/*******************************************************************************
input variables:  three
      dos_mapping_folder_name       - the dos_mapping folder name where the data is saved. 
      self_consistency_index    - the current iteration number.
      hopping_operator_operator - the spectral operator for which the file is 
                                  created.

output variables: one
      file_name - file name for the on-site energy.

return: void

What it does:
      This routine generate a filename for the on-site energies that are computed 

How to call:
      ????
*******************************************************************************/

  char swap_string[254]; 
  char swap_string_1[254];

  strcpy(on_site_energies_file_name, dos_mapping_folder_name); 
  sprintf(swap_string, "//on_site_energies_"); 
  sprintf(swap_string_1, "self_consistency_%d.dat", self_consistancy_index); 
  strcat(swap_string, swap_string_1); 
  strcat(on_site_energies_file_name, swap_string); 

  return; 
}//on_site_energies_mapping_file_name


/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/


void hopping_couplings_mapping_file_name(char *dos_mapping_folder_name,
					 int self_consistancy_index, 
					 char *hopping_couplings_file_name
				      ){

/*******************************************************************************
input variables:  three
     dos_mapping_folder_name       - the dos_mapping folder name where the data is saved. 
     self_consistency_index    - the current iteration number.
     hopping_operator_operator - the spectral operator for which the file is 
                                 created

output variables: one
     file_name - file name for the hopping couplings

return: void

What it does:
     This routine generate a filename for the hopping_couplings that are computed 

How to call:
     ???
*******************************************************************************/

  char swap_string[254]; 
  char swap_string_1[254];

  strcpy(hopping_couplings_file_name, dos_mapping_folder_name); 
  sprintf(swap_string, "//hopping_couplings_"); 
  sprintf(swap_string_1, "self_consistency_%d.dat", self_consistancy_index); 
  strcat(swap_string, swap_string_1); 
  strcat(hopping_couplings_file_name, swap_string); 

  return; 
}//hopping_couplings_mapping_file_name


/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/


void error_message(const char * text){

/*******************************************************************************
input variables:  one
      text - the message that is printed before the program terminates.

output variables: none

return: void

What it does:
     This routine returns an error message and exits the program. 

How to call:
     void error_message(const char * text)
*******************************************************************************/

  cerr<<"\nError while "<< text <<".\nEXITING...\n" << endl;
  
  ofstream log_file("results//log_file.dat", ios::app);

  log_file<<"\nError while "<< text <<".\nEXITING...\n" << endl;
  
  log_file.close();
  log_file.clear();

  exit(-1);



}//error_message


/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/


bool get_word(char * string, char * word, int & word_offset){

/*******************************************************************************
input variables:  two
     string      - the string from which the word is get.
     word_offset - the offset from the begining of the string. 

output variables: one
     word - is a string represented the extracted word from the string. 

return: bool

What it does: 
     This routine gets one word from a string with a word_offset displacement from 
     the begining of the string. The blanks, tabs, return, = are neglected.

How to call:
     bool get_word(char * string, char * word, int & word_offset)
*******************************************************************************/
  if(!string[word_offset]){
    return false;    
  }//if

  char * p1(NULL), * p2(NULL);
  p1 = p2 = string + word_offset;

  //eat leading spaces
  for(int i = 0; i < (int)strlen(p1) && ((p1[0] == ' ') 
					 || (p1[0] == '\t') 
					 || (p1[0] == '\n') 
					 || (p1[0] == '=')
					 || (p1[0] == '{') 
					 || (p1[0] == '}')
					 || (p1[0] == ';')); i++)
    p1++;
  if((!p1[0]) 
     || (p1[0] == ' ') 
     || (p1[0] == '\t') 
     || (p1[0] == '\n') 
     || (p1[0] == '=')
     || (p1[0] == '{') 
     || (p1[0] == '}')
     || (p1[0] == ';'))
    return false;
  p2 = p1;
  while((p2[0] != ' ') 
	&& (p2[0] != '\t') 
	&& (p2[0] != '\n') 
	&& (p2[0]!= '=') 
	&& (p2[0]!= '{') 
	&& (p2[0]!= '}') 
	&& (p2[0]!= ';') 
	&& (p2[0])  )
    p2++;
  int len = int(p2 - p1);
  strncpy(word, p1, len);
  word[len] = '\0';
  for(int i = int(p2 - string); i < (int)strlen(string) && (((p2[0] == ' ') 
							     || (p2[0] == '\t') 
							     || (p2[0] == '\n') 
							     ||(p2[0]== '=') 
							     ||(p2[0]== '{')
							     ||(p2[0]== '}')
							     ||(p2[0]== ';')
							     )); i++)
    p2++;
  word_offset = int(p2 - string);
  p1 = p2 = NULL;
  return true;
}//get_word


/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/

void read_parameters_section(){


/*******************************************************************************
input variables:  none

output variables: none

return: void

What it does: 
     This routine reads the parameters section from the input file. The 
     parameters are those from the input.dat file in the main folder. 

How to call:     
     void read_parameters_section()
*******************************************************************************/

  fstream read_file("input.dat", ios::in); 
  fstream log_file("log_file", ios::out); 
 
  if( read_file == NULL ){
    printf("Error opening file 'input.dat'.\nError in routine read_parameters_section()\nExiting...");
    exit(0);
  }//if

  if( log_file == NULL ){
    printf("Error opening file 'log_file'.\nError in routine read_parameters_section()\nExiting");
    exit(0);
  }//if
  

  int begin_line_no=0;
  int end_line_no=0; 
  int line_no=0; 
  

  while(!read_file.eof()){

    line_no++; 
    read_file.getline(buffer, buffer_size, '\n');
    word_offset = 0; 
    if(get_word(buffer, word, word_offset)){
   
      if (strcmp(word, "<SECTION-PARAMETERS>")==0){
	begin_line_no = line_no;       
      }//if

    
      if (strcmp(word, "</SECTION-PARAMETERS>")==0){
	end_line_no = line_no;       
      }//if
      

    }//if get_word;     
  }//while eof; 

    read_file.close();
    read_file.clear();

    //cout<<begin_line_no<<endl;
    //cout<<end_line_no<<endl;


    read_file.open("input.dat", ios::in);
    if (!read_file.good()){
      printf("Error opening file 'input.dat'.\nError in routine read_parameters_section().\nExiting...");
      exit(0);
    }//if

    line_no = 0; 


    while(!read_file.eof()){
      line_no++; 
      read_file.getline(buffer, buffer_size, '\n');
      word_offset = 0; 


      if(get_word(buffer, word, word_offset)){

	if (word[0] == '#'){
	  continue; 
	}//if

	if ((begin_line_no<line_no)&&(line_no<end_line_no)){
	  
	  //here comes the list of parameters. 
	  
	  
	  if(strcmp(word, "model")==0){
	    if(!get_word(buffer, word, word_offset)){
	      error_message("reading model"); 
	    }//if
	    strcpy(model, word);
	  }//if


	  if(strcmp(word, "lambda")==0){
	    if(!get_word(buffer, word, word_offset)){
	      error_message("reading lambda"); 
	    }//if
	    lambda = atof(word); 	      	
	    sqrt_lambda = sqrt(lambda); 
	  }//if
	  
	  if(strcmp(word, "max_state_no")==0){
	    if(!get_word(buffer, word, word_offset)){
	      error_message("reading max_state_no"); 
	    }//if
	    max_state_no = atoi(word); 	      	
	  }//if
	  
	  if(strcmp(word, "iteration_no")==0){
	    if(!get_word(buffer, word, word_offset)){
	      error_message("reading iteration_no"); 
	    }//if
	    iteration_no = atoi(word); 	      	
	  }//if

	  
	  if(strcmp(word, "symmetry_no")==0){
	    if(!get_word(buffer, word, word_offset)){
	      error_message("reading symmetry_no"); 
	    }//if
	   symmetry_no = atoi(word); 	      	

	   //we create an array with the symmetries.


	  }//if
	  
	  if(strcmp(word, "coupling_no")==0){
	    if(!get_word(buffer, word, word_offset)){
	      error_message("reading coupling_no"); 
	    }//if
	   coupling_no = atoi(word); 	      	
	   
	  }//if

	  if(strcmp(word, "spectral_operator_no")==0){
	    if(!get_word(buffer, word, word_offset)){
	      error_message("reading spectral_operator_no"); 
	    }//if
	   spectral_operator_no = atoi(word); 	      	
	  }//if

	  if(strcmp(word, "static_operator_no")==0){
	    if(!get_word(buffer, word, word_offset)){
	      error_message("reading static_operator_no"); 
	    }//if
	   static_operator_no = atoi(word); 	      	
	  }//if


	  if(strcmp(word, "hopping_operator_no")==0){
	    if(!get_word(buffer, word, word_offset)){
	      error_message("reading hopping_operator_no"); 
	    }//if
	   hopping_operator_no = atoi(word); 	      	
	  }//if

	  if(strcmp(word, "block_state_no")==0){
	    if(!get_word(buffer, word, word_offset)){
	      error_message("reading block_stat_no"); 
	    }//if
	   block_state_no = atoi(word); 	      	
	   

	  }//if

	  if(strcmp(word, "local_state_no")==0){
	    if(!get_word(buffer, word, word_offset)){
	      error_message("reading local_state_no"); 
	    }//if
	   local_state_no = atoi(word); 	      	

	  }//if
	  
	  if(strcmp(word, "local_coupling_no")==0){
	    if(!get_word(buffer, word, word_offset)){
	      error_message("reading coupling_no"); 
	    }//if
	   local_coupling_no = atoi(word); 	      	
	  }//if

	  if(strcmp(word, "spectral_function_no")==0){
	    if(!get_word(buffer, word, word_offset)){
	      error_message("reading spectral_function_no"); 
	    }//if
	    spectral_function_no= atoi(word); 	      	

	  }//if
	 

	  if(strcmp(word, "temperature")==0){
	    if(!get_word(buffer, word, word_offset)){
	      error_message("reading temperature"); 
	    }//if
	    bare_temperature = atof(word); 	
	    
	    if (bare_temperature==0){
	      temperature=0.0;
	    }//if

	    if (bare_temperature<0){
	      error_message("negative temperature in the input.dat file");
	    }//if

	    if (bare_temperature>0){
		temperature = bare_temperature*2.0/(1.0+1.0/lambda)/sqrt(lambda);/* ??????????????  */	      
	      max_iteration_no = (int)(5- 2.0*log((bare_temperature)/(1.0+1.0/lambda))/log(lambda));
	    }//if

	    if (temperature<0){
	      error_message("negative rescaled temperature ");
	    }///if


	    if ((temperature>0) && (max_iteration_no > iteration_no)){
	      printf("Increase the iteration_no to at least %d\n",max_iteration_no+5);
	      error_message ("iteration_no to small");
	    }//if 

	    if ( (temperature>0) &&(max_iteration_no< iteration_no)){
	      iteration_no = max_iteration_no;
	    }//if

	  }//if	  

	  if(strcmp(word, "interval_no")==0){
	    if(!get_word(buffer, word, word_offset)){
	      error_message("reading interval_no"); 
	    }//if
	    interval_no = atoi(word); 	     

	  }//if 

	  if(strcmp(word, "degeneracy_threshhold")==0){
	    if(!get_word(buffer, word, word_offset)){
	      error_message("reading degenaracy_threshhold"); 
	    }//if
	    degeneracy_threshhold= atof(word); 	     

	    
	  }//if


	}//if parameters_line
      }//if get_word; 
    }//while(read_file.eof)
    
    read_file.close(); 
    read_file.clear();
    log_file.close();
    log_file.clear();
}//read_parameters_section

/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/

void read_flags_section(){


/*******************************************************************************
input variables:  none

output variables: none

return: void

What it does: 
     This routine reads the parameters section from the input file. The 
     parameters are those from the input.dat file in the main folder. 

How to call:     
     void read_parameters_section()
*******************************************************************************/

  fstream read_file("input.dat", ios::in); 
  fstream log_file("log_file", ios::out); 
 
  if( read_file == NULL ){
    printf("Error opening file 'input.dat'.\nError in routine read_flags_section()\nExiting...");
    exit(0);
  }//if

  if( log_file == NULL ){
    printf("Error opening file 'log_file'.\nError in routine read_flags_section()\nExiting");
    exit(0);
  }//if
  

  int begin_line_no=0;
  int end_line_no=0; 
  int line_no=0; 
  

  while(!read_file.eof()){

    line_no++; 
    read_file.getline(buffer, buffer_size, '\n');
    word_offset = 0; 
    if(get_word(buffer, word, word_offset)){
   
      if (strcmp(word, "<SECTION-FLAGS>")==0){
	begin_line_no = line_no;       
      }//if

    
      if (strcmp(word, "</SECTION-FLAGS>")==0){
	end_line_no = line_no;       
      }//if
      

    }//if get_word;     
  }//while eof; 

    read_file.close();
    read_file.clear();

    //cout<<begin_line_no<<endl;
    //cout<<end_line_no<<endl;


    read_file.open("input.dat", ios::in);
    if (!read_file.good()){
      printf("Error opening file 'input.dat'.\nError in routine read_flags_section().\nExiting...");
      exit(0);
    }//if

    line_no = 0; 


    while(!read_file.eof()){
      line_no++; 
      read_file.getline(buffer, buffer_size, '\n');
      word_offset = 0; 


      if(get_word(buffer, word, word_offset)){

	if (word[0] == '#'){
	  continue; 
	}//if

	if ((begin_line_no<line_no)&&(line_no<end_line_no)){
	  

	  if(strcmp(word, "dmnrg_flag")==0){
	    if(!get_word(buffer, word, word_offset)){
	      error_message("reading dmnrg_flag"); 
	    }
	    if (strcmp(word, "ON")==0){
	      dmnrg_flag=1; 
	    }
	    else{
	      dmnrg_flag=0; 
	    }	    	   
	  }//if
	  
	  if(strcmp(word, "text_swap_files_flag")==0){
	    if(!get_word(buffer, word, word_offset)){
	      error_message("reading text_swap_files_flag"); 
	    }
	    if (strcmp(word, "ON")==0){
	      text_swap_files_flag=1; 
	    }
	    else{
	      text_swap_files_flag=0; 
	    }	    	   
	  }//if

	  if(strcmp(word, "binary_swap_files_flag")==0){
	    if(!get_word(buffer, word, word_offset)){
	      error_message("reading binary_swap_files_flag"); 
	    }
	    if (strcmp(word, "ON")==0){
	      binary_swap_files_flag=1; 
	    }
	    else{
	      binary_swap_files_flag=0; 
	    }	    	   
	  }//if


	  if(strcmp(word, "hoppings_on_site_energies_flag")==0){
	    if(!get_word(buffer, word, word_offset)){
	      error_message("reading hoppings_on_site_energies_flag"); 
	    }
	    if (strcmp(word, "ON")==0){
	      hoppings_on_site_energies_flag=1; 
	    }
	    else{
	      hoppings_on_site_energies_flag=0; 
	    }	    	   
	  }//if
	  


	}//if parameters_line
      }//if get_word; 
    }//while(read_file.eof)
    
    read_file.close(); 
    read_file.clear();
    log_file.close();
    log_file.clear();
}//read_flags_section
















/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/


void read_symmetries_section(){

/*******************************************************************************
input variables:  none

output variables: none

return: void

What it does: 
     This routine reads the symmetries of the problem from the input file. 

How to call:
     void read_symmetries_section()
********************************************************************************/

  if (symmetry_types){
    for(int symmetry_index = 0; symmetry_index<symmetry_no; symmetry_index++){
      symmetry_types[symmetry_index].clear();
    }//for       
    delete [] symmetry_types;
  }//if
  
  symmetry_types = NULL;
     
  symmetry_types = new symmetry[symmetry_no]; 



  fstream read_file("input.dat", ios::in); 
  fstream log_file("log_file", ios::out); 
 
  if( read_file == NULL ){
    printf("Error opening file 'input.dat'.\nError in routine read_symmetries_section()\nExiting...");
    exit(0);
  }//if

  if( log_file == NULL ){
    printf("Error opening file 'log_file'.\nError in routine read_symmetries_section()\nExiting");
    exit(0);
  }//if


  
  int begin_line_no=0; 
  int end_line_no=0;
  int line_no=0; 
  

  while(!read_file.eof()){

    line_no++; 
    read_file.getline(buffer, buffer_size, '\n');
    word_offset = 0; 
    if(get_word(buffer, word, word_offset)){
   

    
      if (strcmp(word, "<SECTION-SYMMETRIES>")==0){
	begin_line_no = line_no;       
      }//if
      

      if (strcmp(word, "</SECTION-SYMMETRIES>")==0){
	end_line_no = line_no;       
      }//if


    }//if get_word;     
  }//while eof; 

    read_file.close();
    read_file.clear();
    //cout<<symmetries_line_no<<endl;
    //cout<<couplings_line_no<<endl;

    read_file.open("input.dat", ios::in);
    if (!read_file.good()){
      printf("Error opening file 'input.dat'.\nError in routine read_symmetries_section().\nExiting...");
      exit(0);
    }//if

    line_no = 0; 
    int symmetry_index = 0; //count the number of symmetries and compare it with the symmetry_no


    while(!read_file.eof()){
      line_no++; 
      read_file.getline(buffer, buffer_size, '\n');
      word_offset = 0; 


      if(get_word(buffer, word, word_offset)){

	if (word[0] == '#'){
	  continue; 
	}//if


	if ((begin_line_no<line_no)&&(line_no<end_line_no)){
	  	  	  
	  
	  for(int index = 0; index < possible_symmetry_type_no ; index ++){


            if(strcmp(word, possible_symmetry_type[index])==0){

	      symmetry_types[symmetry_index].activate();
	      symmetry_types[symmetry_index].set_name(word); 
	      symmetry_types[symmetry_index].set_abelian_tag();


	      if(!(get_word(buffer, word, word_offset)))
		error_message("reading symmetry_index");
	      
	      symmetry_types[symmetry_index].set_min_representation_index(atoi(word));
	      	      
	      if(!(get_word(buffer, word, word_offset)))
		error_message("reading symmetry_index");
	      
	      symmetry_types[symmetry_index].set_max_representation_index(atoi(word));
	      
	      assert(symmetry_types[symmetry_index].get_min_representation_index()<symmetry_types[symmetry_index].get_max_representation_index());
	      trial_state_no *=symmetry_types[symmetry_index].trial_state_no();

	      //cout<<symmetry_index<<endl;
	      //cout<<symmetry_types[symmetry_index].get_name()<<endl;
	      //cout<<symmetry_types[symmetry_index].get_min_representation_index()<<endl;
	      //cout<<symmetry_types[symmetry_index].get_max_representation_index()<<endl;
	      //cout<<symmetry_types[symmetry_index].trial_state_no()<<endl; 
	    }//if strcmp	    
	    
	  }//if index
	  symmetry_index++; 
 	}//if symmetries	       	
      }//if get_word; 
    }//while(read_file.eof)
    assert(symmetry_index==symmetry_no); 
    


    //now we parse each section


    read_file.close(); 
    read_file.clear();
    log_file.close();
    log_file.clear();
    
}//read_symmetries_section


/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/


void read_block_states_section(){

/*******************************************************************************
input variables:  none

output variables: none

return: void

What it does: 
     This routine reads the current states from the input file. 
How to call:
     void read_block_states_section()
*******************************************************************************/

  if (block_states_array != NULL){
    delete [] block_states_array;
  }//if
  
  if (block_states_array_copy != NULL){
    delete [] block_states_array_copy;
  }//if
  block_states_array_copy = NULL;


  block_states_array = new state[block_state_no]; 
  block_states_array_copy = new state[block_state_no]; 

  
   
  

  fstream read_file("input.dat", ios::in); 
  fstream log_file("log_file", ios::out); 
 
  if( read_file == NULL ){
    printf("Error opening file 'input.dat'.\nError in routine read_block_states_section()\nExiting...");
    exit(0);
  }//if

  if( log_file == NULL ){
    printf("Error opening file 'log_file'.\nError in routine read_block_state_section()\nExiting");
    exit(0);
  }//if


  
  int begin_line_no=0;
  int end_line_no=0; 
  int line_no=0; 
  

  while(!read_file.eof()){

    line_no++; 
    read_file.getline(buffer, buffer_size, '\n');
    word_offset = 0; 
    if(get_word(buffer, word, word_offset)){
   
      if (strcmp(word, "<SECTION-BLOCK_STATES>")==0){
	begin_line_no = line_no;       
      }//if

    
      if (strcmp(word, "</SECTION-BLOCK_STATES>")==0){
	end_line_no = line_no;       
      }//if
      
    }//if get_word;     
  }//while eof; 

    read_file.close();
    read_file.clear();

    //cout<<block_states_line_no<<endl;
    //cout<<local_states_line_no<<endl;


    read_file.open("input.dat", ios::in);
    if (!read_file.good()){
      printf("Error opening file 'input.dat'.\nError in routine read_block_states_section().\nExiting...");
      exit(0);
    }//if

    line_no = 0; 
    int block_states_index = 0; //count the number of symmetries and compare it with the symmetry_no


    while(!read_file.eof()){
      line_no++; 
      read_file.getline(buffer, buffer_size, '\n');
      word_offset = 0; 


      if(get_word(buffer, word, word_offset)){

	if (word[0] == '#'){
	  continue; 
	}//if


	if ((begin_line_no<line_no)&&(line_no<end_line_no)){
	  	  	  	  
	  block_states_array[block_states_index].activate(symmetry_no);
	  block_states_array_copy[block_states_index].activate(symmetry_no);

	  word_offset = 0; 

	  for(int i=0; i<symmetry_no; i++){
	    
	    if(!(get_word(buffer, word, word_offset)))
	      error_message("reading block_states quantum_numbers");
            int representation_index =atoi(word);
	    
	   
            // We check if the quantum numbers of the states are in the allowed range. 

            if((representation_index > symmetry_types[i].get_max_representation_index()) ||
               (representation_index < symmetry_types[i].get_min_representation_index()))
	      error_message("checking the quantum numbers of the states.\nThey are not in the allowed range");

            else{
	      block_states_array[block_states_index].set_representation_index(i,representation_index);
	      block_states_array_copy[block_states_index].set_representation_index(i,representation_index);

	      //cout<<"index="<<"  "<<block_states_index<<endl;
	      //cout<<block_states_array[block_states_index].get_representation_index(i)<<endl; 
	    }//else
	  }//for i

	  block_states_index++; 
 	}//if block_state_line_no
		
      }//if get_word; 
    }//while(read_file.eof)
    
    assert(block_states_index==block_state_no); 


    sort_states((unsigned long)block_state_no, block_states_array_copy - 1);
    
    if (!check_states_order ((unsigned long)block_state_no, block_states_array_copy, block_states_array)){
      error_message("representation indices for the block_states_array are not ordered\n");
    }//if

    read_file.close(); 
    read_file.clear();
    log_file.close();
    log_file.clear();

}//read_block_states_section


/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/


void read_local_states_section(){

/*******************************************************************************
input variables:  none

output variables: none

return: void

What it does: 
     This routine reads the local states from the input file. 
How to call:
     void read_local_states_section()
*******************************************************************************/

  if (local_states_array != NULL){
    delete [] local_states_array;
  }//if
  local_states_array = NULL;
  
  if (local_states_array_copy != NULL){
    delete [] local_states_array_copy;
  }
  local_states_array_copy = NULL;


  local_states_array = new state[local_state_no]; 
  local_states_array_copy = new state[local_state_no]; 




  fstream read_file("input.dat", ios::in); 
  fstream log_file("log_file", ios::out); 
 
  if( read_file == NULL ){
    printf("Error opening file 'input.dat'.\nError in routine read_local_states_section()\nExiting...");
    exit(0);
  }//if

  if( log_file == NULL ){
    printf("Error opening file 'log_file'.\nError in routine read_local_state_section()\nExiting");
    exit(0);
  }//if


  int begin_line_no=0;
  int end_line_no=0; 
  int line_no=0; 
  

  while(!read_file.eof()){

    line_no++; 
    read_file.getline(buffer, buffer_size, '\n');
    word_offset = 0; 
    if(get_word(buffer, word, word_offset)){
   
      if (strcmp(word, "<SECTION-LOCAL_STATES>")==0){
	begin_line_no = line_no;       
      }//if

    
      if (strcmp(word, "</SECTION-LOCAL_STATES>")==0){
	end_line_no = line_no;       
      }//if
      
    }//if get_word;     
  }//while eof; 

    read_file.close();
    read_file.clear();

    //cout<<block_states_line_no<<endl;
    //cout<<local_states_line_no<<endl;


    read_file.open("input.dat", ios::in);
    if (!read_file.good()){
      printf("Error opening file 'input.dat'.\nError in routine read_local_states_section().\nExiting...");
      exit(0);
    }//if

    line_no = 0; 
    int local_states_index = 0; //count the number of symmetries and compare it with the symmetry_no


    while(!read_file.eof()){
      line_no++; 
      read_file.getline(buffer, buffer_size, '\n');
      word_offset = 0; 


      if(get_word(buffer, word, word_offset)){

	if (word[0] == '#'){
	  continue; 
	}//if


	if ((begin_line_no<line_no)&&(line_no<end_line_no)){
	  	  	  	  
	  local_states_array[local_states_index].activate(symmetry_no);
	  local_states_array_copy[local_states_index].activate(symmetry_no);

	  word_offset = 0; 

	  for(int i=0; i<symmetry_no; i++){
	    
	    if(!(get_word(buffer, word, word_offset)))
	      error_message("reading local_states quantum_numbers");
            int representation_index =atoi(word);
	    
	   
            // We check if the quantum numbers of the states are in the allowed range. 

            if((representation_index > symmetry_types[i].get_max_representation_index()) ||
               (representation_index < symmetry_types[i].get_min_representation_index()))
	      error_message("checking the quantum numbers of the states.\nThey are not in the allowed range");

            else{
	      local_states_array[local_states_index].set_representation_index(i,representation_index);
	      local_states_array_copy[local_states_index].set_representation_index(i,representation_index);
	      //cout<<"index="<<"  "<<local_states_index<<endl;
	      //cout<<local_states_array[local_states_index].get_representation_index(i)<<endl; 
	    }//else
	  }//for i

	  local_states_index++; 
 	}//if local_state_line_no
		
      }//if get_word; 
    }//while(read_file.eof)

    
    assert(local_states_index==local_state_no); 

    sort_states((unsigned long)local_state_no, local_states_array_copy - 1);
    
    if (!check_states_order ((unsigned long)local_state_no, local_states_array_copy, local_states_array)){
      error_message("representation indices for the local_states are not ordered\n");
    }//if



    read_file.close(); 
    read_file.clear();
    log_file.close();
    log_file.clear();

}//read_local_states_section


/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/


void read_local_states_signs_section(){

/*******************************************************************************
input variables:  none

output variables: none

return: void

What it does: 
     This routine reads the signs of the local states.
How to call:
     void read_local_states_signs_section()
*******************************************************************************/



  fstream read_file("input.dat", ios::in); 
  fstream log_file("log_file", ios::out); 
 
  if( read_file == NULL ){
    printf("Error opening file 'input.dat'.\nError in routine read_local_states_signs_section()\nExiting...");
    exit(0);
  }//if

  if( log_file == NULL ){
    printf("Error opening file 'log_file'.\nError in routine read_local_states_signs_section()\nExiting");
    exit(0);
  }//if


  int begin_line_no=0;
  int end_line_no=0; 
  int line_no=0; 
  

  while(!read_file.eof()){

    line_no++; 
    read_file.getline(buffer, buffer_size, '\n');
    word_offset = 0; 
    if(get_word(buffer, word, word_offset)){
   
      if (strcmp(word, "<SECTION-LOCAL_STATES_SIGNS>")==0){
	begin_line_no = line_no;       
      }//if

    
      if (strcmp(word, "</SECTION-LOCAL_STATES_SIGNS>")==0){
	end_line_no = line_no;       
      }//if
      
    }//if get_word;     
  }//while eof; 

    read_file.close();
    read_file.clear();

    //cout<<block_states_line_no<<endl;
    //cout<<local_states_line_no<<endl;


    read_file.open("input.dat", ios::in);
    if (!read_file.good()){
      printf("Error opening file 'input.dat'.\nError in routine read_local_states_signs_section().\nExiting...");
      exit(0);
    }//if

    line_no = 0; 
 

    while(!read_file.eof()){
      line_no++; 
      read_file.getline(buffer, buffer_size, '\n');
      word_offset = 0; 


      if(get_word(buffer, word, word_offset)){

	if (word[0] == '#'){
	  continue; 
	}//if


	if ((begin_line_no<line_no)&&(line_no<end_line_no)){
	  	  	  	  
	  word_offset = 0; 

	  for(int i=0; i<local_state_no; i++){
	    
	    if(!(get_word(buffer, word, word_offset)))
	      error_message("reading local states signs");

            int sgn_in =atoi(word);

	    assert(fabs(sgn_in)==1); 
	    
	    local_states_array[i].set_sgn(sgn_in) ;
	    local_states_array_copy[i].set_sgn(sgn_in); 
	    
	    //cout<<local_states_array[i].get_sgn()<<endl;

	  }//for i

 	}//if begin_line_no
		
      }//if get_word; 
    }//while(read_file.eof)
    
    read_file.close(); 
    read_file.clear();
    log_file.close();
    log_file.clear();

}//read_local_states_signs_section


/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/


void read_block_hamiltonian_section(){

/*******************************************************************************
input variables:  none

output variables: none

return: void

What it does: 
     This routine reads the block_hamiltonian section and load the hmailtonian
     operator. 
How to call:
     void read_block_hamiltonian_section()
*******************************************************************************/

  //allocate memory for the coupling names; 

  if (couplings_name){
    delete [] couplings_name;
  }//if
  
  couplings_name = NULL;
  
  couplings_name = new name[coupling_no]; 
  

  if (couplings) {
    delete [] couplings;
  }//if
  couplings = NULL;
  
  if (couplings_rescaled){
    delete [] couplings_rescaled;
  }
  
  couplings_rescaled = NULL;

  if (block_hamiltonian_terms!= NULL){
    for(int i = 0; i<coupling_no; i++){
      block_hamiltonian_terms[i].clear();
    }//for
    delete [] block_hamiltonian_terms;
  }//if

  block_hamiltonian_terms = NULL;


  couplings = new double [coupling_no]; 
  couplings_rescaled = new double [coupling_no]; 

  block_hamiltonian_terms = new quantum_operator[coupling_no]; 

  for(int i=0; i<coupling_no; i++){
    block_hamiltonian_terms[i].activate(symmetry_no); 
    block_hamiltonian_terms[i].allocate_sectors_matrix(block_sector_no); 
  }//i
  
  block_hamiltonian.activate(symmetry_no); 
  block_hamiltonian.set_name("Block_Hamiltonian"); 
  block_hamiltonian.allocate_sectors_matrix(block_sector_no); 

  for(int i = 0; i < symmetry_no; i++){
    block_hamiltonian.set_representation_index(i,0); 
  }//i

  int matrix_size = 0;
  for (int i=0; i<block_sector_no; i++){
    matrix_size += block_sectors_properties_array[i].dimension;     
  }//i

  //allocate a matrix of size matrix size;

  
  dmatrix *read_matrix; 
  read_matrix = new dmatrix[coupling_no]; 

  for (int i=0; i<coupling_no; i++){
    read_matrix[i].allocate(matrix_size, matrix_size); 
  }//i

  


  fstream read_file("input.dat", ios::in); 
  fstream log_file("log_file", ios::out); 
 
  if( read_file == NULL ){
    printf("Error opening file 'input.dat'.\nError in routine read_block_hamiltonian_section()\nExiting...");
    exit(0);
  }//if

  if( log_file == NULL ){
    printf("Error opening file 'log_file'.\nError in routine read_block_hamiltonian_section()\nExiting");
    exit(0);
  }//if


  int  begin_line_no;
  int end_line_no; 
  int line_no=0; 
  int index = 0; 

  int *top_line_no; 
  int *bottom_line_no; 
  int *top_name; 
  int *bottom_name; 
  int *top_coupling;
  int *bottom_coupling; 
  int *top_representation_index;
  int *bottom_representation_index; 
  int *top_matrix;
  int *bottom_matrix;
  
  top_line_no = new int[coupling_no];
  bottom_line_no = new int[coupling_no]; 

  top_name = new int[coupling_no];
  bottom_name = new int[coupling_no]; 

  top_coupling = new int[coupling_no];
  bottom_coupling = new int[coupling_no]; 

  top_representation_index = new int [coupling_no]; 
  bottom_representation_index = new int [coupling_no]; 

  top_matrix = new int [coupling_no]; 
  bottom_matrix = new int [coupling_no]; 
  
  while(!read_file.eof()){

    line_no++; 
    read_file.getline(buffer, buffer_size, '\n');
    word_offset = 0; 
    if(get_word(buffer, word, word_offset)){   
      
      if (strcmp(word, "<SECTION-BLOCK_HAMILTONIAN>")==0){
	begin_line_no = line_no;       
      }//if

    
      if (strcmp(word, "</SECTION-BLOCK_HAMILTONIAN>")==0){
	end_line_no = line_no;       
      }//if

      
      if (strcmp(word, "<BLOCK_HAMILTONIAN_TERM>")==0){
	top_line_no [index] = line_no;       
      }//if

      if (strcmp(word, "<BLOCK_HAMILTONIAN_NAME>")==0){
	top_name [index] = line_no;       
      }//if

      if (strcmp(word, "</BLOCK_HAMILTONIAN_NAME>")==0){
	bottom_name [index] = line_no;       
      }//if

      if (strcmp(word, "<BLOCK_HAMILTONIAN_COUPLING>")==0){
	top_coupling [index] = line_no;       
      }//if

      if (strcmp(word, "</BLOCK_HAMILTONIAN_COUPLING>")==0){
	bottom_coupling [index] = line_no;       
      }//if


      if (strcmp(word, "<BLOCK_HAMILTONIAN_REPRESENTATION_INDEX>")==0){
	top_representation_index [index] = line_no;       
      }//if

      if (strcmp(word, "</BLOCK_HAMILTONIAN_REPRESENTATION_INDEX>")==0){
	bottom_representation_index [index] = line_no;       
      }//if

      if (strcmp(word, "<BLOCK_HAMILTONIAN_MATRIX>")==0){
	top_matrix [index] = line_no;       
      }//if
      
      if (strcmp(word, "</BLOCK_HAMILTONIAN_MATRIX>")==0){
	bottom_matrix [index] = line_no;       
      }//if

    
      if (strcmp(word, "</BLOCK_HAMILTONIAN_TERM>")==0){
	bottom_line_no[index] = line_no;       
	index++; 
      }//if
      
    }//if get_word;     
  }//while eof; 

  //make sure we have the proper positions for the line_no's.


    read_file.close();
    read_file.clear();

    assert(index == coupling_no); 

    assert(begin_line_no<top_line_no[0]);
    for(int i=0; i<index; i++){
      assert(top_line_no[i]<top_name[i]); 
      assert(top_line_no[i]<top_representation_index[i]); 
      assert(top_line_no[i]<top_matrix[i]); 
      assert(top_line_no[i]<bottom_line_no[i]);

      assert (top_name[i]<bottom_name[i]); 
      assert (top_representation_index[i]<bottom_representation_index[i]);
      assert(top_matrix[i]<bottom_matrix[i]); 
      
      assert(bottom_name[i]<bottom_line_no[i]); 
      assert(bottom_representation_index[i]<bottom_line_no[i]);
      assert(bottom_matrix[i]<bottom_line_no[i]);

      
    }//int i 

    assert (bottom_line_no[index-1]<end_line_no); 
    
    for(index=0; index<coupling_no; index++){

      read_file.open("input.dat", ios::in);
      if (!read_file.good()){
	printf("Error opening file 'input.dat'.\nError in routine read_block_hamiltonian_section().\nExiting...");
	exit(0);
      }//if

      line_no = 0; 
      int column_index=0; 
      int row_index =0; 

      while(!read_file.eof()){
	line_no++; 
	read_file.getline(buffer, buffer_size, '\n');
	word_offset = 0; 


	if(get_word(buffer, word, word_offset)){
	  if (word[0] == '#'){
	    continue; 
	  }//if

	  
	  if ((top_line_no[index]<line_no)&&(line_no<bottom_line_no[index])){
	    
	    if ((top_name[index]<line_no)&&(line_no<bottom_name[index])){
	      
	      word_offset = 0; 
	      if(!(get_word(buffer, word, word_offset))){
		error_message("reading block_hamiltonian name\n");
	      }//if
	      

	      block_hamiltonian_terms[index].set_name(word);

	      //cout<<block_hamiltonian_terms[index].get_name()<<endl; 

	    }//top_name

	    if ((top_coupling[index]<line_no)&&(line_no<bottom_coupling[index])){


	      word_offset =0; 

	      if(!(get_word(buffer, word, word_offset))){
		error_message("reading name of the  coupling\n");
	      }//if

	      strcpy(couplings_name[index], word);


	      if(!(get_word(buffer, word, word_offset))){
		error_message("reading value of the  coupling\n");
	      }//if

	      couplings[index] = atof(word); 
	      couplings_rescaled[index] = couplings[index]*2.0/(1.0+1.0/lambda)/sqrt(lambda);

	      //the sqrt(lambda) comes from the rescaling of the hamiltonian

	    }//top_coupling
	  

	    if ((top_representation_index[index]<line_no)&&(line_no<bottom_representation_index[index])){

	      word_offset = 0;	   

	      for(int i = 0; i < symmetry_no; i++){

		if(!(get_word(buffer, word, word_offset))){
		  error_message("reading the representation indices of the Block_Hamiltonian.\nError in read_block_hamiltonian_section()\n.Exiting...\n");
		}
		
		int representation_index_in =atoi(word);
		if( representation_index_in!=0){
		  //Block_Hamiltonian must have the representation indices zero. 
		  error_message("reading the representation indices of the Block_Hamiltonian.\nError in read_block_hamiltonian_section()\n.Exiting...\n");
		}
		
		// We check if the quantum numbers of the states are in the allowed range. 

		if((representation_index_in > symmetry_types[i].get_max_representation_index()) ||
		   (representation_index_in < symmetry_types[i].get_min_representation_index())){
		  error_message("checking the quantum numbers of the block_hamiltonian_terms.\nThey are not in the allowed range");
		}//if

		else{		  
		  block_hamiltonian_terms[index].set_representation_index(i,representation_index_in);
		  //cout<<block_hamiltonian_terms[index].get_representation_index(i)<<endl; 
		}//else
	    }//i	      	      
	    }//if top_representation_index
	    
	    //now we read the matrix for the Block_Hamiltonian
	    

	    if ((top_matrix[index]<line_no)&&(line_no<bottom_matrix[index])){
	      word_offset = 0; 

	      for(column_index=0; column_index<matrix_size; column_index++){
		
		if(!(get_word(buffer, word, word_offset))){
		  error_message("reading the quantum numbers of the block_hamiltonian_terms.\nError in read_block_hamiltonian_section().\nExiting...\n");
		}//if		  
		read_matrix[index].set_matrix_element(row_index, column_index, atof(word)); 		  		
	      }//row_index
	      //cout<<endl;
	      row_index++; 
	    }//if top_matrix
	    //cout<<column_index<<endl;
	  }//if top_line	  
	}//if get_word; 

      }//while(read_file.eof)
      assert(row_index==matrix_size); 
      read_file.close(); 
      read_file.clear();
    }//for index.


    /*    
    for(int i=0; i<matrix_size; i++){
	  for(int j=0; j<matrix_size; j++){
	    cout<<read_matrix.get_matrix_ptr()[i][j]<<"  ";
	  }//for column
	  cout<<endl;
    }//for row
    */


    log_file.close();
    log_file.clear();
    
    //now the operators are set. 
    for(int sector_row_index = 0; sector_row_index < block_sector_no; sector_row_index++){
      for(int sector_column_index = 0; sector_column_index < block_sector_no; sector_column_index++){


	block_hamiltonian.get_sector_matrix()[sector_row_index][sector_column_index].set_size(block_sectors_properties_array[sector_row_index].dimension,
						      block_sectors_properties_array[sector_column_index].dimension);

	  if(grand_selection_rule(symmetry_no, symmetry_types, block_sectors_properties_array[sector_column_index].representation_index,
				  block_hamiltonian.get_representation_index(), block_sectors_properties_array[sector_row_index].representation_index)){

	      block_hamiltonian.get_sector_matrix()[sector_row_index][sector_column_index].activate(symmetry_no);

	      block_hamiltonian.get_sector_matrix()[sector_row_index][sector_column_index].set_representation_index(0, block_sectors_properties_array[sector_row_index].representation_index);
	      block_hamiltonian.get_sector_matrix()[sector_row_index][sector_column_index].set_representation_index(1, block_sectors_properties_array[sector_column_index].representation_index);
	      block_hamiltonian.get_sector_matrix()[sector_row_index][sector_column_index].allocate_matrix();

	      int size_height = block_hamiltonian.get_sector_matrix()[sector_row_index][sector_column_index].get_height();
	      int size_width = block_hamiltonian.get_sector_matrix()[sector_row_index][sector_column_index].get_width();
	

	      for(int i = 0; i < size_height; i++){
		for(int j = 0; j < size_width; j++){
		  
		  int d1 =0;
		  int d2 =0;

		  for(int k = 0; k < sector_row_index; k++)
		    d1 +=  block_hamiltonian.get_sector_matrix()[k][0].get_height();
		    d1 += i;
		    for(int k = 0; k < sector_column_index; k++)
		      d2 +=  block_hamiltonian.get_sector_matrix()[0][k].get_width();
		    d2 += j;

		    double element =0;
		    for(index= 0; index < coupling_no; index++){
		      element += couplings_rescaled[index] * read_matrix[index].get_matrix_ptr()[d1][d2];
		    }//index
		    block_hamiltonian.get_sector_matrix()[sector_row_index][sector_column_index].set_matrix_element(i, j, element);
		}//j
	      }//i
	  }//if
      }//sector_column_index
    }//sector_row_index


    delete [] top_line_no;
    top_line_no = NULL;
    delete [] bottom_line_no; 
    bottom_line_no = NULL;
    delete [] top_name;
    top_name = NULL;
    delete [] bottom_name; 
    bottom_name = NULL;
    delete [] top_coupling;
    top_coupling = NULL;
    delete [] bottom_coupling;
    bottom_coupling = NULL;
    delete [] top_representation_index; 
    top_representation_index = NULL;
    delete [] bottom_representation_index;
    bottom_representation_index = NULL;
    delete [] top_matrix;
    top_matrix = NULL;
    delete [] bottom_matrix;
    bottom_matrix = NULL;

    for(int i=0; i<coupling_no; i++){
      read_matrix[i].clear();
    }
    delete [] read_matrix; 
    read_matrix = NULL; 

  for(int i=0; i<coupling_no; i++){
    block_hamiltonian_terms[i].clear(); 
  }//i
  delete [] block_hamiltonian_terms;
  block_hamiltonian_terms = NULL;

  /*
 
  cout<<block_hamiltonian.get_name()<<endl;
  cout<<block_hamiltonian.get_representation_index()<<endl;

  
  for (int sector_row=0; sector_row<block_sector_no; sector_row++){
    for (int sector_column=0; sector_column<block_sector_no; sector_column++){
      if(block_hamiltonian.get_sector_matrix()[sector_row][sector_column].get_activation_state()){
	cout<< "sector(" <<sector_row<<","<<sector_column<<") ";
	cout<< " dimension= (" << block_sectors_properties_array[sector_row].dimension
	    <<","<<block_sectors_properties_array[sector_column].dimension<<")"<<endl;
	
	for(int i=0;i<block_sectors_properties_array[sector_row].dimension; i++){
	  for(int j=0; j<block_sectors_properties_array[sector_column].dimension; j++){
	    cout<<block_hamiltonian.get_sector_matrix()[sector_row][sector_column].get_matrix()[i][j]<<"\t";
	  }//j
	  cout<<endl;
	}//i
	

      }//if
    }//sector_column
  }//sector_row
  */


}//read_block_hamiltonian_section


/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/


void read_hopping_operators_section(){

/*******************************************************************************
input variables:  none

output variables: none

return: void

What it does: 
     This routine reads all the hopping operators from the input.dat file. 
How to call:
    void read_hopping_operators_section()
*******************************************************************************/
  
  if (block_hopping_operators != NULL){
    for(int i=0; i< hopping_operator_no; i++){
      block_hopping_operators[i].clear();
    }//for
    delete [] block_hopping_operators;
  }
  block_hopping_operators = NULL;


  if (new_block_hopping_operators != NULL){
    for(int i=0; i< hopping_operator_no; i++){
      new_block_hopping_operators[i].clear();
    }//for
    delete [] new_block_hopping_operators;
  }
  new_block_hopping_operators = NULL;


  block_hopping_operators = new quantum_operator[hopping_operator_no]; 
  new_block_hopping_operators = new quantum_operator[hopping_operator_no]; 
  

  
  for(int i=0; i<hopping_operator_no; i++){
    block_hopping_operators[i].activate(symmetry_no); 
    block_hopping_operators[i].allocate_sectors_matrix(block_sector_no); 
  }//i
  


  int matrix_size = 0;
  for (int i=0; i<block_sector_no; i++){
    matrix_size += block_sectors_properties_array[i].dimension; 
  }//i

  //allocate a matrix of size matrix size;

  
  dmatrix *read_matrix; 
  read_matrix = new dmatrix[hopping_operator_no]; 

  for (int i=0; i<hopping_operator_no; i++){
    read_matrix[i].allocate(matrix_size, matrix_size); 
  }//i

  


  fstream read_file("input.dat", ios::in); 
  fstream log_file("log_file", ios::out); 
 
  if( read_file == NULL ){
    printf("Error opening file 'input.dat'.\nError in routine read_hopping_operators_section()\nExiting...");
    exit(0);
  }//if

  if( log_file == NULL ){
    printf("Error opening file 'log_file'.\nError in routine read_hopping_operators_section()\nExiting");
    exit(0);
  }//if


  int  begin_line_no;
  int end_line_no; 
  int line_no=0; 
  int index = 0; 

  int *top_line_no; 
  int *bottom_line_no; 
  int *top_name; 
  int *bottom_name; 
  int *top_representation_index;
  int *bottom_representation_index; 
  int *top_sign;
  int *bottom_sign; 
  int *top_matrix;
  int *bottom_matrix;
  
  top_line_no = new int[hopping_operator_no];
  bottom_line_no = new int[hopping_operator_no]; 

  top_name = new int[hopping_operator_no];
  bottom_name = new int[hopping_operator_no]; 
  top_representation_index = new int [hopping_operator_no]; 
  bottom_representation_index = new int [hopping_operator_no]; 
  top_sign = new int [hopping_operator_no]; 
  bottom_sign = new int [hopping_operator_no]; 
  top_matrix = new int [hopping_operator_no]; 
  bottom_matrix = new int [hopping_operator_no]; 
  
  while(!read_file.eof()){

    line_no++; 
    read_file.getline(buffer, buffer_size, '\n');
    word_offset = 0; 
    if(get_word(buffer, word, word_offset)){   
      
      if (strcmp(word, "<SECTION-HOPPING_OPERATORS>")==0){
	begin_line_no = line_no;       
      }//if

    
      if (strcmp(word, "</SECTION-HOPPING_OPERATORS>")==0){
	end_line_no = line_no;       
      }//if

      
      if (strcmp(word, "<HOPPING_OPERATOR>")==0){
	top_line_no [index] = line_no;       
      }//if

      if (strcmp(word, "<HOPPING_OPERATOR_NAME>")==0){
	top_name [index] = line_no;       
      }//if

      if (strcmp(word, "</HOPPING_OPERATOR_NAME>")==0){
	bottom_name [index] = line_no;       
      }//if

      if (strcmp(word, "<HOPPING_OPERATOR_REPRESENTATION_INDEX>")==0){
	top_representation_index [index] = line_no;       
      }//if

      if (strcmp(word, "</HOPPING_OPERATOR_REPRESENTATION_INDEX>")==0){
	bottom_representation_index [index] = line_no;       
      }//if

      if (strcmp(word, "<HOPPING_OPERATOR_SIGN>")==0){
	top_sign [index] = line_no;       
      }//if
      
      if (strcmp(word, "</HOPPING_OPERATOR_SIGN>")==0){
	bottom_sign [index] = line_no;       
      }//if


      if (strcmp(word, "<HOPPING_OPERATOR_MATRIX>")==0){
	top_matrix [index] = line_no;       
      }//if
      
      if (strcmp(word, "</HOPPING_OPERATOR_MATRIX>")==0){
	bottom_matrix [index] = line_no;       
      }//if
   
      if (strcmp(word, "</HOPPING_OPERATOR>")==0){
	bottom_line_no[index] = line_no;       
	index++; 
      }//if
      
    }//if get_word;     
  }//while eof; 

  //make sure we have the proper positions for the line_no's.

    read_file.close();
    read_file.clear();

    assert(index == hopping_operator_no); 

    assert(begin_line_no<top_line_no[0]);

    for(int i=0; i<index; i++){
      assert(top_line_no[i]<top_name[i]); 
      assert(top_line_no[i]<top_representation_index[i]); 
      assert(top_line_no[i]<top_sign[i]);
      assert(top_line_no[i]<top_matrix[i]); 


      assert(top_line_no[i]<bottom_line_no[i]);

      assert (top_name[i]<bottom_name[i]); 
      assert (top_representation_index[i]<bottom_representation_index[i]);
      assert(top_sign[i]<bottom_sign[i]); 
      assert(top_matrix[i]<bottom_matrix[i]); 
      
      assert(bottom_name[i]<bottom_line_no[i]); 
      assert(bottom_representation_index[i]<bottom_line_no[i]);
      assert(bottom_matrix[i]<bottom_line_no[i]);
      assert(bottom_sign[i]<bottom_line_no[i]); 

    }//int i 

    assert (bottom_line_no[index-1]<end_line_no); 
    
    for(index=0; index<hopping_operator_no; index++){

      read_file.open("input.dat", ios::in);
      if (!read_file.good()){
	printf("Error opening file 'input.dat'.\nError in routine read_hopping_operators_section().\nExiting...");
	exit(0);
      }//if

      line_no = 0; 
      int column_index=0; 
      int row_index =0; 

      while(!read_file.eof()){
	line_no++; 
	read_file.getline(buffer, buffer_size, '\n');
	word_offset = 0; 


	if(get_word(buffer, word, word_offset)){
	  if (word[0] == '#'){
	    continue; 
	  }//if

	  
	  if ((top_line_no[index]<line_no)&&(line_no<bottom_line_no[index])){
	    
	    if ((top_name[index]<line_no)&&(line_no<bottom_name[index])){
	      
	      word_offset = 0; 
	      if(!(get_word(buffer, word, word_offset))){
		error_message("reading block_hopping_operators name\n");
	      }//if
	      
	      block_hopping_operators[index].set_name(word);

	      //cout<<block_hopping_operators[index].get_name(); 

	    }//top_name

	  

	    if ((top_representation_index[index]<line_no)&&(line_no<bottom_representation_index[index])){

	      word_offset = 0;	   

	      for(int i = 0; i < symmetry_no; i++){

		if(!(get_word(buffer, word, word_offset))){
		  error_message("reading the representation indices of the operators.\nError in read_hopping_operators_section()\n.Exiting...\n");
		}
		
		int representation_index_in =atoi(word);
		
		// We check if the quantum numbers of the states are in the allowed range. 

		if((representation_index_in > symmetry_types[i].get_max_representation_index()) ||
		   (representation_index_in < symmetry_types[i].get_min_representation_index())){
		  error_message("checking the quantum numbers of the block_hopping_operators.\nThey are not in the allowed range");
		}//if

		else{		  
		  block_hopping_operators[index].set_representation_index(i,representation_index_in);
		  //cout<<block_hopping_operators[index].get_representation_index(i)<<endl; 
		}//else
	      }//i	      	      
	    }//if top_representation_index
	    
	    //now we read in the sign of the operator 

	    if ((top_sign[index]<line_no)&&(line_no<bottom_sign[index])){
	      
	      word_offset = 0; 
	      if(!(get_word(buffer, word, word_offset))){
		error_message("reading block_hopping_operators sign\n");
	      }//if
	      
	      block_hopping_operators[index].set_sgn(atoi(word));

	      //cout<<block_hopping_operators[index].get_name(); 

	    }//top_sign



	    //now we read the matrix for the Block_Hamiltonian
	    

	    if ((top_matrix[index]<line_no)&&(line_no<bottom_matrix[index])){
	      word_offset = 0; 

	      for(column_index=0; column_index<matrix_size; column_index++){
		
		if(!(get_word(buffer, word, word_offset))){
		  error_message("reading the quantum numbers of the operators.\nError in read_block_hamiltonian_section()\n.Exiting...\n");
		}//if		  
		read_matrix[index].set_matrix_element(row_index, column_index, atof(word)); 		  
		//cout<<read_matrix[index].get_matrix_ptr()[row_index][column_index]<<"  ";
	      }//row_index
	      //cout<<endl;
	      row_index++; 

	    }//if top_matrix
	    //cout<<column_index<<endl;
	  }//if top_line	  
	}//if get_word; 

      }//while(read_file.eof)
      assert(row_index==matrix_size); 
      read_file.close(); 
      read_file.clear();
    }//for index.


    /*
    for(int i=0; i<matrix_size; i++){
	  for(int j=0; j<matrix_size; j++){
	    cout<<read_matrix.get_matrix_ptr()[i][j]<<"  ";
	  }//for column
	  cout<<endl;
    }//for row
    */

    log_file.close();
    log_file.clear();

    
    //now the operators are set. 

    for(index=0; index<hopping_operator_no; index++){
      
      for(int sector_row_index = 0; sector_row_index < block_sector_no; sector_row_index++){
	for(int sector_column_index = 0; sector_column_index < block_sector_no; sector_column_index++){
	  

	  block_hopping_operators[index].get_sector_matrix()[sector_row_index][sector_column_index].set_size(block_sectors_properties_array[sector_row_index].dimension,
											  block_sectors_properties_array[sector_column_index].dimension);
	  
	  if(grand_selection_rule(symmetry_no, symmetry_types, block_sectors_properties_array[sector_column_index].representation_index,
				  block_hopping_operators[index].get_representation_index(), block_sectors_properties_array[sector_row_index].representation_index)){
	    
	    block_hopping_operators[index].get_sector_matrix()[sector_row_index][sector_column_index].activate(symmetry_no);

	    block_hopping_operators[index].get_sector_matrix()[sector_row_index][sector_column_index].set_representation_index(0, block_sectors_properties_array[sector_row_index].representation_index);
	    block_hopping_operators[index].get_sector_matrix()[sector_row_index][sector_column_index].set_representation_index(1, block_sectors_properties_array[sector_column_index].representation_index);
	    block_hopping_operators[index].get_sector_matrix()[sector_row_index][sector_column_index].allocate_matrix();
	    
	    int size_height = block_hopping_operators[index].get_sector_matrix()[sector_row_index][sector_column_index].get_height();
	    int size_width = block_hopping_operators[index].get_sector_matrix()[sector_row_index][sector_column_index].get_width();
	    
	    
	      for(int i = 0; i < size_height; i++){
		for(int j = 0; j < size_width; j++){
		  
		  int d1 =0;
		  int d2 =0;
		  
		  for(int k = 0; k < sector_row_index; k++)
		    d1 +=  block_hopping_operators[index].get_sector_matrix()[k][0].get_height();
		  d1 += i;
		  for(int k = 0; k < sector_column_index; k++)
		      d2 +=  block_hopping_operators[index].get_sector_matrix()[0][k].get_width();
		  d2 += j;
		  
		  double element =0;
		  element =  read_matrix[index].get_matrix_ptr()[d1][d2];
		  //cout<<element<<endl; 
		  block_hopping_operators[index].get_sector_matrix()[sector_row_index][sector_column_index].set_matrix_element(i, j, element);
		}//j
	      }//i
	  }//if
	}//sector_column_index
      }//sector_row_index      
    }//index

    delete [] top_line_no;
    top_line_no = NULL;
    delete [] bottom_line_no; 
    bottom_line_no = NULL;
    delete [] top_name;
    top_name = NULL;
    delete [] bottom_name; 
    bottom_name = NULL; 
    delete [] top_representation_index; 
    top_representation_index = NULL;
    delete [] bottom_representation_index;
    bottom_representation_index = NULL;
    delete [] top_sign;
    top_sign = NULL;
    delete [] bottom_sign;
    bottom_sign = NULL;
    delete [] top_matrix;
    top_matrix = NULL;
    delete [] bottom_matrix;
    bottom_matrix = NULL;

    for(int i=0; i<hopping_operator_no; i++){
      read_matrix[i].clear();
    }
    delete [] read_matrix;
    read_matrix = NULL;

    /*
    for(index=0; index<hopping_operator_no; index++){  

      cout<<block_hopping_operators[index].get_name()<<endl;
      cout<<block_hopping_operators[index].get_representation_index()<<endl;
      
  
      for (int sector_row=0; sector_row<block_sector_no; sector_row++){
	for (int sector_column=0; sector_column<block_sector_no; sector_column++){
	  if(block_hopping_operators[index].get_sector_matrix()[sector_row][sector_column].get_activation_state()){
	    cout<< "sector(" <<sector_row<<","<<sector_column<<") ";
	    cout<< " dimension= (" << block_sectors_properties_array[sector_row].dimension<<","<<block_sectors_properties_array[sector_column].dimension<<")"<<endl;
	    
	    for(int i=0;i<block_sectors_properties_array[sector_row].dimension; i++){
	      for(int j=0; j<block_sectors_properties_array[sector_column].dimension; j++){
		cout<<block_hopping_operators[index].get_sector_matrix()[sector_row][sector_column].get_matrix()[i][j]<<"\t";
	      }//j
	      cout<<endl;
	    }//i	    	    
	  }//if
	}//sector_column
      }//sector_row
    }//index
    */

}//read_hopping_operators_section


/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/


void read_spectral_operators_section(){

/*******************************************************************************
input variables:  none

output variables: none

return: void

What it does: 
     This routine reads all the spectral operators from the input.dat file.

How to call:
     void read_spectral_operators_section()
*******************************************************************************/
  



  if (block_spectral_operators != NULL){
    for(int i=0; i< spectral_operator_no; i++){
      block_spectral_operators[i].clear();
    }//for
    delete [] block_spectral_operators;
  }
  block_spectral_operators = NULL;


  if (new_block_spectral_operators != NULL){
    for(int i=0; i< spectral_operator_no; i++){
      new_block_spectral_operators[i].clear();
    }//for
    delete [] new_block_spectral_operators;
  }
  new_block_spectral_operators = NULL;


  block_spectral_operators = new quantum_operator[spectral_operator_no]; 
  new_block_spectral_operators = new quantum_operator[spectral_operator_no]; 

  for(int i=0; i<spectral_operator_no; i++){
    block_spectral_operators[i].activate(symmetry_no); 
    block_spectral_operators[i].allocate_sectors_matrix(block_sector_no); 
  }//i
  


  int matrix_size = 0;
  for (int i=0; i<block_sector_no; i++){
    matrix_size += block_sectors_properties_array[i].dimension; 
  }//i

  //allocate a matrix of size matrix size;

  
  dmatrix *read_matrix; 
  read_matrix = new dmatrix[spectral_operator_no]; 

  for (int i=0; i<spectral_operator_no; i++){
    read_matrix[i].allocate(matrix_size, matrix_size); 
  }//i


  fstream read_file("input.dat", ios::in); 
  fstream log_file("log_file", ios::out); 
 
  if( read_file == NULL ){
    printf("Error opening file 'input.dat'.\nError in routine read_spectral_operators_section()\nExiting...");
    exit(0);
  }//if

  if( log_file == NULL ){
    printf("Error opening file 'log_file'.\nError in routine read_spectral_operators_section()\nExiting");
    exit(0);
  }//if


  int  begin_line_no;
  int end_line_no; 
  int line_no=0; 
  int index = 0; 

  int *top_line_no; 
  int *bottom_line_no; 
  int *top_name; 
  int *bottom_name; 
  int *top_representation_index;
  int *bottom_representation_index; 
  int *top_matrix;
  int *bottom_matrix;
  int *top_sign;
  int * bottom_sign;
  
  top_line_no = new int[spectral_operator_no];
  bottom_line_no = new int[spectral_operator_no]; 

  top_name = new int[spectral_operator_no];
  bottom_name = new int[spectral_operator_no]; 
  top_representation_index = new int [spectral_operator_no]; 
  bottom_representation_index = new int [spectral_operator_no]; 

  top_sign = new int [spectral_operator_no];
  bottom_sign = new int [spectral_operator_no]; 

  top_matrix = new int [spectral_operator_no]; 
  bottom_matrix = new int [spectral_operator_no]; 
  
  while(!read_file.eof()){

    line_no++; 
    read_file.getline(buffer, buffer_size, '\n');
    word_offset = 0; 
    if(get_word(buffer, word, word_offset)){   
      
      if (strcmp(word, "<SECTION-SPECTRAL_OPERATORS>")==0){
	begin_line_no = line_no;       
      }//if

    
      if (strcmp(word, "</SECTION-SPECTRAL_OPERATORS>")==0){
	end_line_no = line_no;       
      }//if

      
      if (strcmp(word, "<SPECTRAL_OPERATOR>")==0){
	top_line_no [index] = line_no;       
      }//if

      if (strcmp(word, "<SPECTRAL_OPERATOR_NAME>")==0){
	top_name [index] = line_no;       
      }//if

      if (strcmp(word, "</SPECTRAL_OPERATOR_NAME>")==0){
	bottom_name [index] = line_no;       
      }//if

      if (strcmp(word, "<SPECTRAL_OPERATOR_REPRESENTATION_INDEX>")==0){
	top_representation_index [index] = line_no;       
      }//if

      if (strcmp(word, "</SPECTRAL_OPERATOR_REPRESENTATION_INDEX>")==0){
	bottom_representation_index [index] = line_no;       
      }//if

      if (strcmp(word, "<SPECTRAL_OPERATOR_SIGN>")==0){
	top_sign [index] = line_no;       
      }//if
      
      if (strcmp(word, "</SPECTRAL_OPERATOR_SIGN>")==0){
	bottom_sign [index] = line_no;       
      }//if

      if (strcmp(word, "<SPECTRAL_OPERATOR_MATRIX>")==0){
	top_matrix [index] = line_no;       
      }//if
      
      if (strcmp(word, "</SPECTRAL_OPERATOR_MATRIX>")==0){
	bottom_matrix [index] = line_no;       
      }//if
   
      if (strcmp(word, "</SPECTRAL_OPERATOR>")==0){
	bottom_line_no[index] = line_no;       
	index++; 
      }//if
      
    }//if get_word;     
  }//while eof; 

  //make sure we have the proper positions for the line_no's.

    read_file.close();
    read_file.clear();

    assert(index == spectral_operator_no); 

    assert(begin_line_no<top_line_no[0]);

    for(int i=0; i<index; i++){
      assert(top_line_no[i]<top_name[i]); 
      assert(top_line_no[i]<top_representation_index[i]); 
      assert(top_line_no[i]<top_matrix[i]); 
      assert(top_line_no[i]<top_sign[i]); 

      assert(top_line_no[i]<bottom_line_no[i]);


      assert (top_name[i]<bottom_name[i]); 
      assert (top_representation_index[i]<bottom_representation_index[i]);
      assert(top_matrix[i]<bottom_matrix[i]); 
      assert(top_sign[i]<bottom_sign[i]);
      
      assert(bottom_name[i]<bottom_line_no[i]); 
      assert(bottom_representation_index[i]<bottom_line_no[i]);
      assert(bottom_matrix[i]<bottom_line_no[i]);
      assert(bottom_sign[i]<bottom_line_no[i]); 

    }//int i 

    assert (bottom_line_no[index-1]<end_line_no); 

    
    for(index=0; index<spectral_operator_no; index++){

      read_file.open("input.dat", ios::in);
      if (!read_file.good()){
	printf("Error opening file 'input.dat'.\nError in routine read_spectral_operators_section().\nExiting...");
	exit(0);
      }//if

      line_no = 0; 
      int column_index=0; 
      int row_index =0; 

      while(!read_file.eof()){
	line_no++; 
	read_file.getline(buffer, buffer_size, '\n');
	word_offset = 0; 


	if(get_word(buffer, word, word_offset)){
	  if (word[0] == '#'){
	    continue; 
	  }//if

	  
	  if ((top_line_no[index]<line_no)&&(line_no<bottom_line_no[index])){
	    
	    if ((top_name[index]<line_no)&&(line_no<bottom_name[index])){
	      
	      word_offset = 0; 
	      if(!(get_word(buffer, word, word_offset))){
		error_message("reading block_spectral_operators name\n");
	      }//if
	      
	      block_spectral_operators[index].set_name(word);

	      //cout<<block_spectral_operators[index].get_name(); 

	    }//top_name

	  

	    if ((top_representation_index[index]<line_no)&&(line_no<bottom_representation_index[index])){

	      word_offset = 0;	   

	      for(int i = 0; i < symmetry_no; i++){

		if(!(get_word(buffer, word, word_offset))){
		  error_message("reading the representation indices of the spectral_operators.\nError in read_spectral_operators_section()\n.Exiting...\n");
		}
		
		int representation_index_in =atoi(word);
		
		// We check if the quantum numbers of the states are in the allowed range. 

		if((representation_index_in > symmetry_types[i].get_max_representation_index()) ||
		   (representation_index_in < symmetry_types[i].get_min_representation_index())){
		  error_message("checking the quantum numbers of the spectral operators.\nThey are not in the allowed range");
		}//if

		else{		  
		  block_spectral_operators[index].set_representation_index(i,representation_index_in);
		  //cout<<block_spectral_operators[index].get_representation_index(i)<<endl; 
		}//else
	    }//i	      	      
	    }//if top_representation_index

	    //now we read in the sign of the spectral operator. 
	    
	    if ((top_sign[index]<line_no)&&(line_no<bottom_sign[index])){
	      
	      word_offset = 0; 
	      if(!(get_word(buffer, word, word_offset))){
		error_message("reading block_spectral_operators sign\n");
	      }//if
	      
	      block_spectral_operators[index].set_sgn(atoi(word));

	    }//top_sign


	    //now we read the matrix for the spectral operator
	    

	    if ((top_matrix[index]<line_no)&&(line_no<bottom_matrix[index])){
	      word_offset = 0; 

	      for(column_index=0; column_index<matrix_size; column_index++){
		
		if(!(get_word(buffer, word, word_offset))){
		  error_message("reading the quantum numbers of the spectral operators.\nError in read_spectral_operators_section()\n.Exiting...\n");
		}//if		  
		read_matrix[index].set_matrix_element(row_index, column_index, atof(word)); 		  
		//cout<<read_matrix[index].get_matrix_ptr()[row_index][column_index]<<"  ";
	      }//row_index
	      //cout<<endl;
	      row_index++; 

	    }//if top_matrix
	    //cout<<column_index<<endl;
	  }//if top_line	  
	}//if get_word; 

      }//while(read_file.eof)
      assert(row_index==matrix_size); 
      read_file.close(); 
      read_file.clear();
    }//for index.


    /*
    for(int i=0; i<matrix_size; i++){
	  for(int j=0; j<matrix_size; j++){
	    cout<<read_matrix.get_matrix_ptr()[i][j]<<"  ";
	  }//for column
	  cout<<endl;
    }//for row
    */

    log_file.close();
    log_file.clear();

    
    //now the operators are set. 

    for(index=0; index<spectral_operator_no; index++){
      
      for(int sector_row_index = 0; sector_row_index < block_sector_no; sector_row_index++){
	for(int sector_column_index = 0; sector_column_index < block_sector_no; sector_column_index++){
	  

	  block_spectral_operators[index].get_sector_matrix()[sector_row_index][sector_column_index].set_size(block_sectors_properties_array[sector_row_index].dimension, block_sectors_properties_array[sector_column_index].dimension);
	  
	  if(grand_selection_rule(symmetry_no, symmetry_types, block_sectors_properties_array[sector_column_index].representation_index,
				  block_spectral_operators[index].get_representation_index(), block_sectors_properties_array[sector_row_index].representation_index)){
	    
	    block_spectral_operators[index].get_sector_matrix()[sector_row_index][sector_column_index].activate(symmetry_no);

	    block_spectral_operators[index].get_sector_matrix()[sector_row_index][sector_column_index].set_representation_index(0, block_sectors_properties_array[sector_row_index].representation_index);
	    block_spectral_operators[index].get_sector_matrix()[sector_row_index][sector_column_index].set_representation_index(1, block_sectors_properties_array[sector_column_index].representation_index);
	    block_spectral_operators[index].get_sector_matrix()[sector_row_index][sector_column_index].allocate_matrix();
	    
	    int size_height = block_spectral_operators[index].get_sector_matrix()[sector_row_index][sector_column_index].get_height();
	    int size_width = block_spectral_operators[index].get_sector_matrix()[sector_row_index][sector_column_index].get_width();
	    
	    
	      for(int i = 0; i < size_height; i++){
		for(int j = 0; j < size_width; j++){
		  
		  int d1 =0;
		  int d2 =0;
		  
		  for(int k = 0; k < sector_row_index; k++)
		    d1 +=  block_spectral_operators[index].get_sector_matrix()[k][0].get_height();
		  d1 += i;
		  for(int k = 0; k < sector_column_index; k++)
		      d2 +=  block_spectral_operators[index].get_sector_matrix()[0][k].get_width();
		  d2 += j;
		  
		  double element =0;
		  element =  read_matrix[index].get_matrix_ptr()[d1][d2];
		  //cout<<element<<endl; 
		  block_spectral_operators[index].get_sector_matrix()[sector_row_index][sector_column_index].set_matrix_element(i, j, element);
		}//j
	      }//i
	  }//if
	}//sector_column_index
      }//sector_row_index      
    }//index

    delete [] top_line_no;
    top_line_no = NULL;
    delete [] bottom_line_no; 
    bottom_line_no = NULL;
    delete [] top_name;
    top_name = NULL;
    delete [] bottom_name; 
    bottom_name = NULL;
    delete [] top_representation_index; 
    top_representation_index = NULL;
    delete [] bottom_representation_index;
    bottom_representation_index = NULL;
    delete [] top_matrix;
    top_matrix = NULL;
    delete [] bottom_matrix;
    bottom_matrix = NULL;
    delete [] top_sign; 
    top_sign = NULL;
    delete [] bottom_sign; 
    bottom_sign = NULL;

    for(int i=0; i<spectral_operator_no; i++){
      read_matrix[i].clear();
    }
    delete [] read_matrix;
    read_matrix = NULL;
    

    /*
    for(index=0; index<spectral_operator_no; index++){  

      cout<<block_spectral_operators[index].get_name()<<endl;
      cout<<block_spectral_operators[index].get_representation_index()<<endl;
      
  
      for (int sector_row=0; sector_row<block_sector_no; sector_row++){
	for (int sector_column=0; sector_column<block_sector_no; sector_column++){
	  if(block_spectral_operators[index].get_sector_matrix()[sector_row][sector_column].get_activation_state()){
	    cout<< "sector(" <<sector_row<<","<<sector_column<<") ";
	    cout<< " dimension= (" << block_sectors_dimension[sector_row]<<","<<block_sectors_dimension[sector_column]<<")"<<endl;
	    
	    for(int i=0;i<block_sectors_dimension[sector_row]; i++){
	      for(int j=0; j<block_sectors_dimension[sector_column]; j++){
		cout<<block_spectral_operators[index].get_sector_matrix()[sector_row][sector_column].get_matrix()[i][j]<<"\t";
	      }//j
	      cout<<endl;
	    }//i	    	    
	  }//if
	}//sector_column
      }//sector_row
    }//index
*/
}//read_spectral_operators_section







/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/


void read_static_operators_section(){

/*******************************************************************************
input variables:  none

output variables: none

return: void

What it does: 
     This routine reads all the static operators from the input.dat file.

How to call:
     void read_static_operators_section()
*******************************************************************************/
  
  if (block_static_operators != NULL){
    for(int i=0; i< static_operator_no; i++){
      block_static_operators[i].clear();
    }//for
    delete [] block_static_operators;
  }
  block_static_operators = NULL;
  
  

  if (new_block_static_operators != NULL){
    for(int i=0; i< static_operator_no; i++){
      new_block_static_operators[i].clear();
    }//for
    delete [] new_block_static_operators;
  }
  new_block_static_operators = NULL;



  block_static_operators = new quantum_operator[static_operator_no]; 
  new_block_static_operators = new quantum_operator[static_operator_no]; 

  for(int i=0; i<static_operator_no; i++){
    block_static_operators[i].activate(symmetry_no); 
    block_static_operators[i].allocate_sectors_matrix(block_sector_no); 
  }//i
  
  int matrix_size = 0;
  for (int i=0; i<block_sector_no; i++){
    matrix_size += block_sectors_properties_array[i].dimension; 
  }//i

  //allocate a matrix of size matrix size;

  
  dmatrix *read_matrix; 
  read_matrix = new dmatrix[static_operator_no]; 

  for (int i=0; i<static_operator_no; i++){
    read_matrix[i].allocate(matrix_size, matrix_size); 
  }//i

  


  fstream read_file("input.dat", ios::in); 
  fstream log_file("log_file", ios::out); 
 
  if( read_file == NULL ){
    printf("Error opening file 'input.dat'.\nError in routine read_static_operators_section()\nExiting...");
    exit(0);
  }//if

  if( log_file == NULL ){
    printf("Error opening file 'log_file'.\nError in routine read_static_operators_section()\nExiting");
    exit(0);
  }//if


  int  begin_line_no;
  int end_line_no; 
  int line_no=0; 
  int index = 0; 

  int *top_line_no; 
  int *bottom_line_no; 
  int *top_name; 
  int *bottom_name; 
  int *top_representation_index;
  int *bottom_representation_index; 
  int *top_matrix;
  int *bottom_matrix;
  int *top_sign;
  int * bottom_sign;
  
  top_line_no = new int[static_operator_no];
  bottom_line_no = new int[static_operator_no]; 

  top_name = new int[static_operator_no];
  bottom_name = new int[static_operator_no]; 
  top_representation_index = new int [static_operator_no]; 
  bottom_representation_index = new int [static_operator_no]; 

  top_sign = new int [static_operator_no];
  bottom_sign = new int [static_operator_no]; 

  top_matrix = new int [static_operator_no]; 
  bottom_matrix = new int [static_operator_no]; 
  
  while(!read_file.eof()){

    line_no++; 
    read_file.getline(buffer, buffer_size, '\n');
    word_offset = 0; 
    if(get_word(buffer, word, word_offset)){   
      
      if (strcmp(word, "<SECTION-STATIC_OPERATORS>")==0){
	begin_line_no = line_no;       
      }//if

    
      if (strcmp(word, "</SECTION-STATIC_OPERATORS>")==0){
	end_line_no = line_no;       
      }//if

      
      if (strcmp(word, "<STATIC_OPERATOR>")==0){
	top_line_no [index] = line_no;       
      }//if

      if (strcmp(word, "<STATIC_OPERATOR_NAME>")==0){
	top_name [index] = line_no;       
      }//if

      if (strcmp(word, "</STATIC_OPERATOR_NAME>")==0){
	bottom_name [index] = line_no;       
      }//if

      if (strcmp(word, "<STATIC_OPERATOR_REPRESENTATION_INDEX>")==0){
	top_representation_index [index] = line_no;       
      }//if

      if (strcmp(word, "</STATIC_OPERATOR_REPRESENTATION_INDEX>")==0){
	bottom_representation_index [index] = line_no;       
      }//if

      if (strcmp(word, "<STATIC_OPERATOR_SIGN>")==0){
	top_sign [index] = line_no;       
      }//if
      
      if (strcmp(word, "</STATIC_OPERATOR_SIGN>")==0){
	bottom_sign [index] = line_no;       
      }//if

      if (strcmp(word, "<STATIC_OPERATOR_MATRIX>")==0){
	top_matrix [index] = line_no;       
      }//if
      
      if (strcmp(word, "</STATIC_OPERATOR_MATRIX>")==0){
	bottom_matrix [index] = line_no;       
      }//if
   
      if (strcmp(word, "</STATIC_OPERATOR>")==0){
	bottom_line_no[index] = line_no;       
	index++; 
      }//if
      
    }//if get_word;     
  }//while eof; 

  //make sure we have the proper positions for the line_no's.

    read_file.close();
    read_file.clear();

    assert(index == static_operator_no); 

    assert(begin_line_no<top_line_no[0]);

    for(int i=0; i<index; i++){
      assert(top_line_no[i]<top_name[i]); 
      assert(top_line_no[i]<top_representation_index[i]); 
      assert(top_line_no[i]<top_matrix[i]); 
      assert(top_line_no[i]<top_sign[i]); 

      assert(top_line_no[i]<bottom_line_no[i]);


      assert (top_name[i]<bottom_name[i]); 
      assert (top_representation_index[i]<bottom_representation_index[i]);
      assert(top_matrix[i]<bottom_matrix[i]); 
      assert(top_sign[i]<bottom_sign[i]);
      
      assert(bottom_name[i]<bottom_line_no[i]); 
      assert(bottom_representation_index[i]<bottom_line_no[i]);
      assert(bottom_matrix[i]<bottom_line_no[i]);
      assert(bottom_sign[i]<bottom_line_no[i]); 

    }//int i 

    assert (bottom_line_no[index-1]<end_line_no); 

    
    for(index=0; index<static_operator_no; index++){

      read_file.open("input.dat", ios::in);
      if (!read_file.good()){
	printf("Error opening file 'input.dat'.\nError in routine read_static_operators_section().\nExiting...");
	exit(0);
      }//if

      line_no = 0; 
      int column_index=0; 
      int row_index =0; 

      while(!read_file.eof()){
	line_no++; 
	read_file.getline(buffer, buffer_size, '\n');
	word_offset = 0; 


	if(get_word(buffer, word, word_offset)){
	  if (word[0] == '#'){
	    continue; 
	  }//if

	  
	  if ((top_line_no[index]<line_no)&&(line_no<bottom_line_no[index])){
	    
	    if ((top_name[index]<line_no)&&(line_no<bottom_name[index])){
	      
	      word_offset = 0; 
	      if(!(get_word(buffer, word, word_offset))){
		error_message("reading block_static_operators name\n");
	      }//if
	      
	      block_static_operators[index].set_name(word);

	      //cout<<block_static_operators[index].get_name(); 

	    }//top_name

	  

	    if ((top_representation_index[index]<line_no)&&(line_no<bottom_representation_index[index])){

	      word_offset = 0;	   

	      for(int i = 0; i < symmetry_no; i++){

		if(!(get_word(buffer, word, word_offset))){
		  error_message("reading the representation indices of the static_operators.\nError in read_static_operators_section()\n.Exiting...\n");
		}
		
		int representation_index_in =atoi(word);
		
		// We check if the quantum numbers of the states are in the allowed range. 

		if((representation_index_in > symmetry_types[i].get_max_representation_index()) ||
		   (representation_index_in < symmetry_types[i].get_min_representation_index())){
		  error_message("checking the quantum numbers of the static operators.\nThey are not in the allowed range");
		}//if

		else{		  
		  block_static_operators[index].set_representation_index(i,representation_index_in);
		  //cout<<block_static_operators[index].get_representation_index(i)<<endl; 
		}//else
	    }//i	      	      
	    }//if top_representation_index

	    //now we read in the sign of the static operator. 
	    
	    if ((top_sign[index]<line_no)&&(line_no<bottom_sign[index])){
	      
	      word_offset = 0; 
	      if(!(get_word(buffer, word, word_offset))){
		error_message("reading block_static_operators sign\n");
	      }//if
	      
	      block_static_operators[index].set_sgn(atoi(word));

	    }//top_sign


	    //now we read the matrix for the static operator
	    

	    if ((top_matrix[index]<line_no)&&(line_no<bottom_matrix[index])){
	      word_offset = 0; 

	      for(column_index=0; column_index<matrix_size; column_index++){
		
		if(!(get_word(buffer, word, word_offset))){
		  error_message("reading the quantum numbers of the static operators.\nError in read_static_operators_section()\n.Exiting...\n");
		}//if		  
		read_matrix[index].set_matrix_element(row_index, column_index, atof(word)); 		  
		//cout<<read_matrix[index].get_matrix_ptr()[row_index][column_index]<<"  ";
	      }//row_index
	      //cout<<endl;
	      row_index++; 

	    }//if top_matrix
	    //cout<<column_index<<endl;
	  }//if top_line	  
	}//if get_word; 

      }//while(read_file.eof)
      assert(row_index==matrix_size); 
      read_file.close(); 
      read_file.clear();
    }//for index.


    /*
    for(int i=0; i<matrix_size; i++){
	  for(int j=0; j<matrix_size; j++){
	    cout<<read_matrix.get_matrix_ptr()[i][j]<<"  ";
	  }//for column
	  cout<<endl;
    }//for row
    */

    log_file.close();
    log_file.clear();

    
    //now the operators are set. 

    for(index=0; index<static_operator_no; index++){
      
      for(int sector_row_index = 0; sector_row_index < block_sector_no; sector_row_index++){
	for(int sector_column_index = 0; sector_column_index < block_sector_no; sector_column_index++){
	  

	  block_static_operators[index].get_sector_matrix()[sector_row_index][sector_column_index].set_size(block_sectors_properties_array[sector_row_index].dimension, block_sectors_properties_array[sector_column_index].dimension);
	  
	  if(grand_selection_rule(symmetry_no, symmetry_types, block_sectors_properties_array[sector_column_index].representation_index,
				  block_static_operators[index].get_representation_index(), block_sectors_properties_array[sector_row_index].representation_index)){
	    
	    block_static_operators[index].get_sector_matrix()[sector_row_index][sector_column_index].activate(symmetry_no);

	    block_static_operators[index].get_sector_matrix()[sector_row_index][sector_column_index].set_representation_index(0, block_sectors_properties_array[sector_row_index].representation_index);
	    block_static_operators[index].get_sector_matrix()[sector_row_index][sector_column_index].set_representation_index(1, block_sectors_properties_array[sector_column_index].representation_index);
	    block_static_operators[index].get_sector_matrix()[sector_row_index][sector_column_index].allocate_matrix();
	    
	    int size_height = block_static_operators[index].get_sector_matrix()[sector_row_index][sector_column_index].get_height();
	    int size_width = block_static_operators[index].get_sector_matrix()[sector_row_index][sector_column_index].get_width();
	    
	    
	      for(int i = 0; i < size_height; i++){
		for(int j = 0; j < size_width; j++){
		  
		  int d1 =0;
		  int d2 =0;
		  
		  for(int k = 0; k < sector_row_index; k++)
		    d1 +=  block_static_operators[index].get_sector_matrix()[k][0].get_height();
		  d1 += i;
		  for(int k = 0; k < sector_column_index; k++)
		      d2 +=  block_static_operators[index].get_sector_matrix()[0][k].get_width();
		  d2 += j;
		  
		  double element =0;
		  element =  read_matrix[index].get_matrix_ptr()[d1][d2];
		  //cout<<element<<endl; 
		  block_static_operators[index].get_sector_matrix()[sector_row_index][sector_column_index].set_matrix_element(i, j, element);
		}//j
	      }//i
	  }//if
	}//sector_column_index
      }//sector_row_index      
    }//index

    delete [] top_line_no;
    top_line_no = NULL;
    delete [] bottom_line_no; 
    bottom_line_no = NULL;
    delete [] top_name;
    top_name = NULL;
    delete [] bottom_name; 
    bottom_name = NULL;
    delete [] top_representation_index; 
    top_representation_index = NULL;
    delete [] bottom_representation_index;
    bottom_representation_index = NULL;
    delete [] top_matrix;
    top_matrix = NULL;
    delete [] bottom_matrix;
    bottom_matrix = NULL;
    delete [] top_sign; 
    top_sign = NULL;
    delete [] bottom_sign; 
    bottom_sign = NULL;
    for(int i=0; i<static_operator_no; i++){
      read_matrix[i].clear();
    }
    delete [] read_matrix ; 
    read_matrix = NULL;

    /*
    for(index=0; index<static_operator_no; index++){  

      cout<<block_static_operators[index].get_name()<<endl;
      cout<<block_static_operators[index].get_representation_index()<<endl;
      
  
      for (int sector_row=0; sector_row<block_sector_no; sector_row++){
	for (int sector_column=0; sector_column<block_sector_no; sector_column++){
	  if(block_static_operators[index].get_sector_matrix()[sector_row][sector_column].get_activation_state()){
	    cout<< "sector(" <<sector_row<<","<<sector_column<<") ";
	    cout<< " dimension= (" << block_sectors_dimension[sector_row]<<","<<block_sectors_dimension[sector_column]<<")"<<endl;
	    
	    for(int i=0;i<block_sectors_dimension[sector_row]; i++){
	      for(int j=0; j<block_sectors_dimension[sector_column]; j++){
		cout<<block_static_operators[index].get_sector_matrix()[sector_row][sector_column].get_matrix()[i][j]<<"\t";
	      }//j
	      cout<<endl;
	    }//i	    	    
	  }//if
	}//sector_column
      }//sector_row
    }//index
*/
}//read_static_operators_section


/*----------------------------------------------------------------------------*/







/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/


void read_local_hopping_operators_section(){

/*******************************************************************************
input variables:  none

output variables: none

return: void

What it does: 
     This routine reads all the local hopping  operators from the input.dat 
     file.
How to call:
     void read_local_hopping_operators_section()

*******************************************************************************/
  
  if (local_hopping_operators != NULL){
    for(int i=0; i< hopping_operator_no; i++){
      local_hopping_operators[i].clear();
    }//for
    delete [] local_hopping_operators;
  }
  local_hopping_operators = NULL;


  if (local_hopping_hamiltonians !=NULL){
    for(int i=0; i<hopping_operator_no; i++){
      local_hopping_hamiltonians[i].clear();
    }//for
    delete [] local_hopping_hamiltonians;
  }
  local_hopping_hamiltonians = NULL;


  local_hopping_operators = new quantum_operator[hopping_operator_no]; 

  local_hopping_hamiltonians = new quantum_operator[hopping_operator_no];  

  for(int i=0; i<hopping_operator_no; i++){
    local_hopping_operators[i].activate(symmetry_no); 
    local_hopping_operators[i].allocate_sectors_matrix(local_sector_no); 

    local_hopping_hamiltonians[i].activate(symmetry_no); 
    local_hopping_hamiltonians[i].allocate_sectors_matrix(local_sector_no); 

    // we set the representation indices to zero for the local_hopping_hamiltonians.

    for(int symmetry_index = 0; symmetry_index < symmetry_no; symmetry_index++){
      local_hopping_hamiltonians[i].set_representation_index(symmetry_index,0); 
    }//for symmetry_index 
  }//i

  int matrix_size = 0;
  for (int i=0; i<local_sector_no; i++){
    matrix_size += local_sectors_properties_array[i].dimension; 
  }//i

  //allocate a matrix of size matrix size;

  
  dmatrix *read_matrix; 
  read_matrix = new dmatrix[hopping_operator_no]; 

  for (int i=0; i<hopping_operator_no; i++){
    read_matrix[i].allocate(matrix_size, matrix_size); 
  }//i


  dmatrix *read_on_site_energy_matrix; 
  read_on_site_energy_matrix = new dmatrix[hopping_operator_no]; 
  for (int i=0; i<hopping_operator_no; i++){
    read_on_site_energy_matrix[i].allocate(matrix_size, matrix_size); 
  }//i
  

  fstream read_file("input.dat", ios::in); 
  fstream log_file("log_file", ios::out); 
 
  if( read_file == NULL ){
    printf("Error opening file 'input.dat'.\nError in routine read_local_hopping_operators_section()\nExiting...");
    exit(0);
  }//if

  if( log_file == NULL ){
    printf("Error opening file 'log_file'.\nError in routine read_local_hopping_operators_section()\nExiting");
    exit(0);
  }//if


  int  begin_line_no;
  int end_line_no; 
  int line_no=0; 
  int index = 0; 

  int *top_line_no; 
  int *bottom_line_no; 
  int *top_name; 
  int *bottom_name; 
  int *top_representation_index;
  int *bottom_representation_index; 
  int *top_matrix;
  int *bottom_matrix;
  int *top_on_site_energy_matrix;
  int *bottom_on_site_energy_matrix;
  int *top_sign;
  int *bottom_sign; 
  
  top_line_no = new int[hopping_operator_no];
  bottom_line_no = new int[hopping_operator_no]; 

  top_name = new int[hopping_operator_no];
  bottom_name = new int[hopping_operator_no]; 
  top_representation_index = new int [hopping_operator_no]; 
  bottom_representation_index = new int [hopping_operator_no]; 
  top_matrix = new int [hopping_operator_no]; 
  bottom_matrix = new int [hopping_operator_no]; 
  top_on_site_energy_matrix = new int [hopping_operator_no]; 
  bottom_on_site_energy_matrix = new int [hopping_operator_no]; 
  top_sign = new int [hopping_operator_no]; 
  bottom_sign = new int [hopping_operator_no]; 

  
  while(!read_file.eof()){

    line_no++; 
    read_file.getline(buffer, buffer_size, '\n');
    word_offset = 0; 
    if(get_word(buffer, word, word_offset)){   
      
      if (strcmp(word, "<SECTION-LOCAL_HOPPING_OPERATORS>")==0){
	begin_line_no = line_no;       
      }//if
    
      if (strcmp(word, "</SECTION-LOCAL_HOPPING_OPERATORS>")==0){
	end_line_no = line_no;       
      }//if

      
      if (strcmp(word, "<LOCAL_HOPPING_OPERATOR>")==0){
	top_line_no [index] = line_no;       
      }//if

      if (strcmp(word, "<LOCAL_HOPPING_OPERATOR_NAME>")==0){
	top_name [index] = line_no;       
      }//if

      if (strcmp(word, "</LOCAL_HOPPING_OPERATOR_NAME>")==0){
	bottom_name [index] = line_no;       
      }//if

      if (strcmp(word, "<LOCAL_HOPPING_OPERATOR_REPRESENTATION_INDEX>")==0){
	top_representation_index [index] = line_no;       
      }//if

      if (strcmp(word, "</LOCAL_HOPPING_OPERATOR_REPRESENTATION_INDEX>")==0){
	bottom_representation_index [index] = line_no;       
      }//if

      if (strcmp(word, "<LOCAL_HOPPING_OPERATOR_SIGN>")==0){
	top_sign [index] = line_no;       
      }//if
      
      if (strcmp(word, "</LOCAL_HOPPING_OPERATOR_SIGN>")==0){
	bottom_sign [index] = line_no;       
      }//if

      if (strcmp(word, "<LOCAL_HOPPING_OPERATOR_MATRIX>")==0){
	top_matrix [index] = line_no;       
      }//if
      
      if (strcmp(word, "</LOCAL_HOPPING_OPERATOR_MATRIX>")==0){
	bottom_matrix [index] = line_no;       
      }//if

      if (strcmp(word, "<LOCAL_ON_SITE_ENERGY_MATRIX>")==0){
	top_on_site_energy_matrix [index] = line_no;       
      }//if
      
      if (strcmp(word, "</LOCAL_ON_SITE_ENERGY_MATRIX>")==0){
	bottom_on_site_energy_matrix [index] = line_no;       
      }//if
   
      if (strcmp(word, "</LOCAL_HOPPING_OPERATOR>")==0){
	bottom_line_no[index] = line_no;       
	index++; 
      }//if
      
    }//if get_word;     
  }//while eof; 



  //make sure we have the proper positions for the line_no's.

    read_file.close();
    read_file.clear();

    assert(index == hopping_operator_no); 

    assert(begin_line_no<top_line_no[0]);

    for(int i=0; i<index; i++){
      assert(top_line_no[i]<top_name[i]); 
      assert(top_line_no[i]<top_representation_index[i]); 
      assert(top_line_no[i]<top_matrix[i]); 
      assert(top_line_no[i]<top_sign[i]); 

      assert(top_line_no[i]<bottom_line_no[i]);

      assert (top_name[i]<bottom_name[i]); 
      assert (top_representation_index[i]<bottom_representation_index[i]);
      assert(top_matrix[i]<bottom_matrix[i]); 
      assert(top_on_site_energy_matrix[i]<bottom_on_site_energy_matrix[i]);
      assert(top_sign[i]<bottom_sign[i]); 
      
      assert(bottom_name[i]<bottom_line_no[i]); 
      assert(bottom_representation_index[i]<bottom_line_no[i]);
      assert(bottom_matrix[i]<bottom_line_no[i]);
      assert(bottom_on_site_energy_matrix[i]<bottom_line_no[i]); 
      assert(bottom_sign[i]<bottom_line_no[i]); 

    }//int i 

    assert (bottom_line_no[index-1]<end_line_no); 

    
    for(index=0; index<hopping_operator_no; index++){

      read_file.open("input.dat", ios::in);
      if (!read_file.good()){
	printf("Error opening file 'input.dat'.\nError in routine read_local_hopping_operators_section().\nExiting...");
	exit(0);
      }//if

      line_no = 0; 
      int column_index=0; 
      int row_index =0; 
      int column_hamiltonian_index=0; 
      int row_hamiltonian_index=0;




      while(!read_file.eof()){
	line_no++; 
	read_file.getline(buffer, buffer_size, '\n');
	word_offset = 0; 


	if(get_word(buffer, word, word_offset)){
	  if (word[0] == '#'){
	    continue; 
	  }//if
	  
	  if ((top_line_no[index]<line_no)&&(line_no<bottom_line_no[index])){
	    
	    if ((top_name[index]<line_no)&&(line_no<bottom_name[index])){
	      
	      word_offset = 0; 
	      if(!(get_word(buffer, word, word_offset))){
		error_message("reading local_hopping_operators name\n");
	      }//if
	      
	      local_hopping_operators[index].set_name(word);

	      //cout<<local_hopping_operators[index].get_name(); 
	      char local_hopping_hamiltonian_name[256]; 
	      strcpy(local_hopping_hamiltonian_name, "hopping_hamiltonian_"); 
	      strcat(local_hopping_hamiltonian_name, word); 
	      local_hopping_hamiltonians[index].set_name(local_hopping_hamiltonian_name);

	    }//top_name

	  

	    if ((top_representation_index[index]<line_no)&&(line_no<bottom_representation_index[index])){

	      word_offset = 0;	   

	      for(int i = 0; i < symmetry_no; i++){

		if(!(get_word(buffer, word, word_offset))){
		  error_message("reading the representation indices of the operators.\nError in read_local_hopping_operators_section()\n.Exiting...\n");
		}
		
		int representation_index_in =atoi(word);
		
		// We check if the quantum numbers of the states are in the allowed range. 

		if((representation_index_in > symmetry_types[i].get_max_representation_index()) ||
		   (representation_index_in < symmetry_types[i].get_min_representation_index())){
		  error_message("checking the quantum numbers of the local hopping operators.\nThey are not in the allowed range");
		}//if

		else{		  
		  local_hopping_operators[index].set_representation_index(i,representation_index_in);
		  //cout<<local_hopping_operators[index].get_representation_index(i)<<endl; 
		}//else
	    }//i	      	      
	    }//if top_representation_index


	    //we read in the sign of the operator. 

	    if ((top_sign[index]<line_no)&&(line_no<bottom_sign[index])){
	      
	      word_offset = 0; 
	      if(!(get_word(buffer, word, word_offset))){
		error_message("reading local_hopping_operators sign\n");
	      }//if
	      
	      local_hopping_operators[index].set_sgn(atoi(word));

	    }//top_sign

	    
	    //now we read the matrix for the local_hopping_operators.  
	    

	    
	    if ((top_matrix[index]<line_no)&&(line_no<bottom_matrix[index])){
	      //row_index=0;
	      //column_index=0; 

	      word_offset = 0; 

	      for(column_index=0; column_index<matrix_size; column_index++){
		
		if(!(get_word(buffer, word, word_offset))){
		  error_message("reading the hopping operators matrix elements.\nError in read_local_hopping_operators_section()\n.Exiting...\n");
		}//if		  
		read_matrix[index].set_matrix_element(row_index, column_index, atof(word)); 		  
		//cout<<read_matrix[index].get_matrix_ptr()[row_index][column_index]<<"  ";
	      }//row_index
	      //cout<<endl;
	      row_index++; 
	    }//if top_matrix
	 
	    
	    if ((top_on_site_energy_matrix[index]<line_no)&&(line_no<bottom_on_site_energy_matrix[index])){
	      word_offset = 0; 

	      for(column_hamiltonian_index=0; column_hamiltonian_index<matrix_size; column_hamiltonian_index++){
		
		if(!(get_word(buffer, word, word_offset))){
		  error_message("reading the local_hopping_matrix elements in read_local_hopping_operators_section()\n.Exiting...\n");
		}//if		  
		read_on_site_energy_matrix[index].set_matrix_element(row_hamiltonian_index, column_hamiltonian_index, atof(word)); 		  
		//cout<<read_on_site_energy_matrix[index].get_matrix_ptr()[row_index][column_index]<<"  ";
		
	      }//row_index
	      //cout<<endl;
	      row_hamiltonian_index++; 
	    }//if top_on_site_energy_matrix
	    
	  }//if top_line	  
	    
	}//if get_word; 

      }//while(read_file.eof)
      assert(row_index==matrix_size); 
      assert(row_hamiltonian_index==matrix_size); 
      read_file.close(); 
      read_file.clear();
    }//for index.


    /*
    for(int i=0; i<matrix_size; i++){
	  for(int j=0; j<matrix_size; j++){
	    cout<<read_matrix.get_matrix_ptr()[i][j]<<"  ";
	  }//for column
	  cout<<endl;
    }//for row
    */

    log_file.close();
    log_file.clear();
    
    //now the operators are set. 

    for(index=0; index<hopping_operator_no; index++){
      
      for(int sector_row_index = 0; sector_row_index < local_sector_no; sector_row_index++){
	for(int sector_column_index = 0; sector_column_index < local_sector_no; sector_column_index++){
	  

	  local_hopping_operators[index].get_sector_matrix()[sector_row_index][sector_column_index].set_size(local_sectors_properties_array[sector_row_index].dimension,local_sectors_properties_array[sector_column_index].dimension);
	  
	  if(grand_selection_rule(symmetry_no, symmetry_types, local_sectors_properties_array[sector_column_index].representation_index,
				  local_hopping_operators[index].get_representation_index(), local_sectors_properties_array[sector_row_index].representation_index)){
	    
	    local_hopping_operators[index].get_sector_matrix()[sector_row_index][sector_column_index].activate(symmetry_no);

	    local_hopping_operators[index].get_sector_matrix()[sector_row_index][sector_column_index].set_representation_index(0, local_sectors_properties_array[sector_row_index].representation_index);
	    local_hopping_operators[index].get_sector_matrix()[sector_row_index][sector_column_index].set_representation_index(1, local_sectors_properties_array[sector_column_index].representation_index);
	    local_hopping_operators[index].get_sector_matrix()[sector_row_index][sector_column_index].allocate_matrix();
	    
	    int size_height = local_hopping_operators[index].get_sector_matrix()[sector_row_index][sector_column_index].get_height();
	    int size_width = local_hopping_operators[index].get_sector_matrix()[sector_row_index][sector_column_index].get_width();
	    
	    
	      for(int i = 0; i < size_height; i++){
		for(int j = 0; j < size_width; j++){
		  
		  int d1 =0;
		  int d2 =0;
		  
		  for(int k = 0; k < sector_row_index; k++)
		    d1 +=  local_hopping_operators[index].get_sector_matrix()[k][0].get_height();
		  d1 += i;
		  for(int k = 0; k < sector_column_index; k++)
		      d2 +=  local_hopping_operators[index].get_sector_matrix()[0][k].get_width();
		  d2 += j;
		  
		  double element =0;
		  element =  read_matrix[index].get_matrix_ptr()[d1][d2];
		  //cout<<element<<endl; 
		  local_hopping_operators[index].get_sector_matrix()[sector_row_index][sector_column_index].set_matrix_element(i, j, element);
		}//j
	      }//i
	  }//if
	}//sector_column_index
      }//sector_row_index      
    }//index




    //now we set-up the local_hopping_hamiltonians. 


    for(index=0; index<hopping_operator_no; index++){
      
      for(int sector_row_index = 0; sector_row_index < local_sector_no; sector_row_index++){
	for(int sector_column_index = 0; sector_column_index < local_sector_no; sector_column_index++){
	  

	  local_hopping_hamiltonians[index].get_sector_matrix()[sector_row_index][sector_column_index].set_size(local_sectors_properties_array[sector_row_index].dimension,local_sectors_properties_array[sector_column_index].dimension);
	  
	  if(grand_selection_rule(symmetry_no, symmetry_types, local_sectors_properties_array[sector_column_index].representation_index,
				  local_hopping_hamiltonians[index].get_representation_index(), local_sectors_properties_array[sector_row_index].representation_index)){
	    
	    local_hopping_hamiltonians[index].get_sector_matrix()[sector_row_index][sector_column_index].activate(symmetry_no);

	    local_hopping_hamiltonians[index].get_sector_matrix()[sector_row_index][sector_column_index].set_representation_index(0, local_sectors_properties_array[sector_row_index].representation_index);
	    local_hopping_hamiltonians[index].get_sector_matrix()[sector_row_index][sector_column_index].set_representation_index(1, local_sectors_properties_array[sector_column_index].representation_index);
	    local_hopping_hamiltonians[index].get_sector_matrix()[sector_row_index][sector_column_index].allocate_matrix();
	    
	    int size_height = local_hopping_hamiltonians[index].get_sector_matrix()[sector_row_index][sector_column_index].get_height();
	    int size_width = local_hopping_hamiltonians[index].get_sector_matrix()[sector_row_index][sector_column_index].get_width();
	    
	    
	      for(int i = 0; i < size_height; i++){
		for(int j = 0; j < size_width; j++){
		  
		  int d1 =0;
		  int d2 =0;
		  
		  for(int k = 0; k < sector_row_index; k++)
		    d1 +=  local_hopping_hamiltonians[index].get_sector_matrix()[k][0].get_height();
		  d1 += i;
		  for(int k = 0; k < sector_column_index; k++)
		      d2 +=  local_hopping_hamiltonians[index].get_sector_matrix()[0][k].get_width();
		  d2 += j;
		  
		  double element =0;
		  element =  read_on_site_energy_matrix[index].get_matrix_ptr()[d1][d2];
		  //cout<<element<<endl; 
		  local_hopping_hamiltonians[index].get_sector_matrix()[sector_row_index][sector_column_index].set_matrix_element(i, j, element);
		}//j
	      }//i
	  }//if
	}//sector_column_index
      }//sector_row_index      
    }//index




    delete [] top_line_no;
    top_line_no = NULL;
    delete [] bottom_line_no; 
    bottom_line_no = NULL;
    delete [] top_name;
    top_name = NULL;
    delete [] bottom_name; 
    bottom_name = NULL;
    delete [] top_representation_index; 
    top_representation_index = NULL;
    delete [] bottom_representation_index;
    bottom_representation_index = NULL;
    delete [] top_matrix;
    top_matrix = NULL;
    delete [] bottom_matrix;
    bottom_matrix = NULL;
    delete [] top_on_site_energy_matrix;
    top_on_site_energy_matrix = NULL;
    delete [] bottom_on_site_energy_matrix;
    bottom_on_site_energy_matrix = NULL;
    delete [] top_sign;
    top_sign = NULL;
    delete [] bottom_sign;
    bottom_sign = NULL;


    for(int i=0; i<hopping_operator_no; i++){
      read_matrix[i].clear();
      read_on_site_energy_matrix[i].clear();
    }
    delete [] read_matrix; 
    delete [] read_on_site_energy_matrix;
    read_matrix = NULL;
    read_on_site_energy_matrix = NULL;

    /*

    for(index=0; index<hopping_operator_no; index++){  

      cout<<local_hopping_operators[index].get_name()<<endl;
      cout<<local_hopping_operators[index].get_representation_index()<<endl;
      
  
      for (int sector_row=0; sector_row<local_sector_no; sector_row++){
	for (int sector_column=0; sector_column<local_sector_no; sector_column++){
	  if(local_hopping_operators[index].get_sector_matrix()[sector_row][sector_column].get_activation_state()){
	    cout<< "sector(" <<sector_row<<","<<sector_column<<") ";
	    cout<< " dimension= (" << local_sectors_dimension[sector_row]<<","<<local_sectors_dimension[sector_column]<<")"<<endl;
	    
	    for(int i=0;i<local_sectors_dimension[sector_row]; i++){
	      for(int j=0; j<local_sectors_dimension[sector_column]; j++){
		cout<<local_hopping_operators[index].get_sector_matrix()[sector_row][sector_column].get_matrix()[i][j]<<"\t";
	      }//j
	      cout<<endl;
	    }//i	    	    
	  }//if
	}//sector_column
      }//sector_row
    }//index
    

    for(index=0; index<hopping_operator_no; index++){  

      cout<<local_hopping_hamiltonians[index].get_name()<<endl;
      cout<<local_hopping_hamiltonians[index].get_representation_index()<<endl;
      
  
      for (int sector_row=0; sector_row<local_sector_no; sector_row++){
	for (int sector_column=0; sector_column<local_sector_no; sector_column++){
	  if(local_hopping_hamiltonians[index].get_sector_matrix()[sector_row][sector_column].get_activation_state()){
	    cout<< "sector(" <<sector_row<<","<<sector_column<<") ";
	    cout<< " dimension= (" << local_sectors_properties_array[sector_row].dimension<<","<<local_sectors_properties_array[sector_column].dimension<<")"<<endl;
	    
	    for(int i=0;i<local_sectors_properties_array[sector_row].dimension; i++){
	      for(int j=0; j<local_sectors_properties_array[sector_column].dimension; j++){
		cout<<local_hopping_hamiltonians[index].get_sector_matrix()[sector_row][sector_column].get_matrix()[i][j]<<"\t";
	      }//j
	      cout<<endl;
	    }//i	    	    
	  }//if
	}//sector_column
      }//sector_row
    }//index
    */

}//read_local_hopping_operators_section


/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/


void read_spectral_function_section(){

/*******************************************************************************
input variables:  none

output variables: none

return: void

What it does: 
     This routine reads the combinations of the spectral operator for which the 
     spectral function has to be computed. In the input file the name of 
     operators has to be provided one after another.

     Example in the input.dat file:
     f_dagger f_dagger 

     This combination calculates the spectral function for the 
     <f, f_dagger> and not for <f_dagger, f_dagger>

How to call:
     void read_spectral_function_section()
*******************************************************************************/



  spectral_function_index[0] = new int [spectral_function_no]; 
  spectral_function_index[1] = new int [spectral_function_no]; 


  for(int index =0; index<spectral_function_no; index++){
    spectral_function_index[0][index] = -1;
    spectral_function_index[1][index] = -1; 
  }



  fstream read_file("input.dat", ios::in); 
  fstream log_file("log_file", ios::out); 
 
  if( read_file == NULL ){
    printf("Error opening file 'input.dat'.\nError in routine read_symmetries_section()\nExiting...");
    exit(0);
  }//if

  if( log_file == NULL ){
    printf("Error opening file 'log_file'.\nError in routine read_symmetries_section()\nExiting");
    exit(0);
  }//if


  
  int begin_line_no=0; 
  int end_line_no=0;
  int line_no=0; 
  

  while(!read_file.eof()){

    line_no++; 
    read_file.getline(buffer, buffer_size, '\n');
    word_offset = 0; 
    if(get_word(buffer, word, word_offset)){
   

    
      if (strcmp(word, "<SECTION-SPECTRAL_FUNCTION>")==0){
	begin_line_no = line_no;       
      }//if
      

      if (strcmp(word, "</SECTION-SPECTRAL_FUNCTION>")==0){
	end_line_no = line_no;       
      }//if


    }//if get_word;     
  }//while eof; 

    read_file.close();
    read_file.clear();

    //cout<<symmetries_line_no<<endl;
    //cout<<couplings_line_no<<endl;

    read_file.open("input.dat", ios::in);
    if (!read_file.good()){
      printf("Error opening file 'input.dat'.\nError in routine read_spectral_function_section().\nExiting...");
      exit(0);
    }//if

    line_no = 0; 
    int label = 0; //count the number of symmetries and compare it with the symmetry_no


    while(!read_file.eof()){
      line_no++; 
      read_file.getline(buffer, buffer_size, '\n');
      word_offset = 0; 


      if(get_word(buffer, word, word_offset)){

	if (word[0] == '#'){
	  continue; 
	}//if


	if ((begin_line_no<line_no)&&(line_no<end_line_no)){
	  
	  word_offset=0; 

	  if(!(get_word(buffer, word, word_offset)))
	    error_message("reading first spectral operator");
	  	  

	  
	  for(int index = 0; index < spectral_operator_no ; index ++){
            if(strcmp(word, block_spectral_operators[index].get_name())==0){	      
	      spectral_function_index[0][label] = index; 
	    }
	  }//for index 
	  

	    
	  if(!(get_word(buffer, word, word_offset)))
	    error_message("reading second spectral operator");
	  
	  for(int index = 0; index < spectral_operator_no ; index ++){
	    if(strcmp(word, block_spectral_operators[index].get_name())==0){	      
	      spectral_function_index[1][label] = index; 
	    }
	  }//for index
	  label++; 
	}//if index
	
      }//if get_word; 
    }//while(read_file.eof)
    assert(label==spectral_function_no); 
    


    for(int index = 0; index < spectral_operator_no ; index ++){
      if (spectral_function_index[0][index] ==-1){
	error_message("Error while reading the spectral_function_section.\n Names of the spectral operators incorrect ");
      }
      if (spectral_function_index[1][index] ==-1){
	error_message("Error while reading the spectral_function_section.\n Names of the spectral operators incorrect ");
      }

    }


    read_file.close(); 
    read_file.clear();
    log_file.close();
    log_file.clear();

    
  return; 

}//read_spectral_function_section



/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/


void read_spectral_function_broadening_section(){

/*******************************************************************************
input variables:  none

output variables: none

return: void

What it does: 

      This routine reads in the parameters used for computing the real axis 
      spectral function by broadening the discrete spectrum. 

      In is used only by the spectral_function code and reading this section is
      not relevant for the fnrg code. 
      We provide two methods for broaden the spectral function. One is the 
      LOG_GAUSS method and the other one is a  INTERPOLATIVE_lOG_GAUSS method. 

How to call:
    void read_spectral_function_broadening_section()
*******************************************************************************/


  fstream read_file("input.dat", ios::in); 
  fstream log_file("log_file", ios::out); 
 
  if( read_file == NULL ){
    printf("Error opening file 'input.dat'.\nError in routine read_spectral_function_broadening_section()\nExiting...");
    exit(0);
  }//if

  if( log_file == NULL ){
    printf("Error opening file 'log_file'.\nError in routine read_spectral_function_broadening_section()\nExiting...");
    exit(0);
  }//if


  
  int begin_line_no=0; 
  int end_line_no=0;
  int line_no=0; 
  

  while(!read_file.eof()){

    line_no++; 
    read_file.getline(buffer, buffer_size, '\n');
    word_offset = 0; 
    if(get_word(buffer, word, word_offset)){
   

    
      if (strcmp(word, "<SECTION-SPECTRAL_FUNCTION_BROADENING>")==0){
	begin_line_no = line_no;       
      }//if
      

      if (strcmp(word, "</SECTION-SPECTRAL_FUNCTION_BROADENING>")==0){
	end_line_no = line_no;       
      }//if


    }//if get_word;     
  }//while eof; 

    read_file.close();
    read_file.clear();


    read_file.open("input.dat", ios::in);
    if (!read_file.good()){
      printf("Error opening file 'input.dat'.\nError in routine read_spectral_function_section().\nExiting...");
      exit(0);
    }//if

    line_no = 0; 
    int label = 0; //count the number of symmetries and compare it with the symmetry_no


    while(!read_file.eof()){
      line_no++; 
      read_file.getline(buffer, buffer_size, '\n');
      word_offset = 0; 


      if(get_word(buffer, word, word_offset)){

	if (word[0] == '#'){
	  continue; 
	}//if

	
	if ((begin_line_no<line_no)&&(line_no<end_line_no)){
	  

	  if(strcmp(word, "broadening_method")==0){
	    if(!get_word(buffer, word, word_offset)){
	      error_message("reading broadening_method"); 
	    }//if
	    strcpy(broadening_method, word); 
	  }//if

	  
	  if(strcmp(word, "broadening_parameter")==0){
	    if(!get_word(buffer, word, word_offset)){
	      error_message("reading broadening_parameter"); 
	    }//if
	    broadening_parameter = atof(word); 
	  }//if



	  if(strcmp(word, "broadening_energy_minim")==0){
	    if(!get_word(buffer, word, word_offset)){
	      error_message("reading broadening_energy_minim"); 
	    }//if
	    broadening_energy_minim = atof(word); 
	    assert(broadening_energy_minim>0);
	  }//if


	  if(strcmp(word, "broadening_energy_maxim")==0){
	    if(!get_word(buffer, word, word_offset)){
	      error_message("reading broadening_energy_maxim"); 
	    }//if
	    broadening_energy_maxim = atof(word); 
	    assert(broadening_energy_maxim>0);
	  }//if


	  if(strcmp(word, "broadening_grid_mesh")==0){
	    if(!get_word(buffer, word, word_offset)){
	      error_message("reading broadening_grid_mesh"); 
	    }//if
	    broadening_grid_mesh = atoi(word); 
	  }//if

	  if(strcmp(word, "quantum_temperature")==0){
	    if(!get_word(buffer, word, word_offset)){
	      error_message("reading quantum_temperature"); 
	    }//if
	    quantum_temperature = atof(word); 
	  }//if

	  if(strcmp(word, "spectral_function_nrg_even")==0){
	    if(!get_word(buffer, word, word_offset)){
	      error_message("reading spectral_function_nrg_even"); 
	    }//if
	    if (strcmp(word, "YES")==0){
	      spectral_function_nrg_even=1; 
	    }
	    else{
	      spectral_function_nrg_even=0; 
	    }	    	   
	  }//if
	  
	  if(strcmp(word, "spectral_function_nrg_odd")==0){
	    if(!get_word(buffer, word, word_offset)){
	      error_message("reading spectral_function_nrg_odd"); 
	    }//if
	    if (strcmp(word, "YES")==0){
	      spectral_function_nrg_odd=1; 
	    }
	    else{
	      spectral_function_nrg_odd=0; 
	    }	    	   

	  }//if
	  
	  if(strcmp(word, "spectral_function_dmnrg")==0){
	    if(!get_word(buffer, word, word_offset)){
	      error_message("reading spectral_function_dmnrg"); 
	    }//if
	    if (strcmp(word, "YES")==0){
	      spectral_function_dmnrg=1; 
	    }
	    else{
	      spectral_function_dmnrg=0; 
	    }	    	   

	  }//if

	  if(strcmp(word, "static_average_dmnrg")==0){
	    if(!get_word(buffer, word, word_offset)){
	      error_message("reading static_average_dmnrg"); 
	    }//if
	    if (strcmp(word, "YES")==0){
	      static_average_dmnrg=1; 
	    }
	    else{
	      static_average_dmnrg=0; 
	    }	    	   

	   
	  }//if


	  if(strcmp(word, "green_function_nrg_even")==0){
	    if(!get_word(buffer, word, word_offset)){
	      error_message("reading green_function_nrg_even"); 
	    }//if
	    if (strcmp(word, "YES")==0){
	      green_function_nrg_even=1; 
	    }
	    else{
	      green_function_nrg_even=0; 
	    }	    	   

	  }//if	 


	  if(strcmp(word, "green_function_nrg_odd")==0){
	    if(!get_word(buffer, word, word_offset)){
	      error_message("reading green_function_nrg_odd"); 
	    }//if
	    if (strcmp(word, "YES")==0){
	      green_function_nrg_odd=1; 
	    }
	    else{
	      green_function_nrg_odd=0; 
	    }	    	   

	  }//if	 



	  if(strcmp(word, "green_function_dmnrg")==0){
	    if(!get_word(buffer, word, word_offset)){
	      error_message("reading green_function_dmnrg"); 
	    }//if
	    if (strcmp(word, "YES")==0){
	      green_function_dmnrg=1; 
	    }
	    else{
	      green_function_dmnrg=0; 
	    }	    	   

	  }//if	 

     	  if(strcmp(word, "green_function_grid_mesh")==0){
	    if(!get_word(buffer, word, word_offset)){
	      error_message("green_function_grid_mesh"); 
	    }//if
	    green_function_grid_mesh = atol(word); 
	  }//if


	}//if begin_line<lin_no	
	 
      }//if get_word; 
    }//while(read_file.eof)
    

    //now we parse each section


    read_file.close(); 
    read_file.clear();
    log_file.close();
    log_file.clear();

}//read_spectral_function_broadening_section


/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/

void copy_input_file(){

/*******************************************************************************
input variables:  none

output variables: none

return: void

What it does: ???

How to call:
    void copy_input_file()
*******************************************************************************/

  char input_file_name[400];

  input_swap_file_name(working_folder_name, 
		       input_file_name); 

  copy_file("input.dat", input_file_name);
 
  
  return; 
}//copy_input_file





/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/

void copy_hoppings_on_site_energies_files(){

/*******************************************************************************
input variables:  none

output variables: none

return: void

What it does: ???

How to call:
    void copy_input_file()
*******************************************************************************/

  char file_name[400];

  on_site_energies_mapping_file_name(dos_mapping_folder_name,
				     self_consistancy_index, 
				     on_site_energies_file_name
				     );
 

 on_site_energies_mapping_file_name(mapping_folder_name,
				    self_consistancy_index, 
				    file_name
				    );
 
 copy_file(on_site_energies_file_name, file_name);


 
 hopping_couplings_mapping_file_name(dos_mapping_folder_name,
				     self_consistancy_index, 
				     hopping_couplings_file_name
				     );

 hopping_couplings_mapping_file_name(mapping_folder_name,
				     self_consistancy_index, 
				     file_name
				     );
 copy_file(hopping_couplings_file_name, file_name);
 
  return; 
}//copy_input_file






void green_function_dmnrg_swap_file_name(char *working_folder_name,
					 double b,
					 char *green_function_file_name,
					 quantum_operator & spectral_operator_A, 
					 quantum_operator & spectral_operator_B
					 ){
  
  
  char swap_string[254]; 
  
  strcpy(green_function_file_name, working_folder_name); 
  
  sprintf(swap_string, "//green_function_dmnrg_"); 
  strcat(swap_string, spectral_operator_A.get_name()); 
  strcat(swap_string, "_"); 
  strcat(swap_string, spectral_operator_B.get_name());
  strcat(swap_string, "_"); 
  strcat(green_function_file_name, swap_string); 
  
  sprintf(swap_string, "b_%lf.dat", b); 
  strcat(green_function_file_name, swap_string); 
  
  return; 
}//green_function_dmnrg_swap_file_name



void green_function_even_swap_file_name(char *working_folder_name,
					 double b,
					 char *green_function_file_name,
					 quantum_operator & spectral_operator_A, 
					 quantum_operator & spectral_operator_B
					 ){
  
  
  char swap_string[254]; 
  
  strcpy(green_function_file_name, working_folder_name); 
  
  sprintf(swap_string, "//green_function_even_"); 
  strcat(swap_string, spectral_operator_A.get_name()); 
  strcat(swap_string, "_"); 
  strcat(swap_string, spectral_operator_B.get_name());
  strcat(swap_string, "_"); 
  strcat(green_function_file_name, swap_string); 
  
  sprintf(swap_string, "b_%lf.dat", b); 
  strcat(green_function_file_name, swap_string); 
  
  return; 
}//green_function_even_swap_file_name


void green_function_odd_swap_file_name(char *working_folder_name,
					 double b,
					 char *green_function_file_name,
					 quantum_operator & spectral_operator_A, 
					 quantum_operator & spectral_operator_B
					 ){
  
  
  char swap_string[254]; 
  
  strcpy(green_function_file_name, working_folder_name); 
  
  sprintf(swap_string, "//green_function_odd_"); 
  strcat(swap_string, spectral_operator_A.get_name()); 
  strcat(swap_string, "_"); 
  strcat(swap_string, spectral_operator_B.get_name());
  strcat(swap_string, "_"); 
  strcat(green_function_file_name, swap_string); 
  
  sprintf(swap_string, "b_%lf.dat", b); 
  strcat(green_function_file_name, swap_string); 
  
  return; 
}//green_function_odd_swap_file_name




void read_hopping_couplings_and_on_site_energies(double ** hopping_couplings_array, 
						 double ** on_site_energies_array){


  const int buffer_size = 2000;
  char buffer[buffer_size + 1];
  char word[buffer_size + 1];
  int word_offset;


  on_site_energies_mapping_file_name(dos_mapping_folder_name,
				     self_consistancy_index, 
				     on_site_energies_file_name
				     );

  hopping_couplings_mapping_file_name(dos_mapping_folder_name,
				      self_consistancy_index, 
				      hopping_couplings_file_name
				      );



  ifstream on_site_energies_file(on_site_energies_file_name, ios::in); 
  ifstream hopping_couplings_file(hopping_couplings_file_name, ios::in); 


  //we read first the on_site_energies from the file. 
  //first we read the header of the on_site_energies_file. 

  on_site_energies_file.getline(buffer, buffer_size, '\n'); 
  word_offset = 0; 

  if(get_word(buffer, word, word_offset)){
    if(strcmp(word, "lambda")==0){
      if(!get_word(buffer, word, word_offset)){
	error_message("reading lambda in routine reading_hopping_couplings_and_on_site_energies"); 
      }//if
      double local_lambda= atof(word); 	      	
      assert(fabs(lambda-local_lambda)<allowed_error); 
    }//if 
  }//if 



 
  on_site_energies_file.getline(buffer, buffer_size, '\n'); 
  word_offset = 0; 

  if(get_word(buffer, word, word_offset)){
    if(strcmp(word, "iteration_no")==0){
      if(!get_word(buffer, word, word_offset)){
	error_message("reading iteration_no in routine reading_hopping_couplings_and_on_site_energies"); 
      }//if
      int local_iteration_no = atoi(word); 	      	
      assert(local_iteration_no >= iteration_no); 
    }//if 
  }//if 




 on_site_energies_file.getline(buffer, buffer_size, '\n'); 
  word_offset = 0; 

  if(get_word(buffer, word, word_offset)){
    if(strcmp(word, "hopping_operator_no")==0){
      if(!get_word(buffer, word, word_offset)){
	error_message("reading hopping_operator_no in routine reading_hopping_couplings_and_on_site_energies"); 
      }//if
      int local_hopping_operator_no = atoi(word); 	      	
      assert(local_hopping_operator_no =hopping_operator_no); 

    }//if 
  }//if 

  
  //now we read the on site energies from the file. 
  //the first column is the iteration_index-1 itself, and then we have a column for each hopping coupling. 

  for(int iteration_index=0; iteration_index<=iteration_no; iteration_index++){

   
    on_site_energies_file.getline(buffer, buffer_size, '\n'); 
    word_offset = 0; 
    
    if(!get_word(buffer, word, word_offset)){
      error_message("reading iteration_index in routine reading_hopping_couplings_and_on_site_energies"); 
    }//if
    
    assert(iteration_index==atoi(word));

    for(int hopping_coupling_index=0; hopping_coupling_index<hopping_operator_no; hopping_coupling_index++){

      if(!get_word(buffer, word, word_offset)){
	error_message("reading on_site_energy_array in routine reading_hopping_couplings_and_on_site_energies"); 
      }//if
    
      on_site_energies_array[iteration_index][hopping_coupling_index]= atof(word); 

    }//for hopping_coupling_index
  }//for iteration_index





  //now we read the hoppings from the file. 
  //reading the hoppings is similar with the reading of the on site energies. 


  hopping_couplings_file.getline(buffer, buffer_size, '\n'); 
  word_offset = 0; 

  if(get_word(buffer, word, word_offset)){
    if(strcmp(word, "lambda")==0){
      if(!get_word(buffer, word, word_offset)){
	error_message("reading lambda in routine reading_hopping_couplings_and_on_site_energies"); 
      }//if
      double local_lambda= atof(word); 	      	
      assert(fabs(lambda-local_lambda)<allowed_error); 
    }//if 
  }//if 



 
  hopping_couplings_file.getline(buffer, buffer_size, '\n'); 
  word_offset = 0; 

  if(get_word(buffer, word, word_offset)){
    if(strcmp(word, "iteration_no")==0){
      if(!get_word(buffer, word, word_offset)){
	error_message("reading iteration_no in routine reading_hopping_couplings_and_on_site_energies"); 
      }//if
      int local_iteration_no = atoi(word); 	      	
      assert(local_iteration_no >= iteration_no); 
    }//if 
  }//if 




 hopping_couplings_file.getline(buffer, buffer_size, '\n'); 
  word_offset = 0; 

  if(get_word(buffer, word, word_offset)){
    if(strcmp(word, "hopping_operator_no")==0){
      if(!get_word(buffer, word, word_offset)){
	error_message("reading hopping_operator_no in routine reading_hopping_couplings_and_on_site_energies"); 
      }//if
      int local_hopping_operator_no = atoi(word); 	      	
      assert(local_hopping_operator_no =hopping_operator_no); 

    }//if 
  }//if 


  //now we read the hopping couplings from the file. 
  //the first column is the iteration_index itself, and then we have a column for each hopping_coupling. 

  for(int iteration_index=0; iteration_index<=iteration_no; iteration_index++){

   
    hopping_couplings_file.getline(buffer, buffer_size, '\n'); 
    word_offset = 0; 
    
    if(!get_word(buffer, word, word_offset)){
      error_message("reading iteration_index in routine reading_hopping_couplings_and_on_site_energies"); 
    }//if
    
    assert(iteration_index==atoi(word));

    for(int hopping_coupling_index=0; hopping_coupling_index<hopping_operator_no; hopping_coupling_index++){

      if(!get_word(buffer, word, word_offset)){
	error_message("reading on_site_energy_array in routine reading_hopping_couplings_and_on_site_energies"); 
      }//if
    
      hopping_couplings_array[iteration_index][hopping_coupling_index]= atof(word); 

    }//for hopping_coupling_index
  }//for iteration_index


  on_site_energies_file.close();
  hopping_couplings_file.close();

  return;

}//read_hopping_couplings_and_on_site_energies


/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/

void read_local_hamiltonian_section(){

/*******************************************************************************
input variables:  none

output variables: none

return: void

What it does: 
     This routine reads the local_hamiltonian section and load the hmailtonian
     operator. 
How to call:
     void read_local_hamiltonian_section()
*******************************************************************************/
  
  if (local_couplings) {
    delete [] local_couplings;
  }//if
  local_couplings = NULL;
  
  if (local_hamiltonian_terms!= NULL){
    for(int i = 0; i<coupling_no; i++){
      local_hamiltonian_terms[i].clear();
    }//for
    delete [] local_hamiltonian_terms;
  }
  
  local_hamiltonian_terms = NULL;


  local_couplings = new double [local_coupling_no]; 
  local_hamiltonian_terms = new quantum_operator[local_coupling_no]; 

  for(int i=0; i<local_coupling_no; i++){
    local_hamiltonian_terms[i].activate(symmetry_no); 
    local_hamiltonian_terms[i].allocate_sectors_matrix(local_sector_no); 
  }//i
  
  local_hamiltonian.activate(symmetry_no); 
  local_hamiltonian.set_name("Local_Hamiltonian"); 
  local_hamiltonian.allocate_sectors_matrix(local_sector_no); 

  for(int i = 0; i < symmetry_no; i++){
    local_hamiltonian.set_representation_index(i,0); 
  }//i

  int matrix_size = 0;
  for (int i=0; i<local_sector_no; i++){
    matrix_size += local_sectors_properties_array[i].dimension;     
  }//i
  //cout<<matrix_size; 

  //allocate a matrix of size matrix size;

  
  dmatrix *read_matrix; 
  read_matrix = new dmatrix[local_coupling_no]; 

  for (int i=0; i<local_coupling_no; i++){
    read_matrix[i].allocate(matrix_size, matrix_size); 
  }//i

  


  fstream read_file("input.dat", ios::in); 
  fstream log_file("log_file", ios::out); 
 
  if( read_file == NULL ){
    printf("Error opening file 'input.dat'.\nError in routine read_local_hamiltonian_section()\nExiting...");
    exit(0);
  }//if

  if( log_file == NULL ){
    printf("Error opening file 'log_file'.\nError in routine read_local_hamiltonian_section()\nExiting");
    exit(0);
  }//if


  int  begin_line_no;
  int end_line_no; 
  int line_no=0; 
  int index = 0; 

  int *top_line_no; 
  int *bottom_line_no; 
  int *top_name; 
  int *bottom_name; 
  int *top_coupling;
  int *bottom_coupling; 
  int *top_representation_index;
  int *bottom_representation_index; 
  int *top_matrix;
  int *bottom_matrix;
  
  top_line_no = new int[local_coupling_no];
  bottom_line_no = new int[local_coupling_no]; 

  top_name = new int[local_coupling_no];
  bottom_name = new int[local_coupling_no]; 

  top_coupling = new int[local_coupling_no];
  bottom_coupling = new int[local_coupling_no]; 

  top_representation_index = new int [local_coupling_no]; 
  bottom_representation_index = new int [local_coupling_no]; 

  top_matrix = new int [local_coupling_no]; 
  bottom_matrix = new int [local_coupling_no]; 
  
  while(!read_file.eof()){

    line_no++; 
    read_file.getline(buffer, buffer_size, '\n');
    word_offset = 0; 
    if(get_word(buffer, word, word_offset)){   
      
      if (strcmp(word, "<SECTION-LOCAL_HAMILTONIAN>")==0){
	begin_line_no = line_no;       
      }//if

    
      if (strcmp(word, "</SECTION-LOCAL_HAMILTONIAN>")==0){
	end_line_no = line_no;       
      }//if

      
      if (strcmp(word, "<LOCAL_HAMILTONIAN_TERM>")==0){
	top_line_no [index] = line_no;       
      }//if

      if (strcmp(word, "<LOCAL_HAMILTONIAN_NAME>")==0){
	top_name [index] = line_no;       
      }//if

      if (strcmp(word, "</LOCAL_HAMILTONIAN_NAME>")==0){
	bottom_name [index] = line_no;       
      }//if

      if (strcmp(word, "<LOCAL_HAMILTONIAN_COUPLING>")==0){
	top_coupling [index] = line_no;       
      }//if

      if (strcmp(word, "</LOCAL_HAMILTONIAN_COUPLING>")==0){
	bottom_coupling [index] = line_no;       
      }//if


      if (strcmp(word, "<LOCAL_HAMILTONIAN_REPRESENTATION_INDEX>")==0){
	top_representation_index [index] = line_no;       
      }//if

      if (strcmp(word, "</LOCAL_HAMILTONIAN_REPRESENTATION_INDEX>")==0){
	bottom_representation_index [index] = line_no;       
      }//if

      if (strcmp(word, "<LOCAL_HAMILTONIAN_MATRIX>")==0){
	top_matrix [index] = line_no;       
      }//if
      
      if (strcmp(word, "</LOCAL_HAMILTONIAN_MATRIX>")==0){
	bottom_matrix [index] = line_no;       
      }//if


    
      if (strcmp(word, "</LOCAL_HAMILTONIAN_TERM>")==0){
	bottom_line_no[index] = line_no;       
	index++; 
      }//if
      
    }//if get_word;     
  }//while eof; 

  //make sure we have the proper positions for the line_no's.


    read_file.close();
    read_file.clear();

    assert(index == local_coupling_no); 

    assert(begin_line_no<top_line_no[0]);
    for(int i=0; i<index; i++){
      assert(top_line_no[i]<top_name[i]); 
      assert(top_line_no[i]<top_representation_index[i]); 
      assert(top_line_no[i]<top_matrix[i]); 
      assert(top_line_no[i]<bottom_line_no[i]);

      assert (top_name[i]<bottom_name[i]); 
      assert (top_representation_index[i]<bottom_representation_index[i]);
      assert(top_matrix[i]<bottom_matrix[i]); 
      
      assert(bottom_name[i]<bottom_line_no[i]); 
      assert(bottom_representation_index[i]<bottom_line_no[i]);
      assert(bottom_matrix[i]<bottom_line_no[i]);

      
    }//int i 

    assert (bottom_line_no[index-1]<end_line_no); 
    
    for(index=0; index<local_coupling_no; index++){

      read_file.open("input.dat", ios::in);
      if (!read_file.good()){
	printf("Error opening file 'input.dat'.\nError in routine read_local_hamiltonian_section().\nExiting...");
	exit(0);
      }//if

      line_no = 0; 
      int column_index=0; 
      int row_index =0; 

      while(!read_file.eof()){
	line_no++; 
	read_file.getline(buffer, buffer_size, '\n');
	word_offset = 0; 


	if(get_word(buffer, word, word_offset)){
	  if (word[0] == '#'){
	    continue; 
	  }//if

	  
	  if ((top_line_no[index]<line_no)&&(line_no<bottom_line_no[index])){
	    
	    if ((top_name[index]<line_no)&&(line_no<bottom_name[index])){
	      
	      word_offset = 0; 
	      if(!(get_word(buffer, word, word_offset))){
		error_message("reading local_hamiltonian name\n");
	      }//if
	      

	      local_hamiltonian_terms[index].set_name(word);

	      //cout<<local_hamiltonian_terms[index].get_name()<<endl; 

	    }//top_name

	    if ((top_coupling[index]<line_no)&&(line_no<bottom_coupling[index])){

	      word_offset =0; 
	      if(!(get_word(buffer, word, word_offset))){
		error_message("reading local_hamiltonian coupling\n");
	      }//if
	      
	      local_couplings[index] = atof(word); 

	      //the sqrt(lambda) comes from the rescaling of the hamiltonian 
	    }//top_coupling
	  

	    if ((top_representation_index[index]<line_no)&&(line_no<bottom_representation_index[index])){

	      word_offset = 0;	   

	      for(int i = 0; i < symmetry_no; i++){

		if(!(get_word(buffer, word, word_offset))){
		  error_message("reading the representation indices of the Local_Hamiltonian.\nError in read_local_hamiltonian_section()\n.Exiting...\n");
		}
		
		int representation_index_in =atoi(word);
		if( representation_index_in!=0){
		  //Local_Hamiltonian must have the representation indices zero. 
		  error_message("reading the representation indices of the Local_Hamiltonian.\nError in read_local_hamiltonian_section()\n.Exiting...\n");
		}
		
		// We check if the quantum numbers of the states are in the allowed range. 

		if((representation_index_in > symmetry_types[i].get_max_representation_index()) ||
		   (representation_index_in < symmetry_types[i].get_min_representation_index())){
		  error_message("checking the quantum numbers of the local_hamiltonian_terms.\nThey are not in the allowed range");
		}//if

		else{		  
		  local_hamiltonian_terms[index].set_representation_index(i,representation_index_in);
		  //cout<<local_hamiltonian_terms[index].get_representation_index(i)<<endl; 
		}//else
	    }//i	      	      
	    }//if top_representation_index
	    
	    //now we read the matrix for the Local_Hamiltonian
	    

	    if ((top_matrix[index]<line_no)&&(line_no<bottom_matrix[index])){
	      word_offset = 0; 

	      for(column_index=0; column_index<matrix_size; column_index++){
		
		if(!(get_word(buffer, word, word_offset))){
		  error_message("reading the quantum numbers of the local_hamiltonian_terms.\nError in read_local_hamiltonian_section()\n.Exiting...\n");
		}//if		  
		read_matrix[index].set_matrix_element(row_index, column_index, atof(word)); 		  		
	      }//row_index
	      //cout<<endl;
	      row_index++; 
	    }//if top_matrix
	    //cout<<column_index<<endl;
	  }//if top_line	  
	}//if get_word; 

      }//while(read_file.eof)
      assert(row_index==matrix_size); 
      read_file.close(); 
      read_file.clear();
    }//for index.


    /*
    for(int i=0; i<matrix_size; i++){
	  for(int j=0; j<matrix_size; j++){
	    cout<<read_matrix.get_matrix_ptr()[i][j]<<"  ";
	  }//for column
	  cout<<endl;
    }//for row
    */

    log_file.close();
    log_file.clear();
    
    //now the operators are set. 
    for(int sector_row_index = 0; sector_row_index < local_sector_no; sector_row_index++){
      for(int sector_column_index = 0; sector_column_index < local_sector_no; sector_column_index++){


	local_hamiltonian.get_sector_matrix()[sector_row_index][sector_column_index].set_size(local_sectors_properties_array[sector_row_index].dimension,
						      local_sectors_properties_array[sector_column_index].dimension);

	  if(grand_selection_rule(symmetry_no, symmetry_types, local_sectors_properties_array[sector_column_index].representation_index,
				  local_hamiltonian.get_representation_index(), local_sectors_properties_array[sector_row_index].representation_index)){

	      local_hamiltonian.get_sector_matrix()[sector_row_index][sector_column_index].activate(symmetry_no);

	      local_hamiltonian.get_sector_matrix()[sector_row_index][sector_column_index].set_representation_index(0, local_sectors_properties_array[sector_row_index].representation_index);
	      local_hamiltonian.get_sector_matrix()[sector_row_index][sector_column_index].set_representation_index(1, local_sectors_properties_array[sector_column_index].representation_index);
	      local_hamiltonian.get_sector_matrix()[sector_row_index][sector_column_index].allocate_matrix();

	      int size_height = local_hamiltonian.get_sector_matrix()[sector_row_index][sector_column_index].get_height();
	      int size_width = local_hamiltonian.get_sector_matrix()[sector_row_index][sector_column_index].get_width();
	

	      for(int i = 0; i < size_height; i++){
		for(int j = 0; j < size_width; j++){
		  
		  int d1 =0;
		  int d2 =0;

		  for(int k = 0; k < sector_row_index; k++)
		    d1 +=  local_hamiltonian.get_sector_matrix()[k][0].get_height();
		    d1 += i;
		    for(int k = 0; k < sector_column_index; k++)
		      d2 +=  local_hamiltonian.get_sector_matrix()[0][k].get_width();
		    d2 += j;

		    double element =0;
		    for(index= 0; index < local_coupling_no; index++){
		      element += local_couplings[index] * read_matrix[index].get_matrix_ptr()[d1][d2];
		    }//index
		    local_hamiltonian.get_sector_matrix()[sector_row_index][sector_column_index].set_matrix_element(i, j, element);
		}//j
	      }//i
	  }//if
      }//sector_column_index
    }//sector_row_index


    delete [] top_line_no;
    top_line_no = NULL;
    delete [] bottom_line_no; 
    bottom_line_no = NULL;
    delete [] top_name;
    top_name = NULL;
    delete [] bottom_name; 
    bottom_name = NULL;
    delete [] top_coupling;
    top_coupling = NULL;
    delete [] bottom_coupling;
    bottom_coupling = NULL;
    delete [] top_representation_index; 
    top_representation_index = NULL;
    delete [] bottom_representation_index;
    bottom_representation_index = NULL;
    delete [] top_matrix;
    top_matrix = NULL;
    delete [] bottom_matrix;
    bottom_matrix = NULL;

    for(int i=0; i<local_coupling_no; i++){
      read_matrix[i].clear();
    }
    delete [] read_matrix; 
    read_matrix = NULL;

  for(int i=0; i<local_coupling_no; i++){
    local_hamiltonian_terms[i].clear(); 
  }//i
  delete [] local_hamiltonian_terms;
  local_hamiltonian_terms = NULL;
  /*
    
  cout<<local_hamiltonian.get_name()<<endl;
  cout<<local_hamiltonian.get_representation_index()<<endl;

  
  for (int sector_row=0; sector_row<local_sector_no; sector_row++){
    for (int sector_column=0; sector_column<local_sector_no; sector_column++){
      if(local_hamiltonian.get_sector_matrix()[sector_row][sector_column].get_activation_state()){
	cout<< "sector(" <<sector_row<<","<<sector_column<<") ";
	cout<< " dimension= (" << local_sectors_properties_array[sector_row].dimension<<","<<local_sectors_properties_array[sector_column].dimension<<")"<<endl;
	for(int i=0;i<local_sectors_properties_array[sector_row].dimension; i++){
	  for(int j=0; j<local_sectors_properties_array[sector_column].dimension; j++){
	    cout<<local_hamiltonian.get_sector_matrix()[sector_row][sector_column].get_matrix()[i][j]<<"\t";
	  }//j
	  cout<<endl;
	}//i       
      }//if
    }//sector_column
  }//sector_row
  
  */
  return; 
}//read_local_hamiltonian_section



