//2005.05.04.
//calculating CG coefficients

#include<iostream>
#include <stdlib.h>
using namespace std;
#include "../include/clebsch_gordan.h"

enum CHOICE {Calculate_CG='c',Quit='q'};

char do_menu();
bool readln(int & index);

int main()
{
    int choice;
    int fQuit=false;
    int S_old, S_z_old, S_added, S_z_added, S_new, S_z_new;
    char buffer[256];

    while(!fQuit)
    {
	choice=do_menu();
	if(choice != Calculate_CG && choice != Quit)
	{
	    cout<<"\n\tInvalid choice. Please, try again.\n\n";
	    continue;
	}
	switch(choice)
	{
	    case Calculate_CG:
		cout<<"\n\t2 * S_old:\t";
		readln(S_old);
		cout<<"\t2 * S_z_old:\t";
		readln(S_z_old);
		cout<<"\t2 * S_added:\t";
		readln(S_added);
		cout<<"\t2 * S_z_added:\t";
		readln(S_z_added);
		cout<<"\t2 * S_new:\t";
		readln(S_new);
		cout<<"\t2 * S_z_new:\t";
		readln(S_z_new);
		if( abs(S_z_old) > S_old || abs(S_z_added) > S_added || abs(S_z_new) > S_new )
		{
		    cerr<<"\n\tInvalid argument.\n\tThe absolute value of S_z cannot exceed S.\n";
		    continue;
		}
		if(S_added != 1 && S_added != 2 && S_added != 0)
		{
		    cerr<<"\n\tThe possible values of S_added are 0 or 1/2 or 1.\n";
		    continue;
		}
		if( S_z_old + S_z_added != S_z_new)
		{
		    cerr<<"\n\tInvalid argument: S_z_old + S_z_added != S_z_new.\n";
		    continue;
		}
		cout<<"\n\tNow calculating: < S_new, S_z_new | S_added, S_z_added; S_old, S_z_old >..."<<endl;
		cout<<"\n\tC( "<<(float)S_new/2<<", "<<(float)S_z_new/2<<" | "<<(float)S_added/2<<", "<<(float)S_z_added/2<<", "<<(float)S_old/2<<", "<<(float)S_z_old/2<<" ) = "<< 
		    clebsch_gordan(S_old, S_z_old, S_added, S_z_added, S_new, S_z_new) <<endl;
		break;
	    case Quit:
		fQuit=true;
		cout<<"\n\tEXITING...\n\n";
		break;
	    default:
		cout<<"\tError in choice!\n";
		fQuit=true;
		break;
	}//end switch
    }//end while
    return 0;
}

char do_menu()
{
    char buffer[256];
    cout<<"\n\n\t\t\t\t *** MENU *** \n\n\n";
    cout<<"\t(c)\tCalculate CG coefficients for SU(2) symmetry\n";
    cout<<"\t(q)\tQuit\n\n\t";
    cin.getline(buffer,255,'\n');
    return buffer[0];
}
bool readln(int & index)
{
    char buffer[256];
    cin.getline(buffer,255,'\n');
    index=atoi(buffer);
    return true;
}
