/****************************************************************************

Last Update : 2007/09/25 Pascu Moca 

No documentation update necessary


*****************************************************************************/


#include "../include/dmatrix.h"
#include "../include/in_out.h"
#include "../include/llvector.h"
#include "../include/sector.h"
#include "../include/state.h"
#include "../include/state_list.h"
#include "../include/symmetry.h"
#include "../include/variables.h"
#include "../include/quantum_operator.h"
#include "../include/construction.h"
#include "../include/diagonalization.h"
#include "../include/transformation.h"
#include "../include/cut_off.h"
#include "../include/spectral_function.h"
#include "../include/dmnrg.h"
#include "../include/real_axis_spectral_function.h"
#include "../include/hilbert_transform.h"
#include "../include/green_function.h"
int main(){


  
  read_parameters_section();
  read_flags_section();
  read_symmetries_section();
  read_block_states_section();
  read_local_states_section();
  read_local_states_signs_section();

  
  block_sector_no = get_sectors_no(block_state_no, block_states_array);
  local_sector_no = get_sectors_no(local_state_no, local_states_array); 

  set_sectors_representation_index(symmetry_no,
				   symmetry_types,
				   block_state_no, 
				   block_states_array, 
				   block_sector_no, 
				   block_sectors_properties_array); 

  set_sectors_representation_index(symmetry_no,
				   symmetry_types,
				   local_state_no, 
				   local_states_array, 
				   local_sector_no, 
				   local_sectors_properties_array); 

  local_degeneracy = get_local_degeneracy(symmetry_no, 
					  symmetry_types, 
					  local_sector_no, 
					  local_sectors_properties_array); 

  read_block_hamiltonian_section();  
  read_hopping_operators_section();


  if (spectral_operator_no>0)  read_spectral_operators_section();
  if(static_operator_no>0)  read_static_operators_section();
  if (local_coupling_no>0) read_local_hamiltonian_section();

  read_spectral_function_section();
  

  read_spectral_function_broadening_section();

  

  create_working_folder(model,
			lambda, 
			max_state_no,
			iteration_no,
			temperature,		   
			symmetry_no,
			symmetry_types,
			coupling_no, 
			couplings,
			working_folder_name			
			); 

  

  create_swap_folder(working_folder_name, 
		     swap_folder_name); 



  create_delta_peaks_folder(swap_folder_name, 
			    delta_peaks_folder_name); 
  create_spectral_functions_folder(swap_folder_name, 
				   spectral_functions_folder_name); 
  create_transformations_folder(swap_folder_name, 
				transformations_folder_name); 
  create_spectral_operators_folder(swap_folder_name, 
				   spectral_operators_folder_name); 
  create_static_operators_folder(swap_folder_name, 
				 static_operators_folder_name); 
  create_states_folder(swap_folder_name, 
		       states_folder_name); 
  create_sectors_folder(swap_folder_name, 
			sectors_folder_name); 

  read_m_star(m_star, m_star_file_name); 


  copy_input_file();
   

  for(int i=0; i<spectral_function_no; i++){

    /* always the negative part of the spectrum need to be reweight first */

    reweight_spectral_function_peaks(block_spectral_operators[spectral_function_index[0][i]],
				     block_spectral_operators[spectral_function_index[1][i]],
				     "negative", 
				     "even",
				     "NRG"
				     ); 

    reweight_spectral_function_peaks(block_spectral_operators[spectral_function_index[0][i]],
				     block_spectral_operators[spectral_function_index[1][i]],
				     "positive", 
				     "even",
				     "NRG"
				     ); 

    reweight_spectral_function_peaks(block_spectral_operators[spectral_function_index[0][i]],
				     block_spectral_operators[spectral_function_index[1][i]],
				     "negative", 
				     "odd",
				     "NRG"
				     ); 

    reweight_spectral_function_peaks(block_spectral_operators[spectral_function_index[0][i]],
				     block_spectral_operators[spectral_function_index[1][i]],
				     "positive", 
				     "odd",
				     "NRG"
				     ); 

  }//i 




  if (dmnrg_flag==1){
    for(int i=0; i<spectral_function_no; i++){
      
      reweight_spectral_function_peaks(block_spectral_operators[spectral_function_index[0][i]],
				       block_spectral_operators[spectral_function_index[1][i]],
				       "negative", 
				       "odd_even",
				       "DMNRG"
				       ); 

      reweight_spectral_function_peaks(block_spectral_operators[spectral_function_index[0][i]],
				       block_spectral_operators[spectral_function_index[1][i]],
				       "positive", 
				       "odd_even",
				       "DMNRG"
				       ); 

      
    }//for i
  }//if dmnrg flag

  for(int i=0; i<spectral_function_no; i++){
    if ((spectral_function_nrg_even==1)
	&& (!strcmp(broadening_method, "LOG_GAUSS"))){        
      generate_spectral_function_real_axis(block_spectral_operators[spectral_function_index[0][i]],
					   block_spectral_operators[spectral_function_index[1][i]],
					   broadening_parameter, 
					   temperature, 
					   quantum_temperature, 
					   "even",
					   "LOG_GAUSS", 
					   "NRG");
    }//if


    if ((spectral_function_nrg_odd==1) && 
	(!strcmp(broadening_method, "LOG_GAUSS"))){
      generate_spectral_function_real_axis(block_spectral_operators[spectral_function_index[0][i]],
					   block_spectral_operators[spectral_function_index[1][i]],
					   broadening_parameter, 
					   temperature, 
					   quantum_temperature, 
					   "odd",
					   "LOG_GAUSS", 
					   "NRG");
    }//if     
    if ((spectral_function_nrg_even==1) && 
	(!strcmp(broadening_method, "INTERPOLATIVE_LOG_GAUSS"))){
      generate_spectral_function_real_axis(block_spectral_operators[spectral_function_index[0][i]],
					   block_spectral_operators[spectral_function_index[1][i]],
					   broadening_parameter, 
					   temperature, 
					   quantum_temperature, 
					   "even",
					   "INTERPOLATIVE_LOG_GAUSS", 
					   "NRG");
    }//if
    if ((spectral_function_nrg_odd==1) && (!strcmp(broadening_method, "INTERPOLATIVE_LOG_GAUSS"))){
      generate_spectral_function_real_axis(block_spectral_operators[spectral_function_index[0][i]],
					   block_spectral_operators[spectral_function_index[1][i]],
					   broadening_parameter, 
					   temperature, 
					   quantum_temperature, 
					   "odd",
					   "INTERPOLATIVE_LOG_GAUSS",
					   "NRG");
    }//if
    

    if ((dmnrg_flag==1)&&
	(spectral_function_dmnrg==1) && 
	(!strcmp(broadening_method, "LOG_GAUSS"))){


      generate_spectral_function_real_axis(block_spectral_operators[spectral_function_index[0][i]],
					   block_spectral_operators[spectral_function_index[1][i]],
					   broadening_parameter, 
					   temperature, 
					   quantum_temperature, 
					   "odd",
					   "LOG_GAUSS",
					   "DMNRG");
      generate_spectral_function_real_axis_dmnrg_each_iteration(block_spectral_operators[spectral_function_index[0][i]], 
							        block_spectral_operators[spectral_function_index[1][i]], 
								broadening_parameter, 
								temperature, 
								quantum_temperature, 		    
								"LOG_GAUSS"
								);
    }//if

    
    if ((dmnrg_flag==1) && 
	(spectral_function_dmnrg==1) && 
	(!strcmp(broadening_method, "INTERPOLATIVE_LOG_GAUSS"))){
               
      
      generate_spectral_function_real_axis(block_spectral_operators[spectral_function_index[0][i]],
					   block_spectral_operators[spectral_function_index[1][i]],
					   broadening_parameter, 
					   temperature, 
					   quantum_temperature, 
					   "odd",
					   "INTERPOLATIVE_LOG_GAUSS",
					   "DMNRG");
      generate_spectral_function_real_axis_dmnrg_each_iteration(block_spectral_operators[spectral_function_index[0][i]], 
							        block_spectral_operators[spectral_function_index[1][i]], 
								broadening_parameter, 
								temperature, 
								quantum_temperature, 		    
								"INTERPOLATIVE_LOG_GAUSS"
								);           
    }//if
    



  }//i


  //now we compute the real part of the spectral functions is the flag is set to YES

  if ((dmnrg_flag==1) && (green_function_dmnrg==1)){
    for(int i=0; i<spectral_function_no; i++){
      generate_green_function_dmnrg_quadrature (broadening_parameter,
						block_spectral_operators[spectral_function_index[0][i]],
						block_spectral_operators[spectral_function_index[1][i]]
						);
    }//for i     
  }//if green_function
  




  if (green_function_nrg_even==1){
    for(int i=0; i<spectral_function_no; i++){      
      generate_green_function_nrg_even_quadrature (broadening_parameter,
						   block_spectral_operators[spectral_function_index[0][i]],
						   block_spectral_operators[spectral_function_index[1][i]]
						   );
    }//for i     
  }//if green_function
  

  

  if (green_function_nrg_odd==1){
    for(int i=0; i<spectral_function_no; i++){      
      generate_green_function_nrg_odd_quadrature (broadening_parameter,
						  block_spectral_operators[spectral_function_index[0][i]],
						  block_spectral_operators[spectral_function_index[1][i]]
						  );
    }//for i     
  }//if green_function
  






  //here we compute the static averages is the corresponding flag is set to YES.

  if ((dmnrg_flag==1) && (static_average_dmnrg==1)){

    for(int i=0; i<spectral_function_no; i++){
        
      generate_static_averages(block_spectral_operators[spectral_function_index[0][i]],
			       block_spectral_operators[spectral_function_index[1][i]] 
			       );
    } //for i 

    for(int i=0; i<static_operator_no;i++){

      generate_static_averages(block_static_operators[i]);
      
    }// for i 


      
  }//if static averages

  
  
  return 1; 
}
