/****************************************************************************

Last Update : 2007/09/25 Pascu Moca 

No documentation update necessary


*****************************************************************************/


#include "../include/quantum_operator.h"


/**********************************************************/
quantum_operator::quantum_operator(){
  name = NULL;
  sectors_matrix =NULL;
  sgn = 0; 

}//quantum_operator

/**********************************************************/

quantum_operator::~quantum_operator(){
  if(name){
    delete [] name; 
    name = NULL;
  }

  if(sectors_matrix){

    delete [] sectors_matrix[0];
    sectors_matrix[0] = NULL;
    delete [] sectors_matrix;
    sectors_matrix = NULL; 
  }//if

}//~quantum_operator

/**********************************************************/

void quantum_operator::activate(int no_of_symmetries){

  if(!representation_index.get_ptr()){
    representation_index.allocate(no_of_symmetries);    
  }//if
  
  if(!name)    /* if not active */
    name = new char[256];
  if(!name) {
    cerr << "Allocation failure: quantum_operator cannot be activated.\nError in routine quantum_operator::activate()\n EXITING...\n"; 
    exit(-1);
  }//if


}//activate

/**********************************************************/

void quantum_operator::allocate_sectors_matrix(int sectors_no){

  sectors_matrix = new sector * [sectors_no];

  if (!sectors_matrix){
    cout << "allocation failure 1 in quantum_operator:allocate(int,)\nEXITING..." << endl; 
    exit(1);
  }//if
  
  sectors_matrix[0] = new sector [sectors_no * sectors_no];

  if (!sectors_matrix[0]){
    cout << "allocation failure 2 in quantum_operator::allocate(int, int)\nEXITING..." << endl; 
    exit(1);
  }//if
  
  for(int i = 1; i < sectors_no; i++){
    sectors_matrix[i] = sectors_matrix[i-1] + sectors_no;    
  }//int i
  
}//allocate_sector_matrix

/*************************************************************************/

void quantum_operator::clear(){
  
  if(sectors_matrix) {  
    // if allocated, otherwise it is clear 
    // remove arrays 
    delete [] (sectors_matrix[0]);
    sectors_matrix[0] = NULL; 
    delete [] sectors_matrix;
    sectors_matrix = NULL; 
  }//if sectors_matrix

  else{
    cerr << "The sectors_matrix is not yet allocated.Error in quantum_operator::clear()\nEXITING..." << endl; 
    exit(1);
  }//else

  if(name){
    delete [] name; 
    name = NULL;
  }
  
}//clear()

/***********************************************************************/


void quantum_operator::clear_sectors_matrix(){
  
  if(sectors_matrix) {  
    // if allocated, otherwise it is clear 
    // remove arrays 
    delete [] (sectors_matrix[0]);
    sectors_matrix[0] = NULL; 
    delete [] sectors_matrix;
    sectors_matrix = NULL; 
  }//if sectors_matrix
  else{
    cerr << "The sectors_matrix is not yet allocated.Error in quantum_operator::clear()\nEXITING..." << endl; 
    exit(1);
  }//else

  
}//clear_sectors()

/***********************************************************************/

int quantum_operator::get_representation_index(int symmetry_index){
  return (representation_index[symmetry_index]); 
}//get_representation_index

/************************************************************************/

void quantum_operator::set_representation_index(int sym_index,int rep_index){
  representation_index[sym_index] = rep_index;
}//set_representation_index

/************************************************************************/

int quantum_operator::get_representation_index_size(){
  return(representation_index.get_size());
}//get_representation_index_size

/************************************************************************/

void quantum_operator::set_representation_index(llvector & rep_index_master ) {

  int size = representation_index.get_size();
  if (size != rep_index_master.get_size())  {
    cerr << "Sizes do not match in quantum_operator::set_representation_index()\n exiting..."; 
    exit(1);
  }//if
  for(int ind = 0; ind < size; ind++){
    representation_index[ind] = rep_index_master[ind];
  }//ind


}//set_represention_index

/************************************************************************/

llvector & quantum_operator::get_representation_index(){
  return(representation_index); 
}//get_representation_index

/************************************************************************/

sector** quantum_operator::get_sector_matrix(){
  return sectors_matrix;
}//get_sector_matrix

/************************************************************************/

char * quantum_operator::get_name(){
  if(name){
    return (name);
  }//if
  else{
    cout<<"quantum_operator without name\nError in routine quantum_operator::get_name\n.Exiting..."<<endl;
  }//
  return NULL; 
}//get_name
/************************************************************************/

void quantum_operator::set_name(char * new_name){
  strcpy(name,new_name);
}//set_name

/************************************************************************/

int quantum_operator::get_sgn(){
  return (sgn); 
}//get_sgn

/************************************************************************/

void quantum_operator::set_sgn(int sign){
  sgn= sign; 
}//set_sgn 

/************************************************************************/

